=== modified file 'HACKING'
--- HACKING	2007-01-09 15:19:18 +0000
+++ HACKING	2007-01-24 19:42:26 +0000
@@ -593,7 +593,7 @@
 ====================
 
 If you'd like to propose a change, please post to the
-bazaar-ng@lists.canonical.com list with a patch, bzr changeset, or link to a
+bazaar@lists.canonical.com list with a patch, bzr changeset, or link to a
 branch.  Please put '[patch]' in the subject so we can pick them out, and
 include some text explaining the change.  Remember to put an update to the NEWS
 file in your diff, if it makes any changes visible to users or plugin

=== modified file 'Makefile'
--- Makefile	2006-12-14 17:46:44 +0000
+++ Makefile	2007-01-30 12:45:50 +0000
@@ -95,7 +95,7 @@
 # win32 python's distutils-based installer
 # require to have python interpreter installed on win32
 python-installer: docs
-	python setup.py bdist_wininst --install-script="bzr-win32-bdist-postinstall.py"
+	python setup.py bdist_wininst --install-script="bzr-win32-bdist-postinstall.py" -d .
 
 
 # clean on win32 all installer-related files and directories
@@ -107,4 +107,5 @@
 	python tools/win32/ostools.py remove doc/bzr_man.txt
 	python tools/win32/ostools.py remove tools/win32/bzr.iss
 	python tools/win32/ostools.py remove bzr-setup*.exe
+	python tools/win32/ostools.py remove bzr-*win32.exe
 	python tools/win32/ostools.py remove dist

=== modified file 'NEWS'
--- NEWS	2007-01-18 04:11:51 +0000
+++ NEWS	2007-02-09 18:55:25 +0000
@@ -1,15 +1,19 @@
 IN DEVELOPMENT
+
   IMPROVEMENTS:
 
+    * Support for OS Windows 98. Also .bzr.log on any windows system
+      saved in My Documents folder. (Alexander Belchenko)
+
     * ``bzr mv`` enhanced to support already moved files.
       In the past the mv command would have failed if the source file doesn't
       exist. In this situation ``bzr mv`` would now detect that the file has
       already moved and update the repository accordingly, if the target file
       does exist.
       A new option ``--after`` has been added so that if two files already
-      exist, you could notify Bazaar that you have moved a (versioned) file and
-      replaced it with another. Thus in this case ``bzr move --after`` will
-      only update the Bazaar identifier.
+      exist, you could notify Bazaar that you have moved a (versioned) file
+      and replaced it with another. Thus in this case ``bzr move --after``
+      will only update the Bazaar identifier.
       (Steffen Eichenberg, Marius Kruger)
 
     * ``ls`` now works on treeless branches and remote branches.
@@ -18,19 +22,102 @@
     * ``bzr help global-options`` describes the global options.
       (Aaron Bentley)
 
+    * ``bzr pull --overwrite`` will now correctly overwrite checkouts.
+      (Robert Collins)
+
+    * Files are now allowed to change kind (e.g. from file to symlink).
+      Supported by ``commit``, ``revert`` and ``status``
+      (Aaron Bentley)
+
+    * ``inventory`` and ``unknowns`` hidden in favour of ``ls``
+      (Aaron Bentley)
+
+    * ``bzr help checkouts`` descibes what checkouts are and some possible
+      uses of them. (James Westby, Aaron Bentley)
+
   INTERNALS:
 
     * Reserved ids (any revision-id ending in a colon) are rejected by
       versionedfiles, repositories, branches, and working trees
       (Aaron Bentley)
 
+    * Minor performance improvement by not creating a ProgressBar for
+      every KnitIndex we create. (about 90ms for a bzr.dev tree)
+      (John Arbash Meinel)
+
+    * New easier to use Branch hooks facility. There are five initial hooks,
+      all documented in bzrlib.branch.BranchHooks.__init__ - 'set_rh',
+      'post_push', 'post_pull', 'post_commit', 'post_uncommit'. These hooks
+      fire after the matching operation on a branch has taken place, and were
+      originally added for the branchrss plugin. (Robert Collins)
+
+    * New method ``Branch.push()`` which should be used when pushing from a
+      branch as it makes performance and policy decisions to match the UI
+      level command ``push``. (Robert Collins).
+
+    * New Branch.last_revision_info method, this is being done to allow
+      optimization of requests for both the number of revisions and the last
+      revision of a branch with smartservers and potentially future branch
+      formats. (Wouter van Heyst, Robert Collins)
+
+    * Allow 'import bzrlib.plugins.NAME' to work when the plugin NAME has not
+      yet been loaded by load_plugins(). This allows plugins to depend on each
+      other for code reuse without requiring users to perform file-renaming
+      gymnastics. (Robert Collins)
+
+    * New Repository method 'gather_stats' for statistic data collection.
+      This is expected to grow to cover a number of related uses mainly
+      related to bzr info. (Robert Collins)
+
+    * Log formatters are now managed with a registry.  log.register_formatter
+      continues to work, but callers accessed the FORMATTERS dictionary
+      directly will not.
+
+    * ``GPGStrategy.sign()`` will now raise ``BzrBadParameterUnicode`` if
+      you pass a Unicode string rather than an 8-bit string. Callers need
+      to be updated to encode first. (John Arbash Meinel)
+
   BUGFIXES:
 
+    * ``bzr annotate`` now uses dotted revnos from the viewpoint of the
+      branch, rather than the last changed revision of the file.
+      (John Arbash Meinel, #82158)
+
+    * Lock operations no longer hang if they encounter a permission problem.
+      (Aaron Bentley)
+
+    * ``bzr push`` can resume a push that was canceled before it finished.
+      Also, it can push even if the target directory exists if you supply
+      the ``--use-existing-dir`` flag.
+      (John Arbash Meinel, #30576, #45504)
+
+    * Fix http proxy authentication when user and an optional
+      password appears in the *_proxy vars. (Vincent Ladeuil,
+      #83954).
+
   TESTING:
 
     * New ``--first`` option to ``bzr selftest`` to run specified tests
       before the rest of the suite.  (Martin Pool)
 
+
+bzr 0.14  2007-01-23
+
+  IMPROVEMENTS:
+
+    * ``bzr help global-options`` describes the global options. (Aaron Bentley)
+
+  BUG FIXES:
+    
+    * Skip documentation generation tests if the tools to do so are not
+      available. Fixes running selftest for installled copies of bzr. 
+      (John Arbash Meinel, #80330)
+
+    * Fix the code that discovers whether bzr is being run from it's
+      working tree to handle the case when it isn't but the directory
+      it is in is below a repository. (James Westby, #77306)
+
+
 bzr 0.14rc1  2007-01-16
 
   IMPROVEMENTS:

=== modified file 'bzr'
--- bzr	2007-01-16 15:56:53 +0000
+++ bzr	2007-01-24 20:40:20 +0000
@@ -73,6 +73,14 @@
 import bzrlib.lazy_regex
 bzrlib.lazy_regex.install_lazy_compile()
 
+import bzrlib.decorators
+if ('--lsprof' in sys.argv
+    or '--lsprof-file' in sys.argv
+    or '--profile' in sys.argv):
+    bzrlib.decorators.use_pretty_decorators()
+else:
+    bzrlib.decorators.use_fast_decorators()
+
 import bzrlib.commands
 import bzrlib.trace
 

=== modified file 'bzrlib/__init__.py'
--- bzrlib/__init__.py	2007-01-16 15:56:53 +0000
+++ bzrlib/__init__.py	2007-02-02 16:17:55 +0000
@@ -54,6 +54,11 @@
                     'Consider using bzrlib.ignores.add_unique_user_ignores'
                     ' or bzrlib.ignores.add_runtime_ignores')
 
+# allow bzrlib plugins to be imported.
+import bzrlib.plugin
+bzrlib.plugin.set_plugins_path()
+
+
 def test_suite():
     import tests
     return tests.test_suite()

=== modified file 'bzrlib/annotate.py'
--- bzrlib/annotate.py	2006-12-17 18:57:05 +0000
+++ bzrlib/annotate.py	2007-02-02 09:17:23 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2004, 2005 Canonical Ltd
+# Copyright (C) 2004, 2005, 2006, 2007 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -83,18 +83,17 @@
         prevanno=anno
 
 
-def _annotate_file(branch, rev_id, file_id ):
+def _annotate_file(branch, rev_id, file_id):
     """Yield the origins for each line of a file.
 
     This includes detailed information, such as the committer name, and
     date string for the commit, rather than just the revision id.
     """
-
-    rh = branch.revision_history()
-    revision_graph = branch.repository.get_revision_graph(rev_id)
+    branch_last_revision = branch.last_revision()
+    revision_graph = branch.repository.get_revision_graph(branch_last_revision)
     merge_sorted_revisions = tsort.merge_sort(
         revision_graph,
-        rev_id,
+        branch_last_revision,
         None,
         generate_revno=True)
     revision_id_to_revno = dict((rev_id, revno)

=== modified file 'bzrlib/branch.py'
--- bzrlib/branch.py	2007-02-06 06:27:24 +0000
+++ bzrlib/branch.py	2007-02-13 05:22:39 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005, 2006 Canonical Ltd
+# Copyright (C) 2005, 2006, 2007 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -81,6 +81,8 @@
 
     base
         Base directory/url of the branch.
+
+    hooks: An instance of BranchHooks.
     """
     # this is really an instance variable - FIXME move it there
     # - RBC 20060112
@@ -223,12 +225,7 @@
         try:
             if last_revision is None:
                 pb.update('get source history')
-                from_history = from_branch.revision_history()
-                if from_history:
-                    last_revision = from_history[-1]
-                else:
-                    # no history in the source branch
-                    last_revision = _mod_revision.NULL_REVISION
+                last_revision = from_branch.last_revision_info()[1]
             return self.repository.fetch(from_branch.repository,
                                          revision_id=last_revision,
                                          pb=nested_pb)
@@ -262,7 +259,7 @@
         if config is None:
             config = self.get_config()
         
-        return self.repository.get_commit_builder(self, parents, config, 
+        return self.repository.get_commit_builder(self, parents, config,
             timestamp, timezone, committer, revprops, revision_id)
 
     def get_master_branch(self):
@@ -322,6 +319,18 @@
         else:
             return None
 
+    def last_revision_info(self):
+        """Return information about the last revision.
+
+        :return: A tuple (revno, last_revision_id).
+        """
+        rh = self.revision_history()
+        revno = len(rh)
+        if revno:
+            return (revno, rh[-1])
+        else:
+            return (0, _mod_revision.NULL_REVISION)
+
     def missing_revisions(self, other, stop_revision=None):
         """Return a list of new revisions that would perfectly fit.
         
@@ -375,8 +384,19 @@
         return history[revno - 1]
 
     def pull(self, source, overwrite=False, stop_revision=None):
+        """Mirror source into this branch.
+
+        This branch is considered to be 'local', having low latency.
+        """
         raise NotImplementedError(self.pull)
 
+    def push(self, target, overwrite=False, stop_revision=None):
+        """Mirror this branch into target.
+
+        This branch is considered to be 'local', having low latency.
+        """
+        raise NotImplementedError(self.push)
+
     def basis_tree(self):
         """Return `Tree` object for last revision."""
         return self.repository.revision_tree(self.last_revision())
@@ -599,7 +619,7 @@
             format = self.repository.bzrdir.cloning_metadir()
         return format
 
-    def create_checkout(self, to_location, revision_id=None, 
+    def create_checkout(self, to_location, revision_id=None,
                         lightweight=False):
         """Create a checkout of a branch.
         
@@ -676,7 +696,7 @@
 
     def get_format_description(self):
         """Return the short format description for this format."""
-        raise NotImplementedError(self.get_format_string)
+        raise NotImplementedError(self.get_format_description)
 
     def initialize(self, a_bzrdir):
         """Create a branch of this format in a_bzrdir."""
@@ -716,6 +736,73 @@
         return self.get_format_string().rstrip()
 
 
+class BranchHooks(dict):
+    """A dictionary mapping hook name to a list of callables for branch hooks.
+    
+    e.g. ['set_rh'] Is the list of items to be called when the
+    set_revision_history function is invoked.
+    """
+
+    def __init__(self):
+        """Create the default hooks.
+
+        These are all empty initially, because by default nothing should get
+        notified.
+        """
+        dict.__init__(self)
+        # Introduced in 0.15:
+        # invoked whenever the revision history has been set
+        # with set_revision_history. The api signature is
+        # (branch, revision_history), and the branch will
+        # be write-locked.
+        self['set_rh'] = []
+        # invoked after a push operation completes.
+        # the api signature is
+        # (source, local, master, old_revno, old_revid, new_revno, new_revid)
+        # where local is the local branch or None, master is the target 
+        # master branch, and the rest should be self explanatory. The source
+        # is read locked and the target branches write locked. Source will
+        # be the local low-latency branch.
+        self['post_push'] = []
+        # invoked after a pull operation completes.
+        # the api signature is
+        # (source, local, master, old_revno, old_revid, new_revno, new_revid)
+        # where local is the local branch or None, master is the target 
+        # master branch, and the rest should be self explanatory. The source
+        # is read locked and the target branches write locked. The local
+        # branch is the low-latency branch.
+        self['post_pull'] = []
+        # invoked after a commit operation completes.
+        # the api signature is 
+        # (local, master, old_revno, old_revid, new_revno, new_revid)
+        # old_revid is NULL_REVISION for the first commit to a branch.
+        self['post_commit'] = []
+        # invoked after a uncommit operation completes.
+        # the api signature is
+        # (local, master, old_revno, old_revid, new_revno, new_revid) where
+        # local is the local branch or None, master is the target branch,
+        # and an empty branch recieves new_revno of 0, new_revid of None.
+        self['post_uncommit'] = []
+
+    def install_hook(self, hook_name, a_callable):
+        """Install a_callable in to the hook hook_name.
+
+        :param hook_name: A hook name. See the __init__ method of BranchHooks
+            for the complete list of hooks.
+        :param a_callable: The callable to be invoked when the hook triggers.
+            The exact signature will depend on the hook - see the __init__ 
+            method of BranchHooks for details on each hook.
+        """
+        try:
+            self[hook_name].append(a_callable)
+        except KeyError:
+            raise errors.UnknownHook('branch', hook_name)
+
+
+# install the default hooks into the Branch class.
+Branch.hooks = BranchHooks()
+
+
 class BzrBranchFormat4(BranchFormat):
     """Bzr branch format 4.
 
@@ -1101,6 +1188,8 @@
             # this call is disabled because revision_history is 
             # not really an object yet, and the transaction is for objects.
             # transaction.register_clean(history)
+        for hook in Branch.hooks['set_rh']:
+            hook(self, rev_history)
 
     @needs_read_lock
     def revision_history(self):
@@ -1188,11 +1277,18 @@
         return self.bzrdir.open_workingtree()
 
     @needs_write_lock
-    def pull(self, source, overwrite=False, stop_revision=None):
-        """See Branch.pull."""
+    def pull(self, source, overwrite=False, stop_revision=None,
+        _hook_master=None, _run_hooks=True):
+        """See Branch.pull.
+
+        :param _hook_master: Private parameter - set the branch to 
+            be supplied as the master to push hooks.
+        :param _run_hooks: Private parameter - allow disabling of
+            hooks, used when pushing to a master branch.
+        """
         source.lock_read()
         try:
-            old_count = len(self.revision_history())
+            old_count, old_tip = self.last_revision_info()
             try:
                 self.update_revisions(source, stop_revision)
             except DivergedBranches:
@@ -1200,11 +1296,54 @@
                     raise
             if overwrite:
                 self.set_revision_history(source.revision_history())
-            new_count = len(self.revision_history())
+            new_count, new_tip = self.last_revision_info()
+            if _run_hooks:
+                if _hook_master:
+                    _hook_local = self
+                else:
+                    _hook_master = self
+                    _hook_local = None
+                for hook in Branch.hooks['post_pull']:
+                    hook(source, _hook_local, _hook_master, old_count, old_tip,
+                        new_count, new_tip)
             return new_count - old_count
         finally:
             source.unlock()
 
+    @needs_read_lock
+    def push(self, target, overwrite=False, stop_revision=None,
+        _hook_master=None, _run_hooks=True):
+        """See Branch.push.
+        
+        :param _hook_master: Private parameter - set the branch to 
+            be supplied as the master to push hooks.
+        :param _run_hooks: Private parameter - allow disabling of
+            hooks, used when pushing to a master branch.
+        """
+        target.lock_write()
+        try:
+            old_count, old_tip = target.last_revision_info()
+            try:
+                target.update_revisions(self, stop_revision)
+            except DivergedBranches:
+                if not overwrite:
+                    raise
+            if overwrite:
+                target.set_revision_history(self.revision_history())
+            new_count, new_tip = target.last_revision_info()
+            if _run_hooks:
+                if _hook_master:
+                    _hook_local = target
+                else:
+                    _hook_master = target
+                    _hook_local = None
+                for hook in Branch.hooks['post_push']:
+                    hook(self, _hook_local, _hook_master, old_count, old_tip,
+                        new_count, new_tip)
+            return new_count - old_count
+        finally:
+            target.unlock()
+
     def get_parent(self):
         """See Branch.get_parent."""
 
@@ -1282,16 +1421,53 @@
                                          _repository=_repository)
         
     @needs_write_lock
-    def pull(self, source, overwrite=False, stop_revision=None):
-        """Updates branch.pull to be bound branch aware."""
+    def pull(self, source, overwrite=False, stop_revision=None,
+        _run_hooks=True):
+        """Extends branch.pull to be bound branch aware.
+        
+        :param _run_hooks: Private parameter used to force hook running
+            off during bound branch double-pushing.
+        """
         bound_location = self.get_bound_location()
-        if source.base != bound_location:
+        master_branch = None
+        if bound_location and source.base != bound_location:
             # not pulling from master, so we need to update master.
             master_branch = self.get_master_branch()
-            if master_branch:
-                master_branch.pull(source)
-                source = master_branch
-        return super(BzrBranch5, self).pull(source, overwrite, stop_revision)
+            master_branch.lock_write()
+        try:
+            if master_branch:
+                # pull from source into master.
+                master_branch.pull(source, overwrite, stop_revision,
+                    _run_hooks=False)
+            return super(BzrBranch5, self).pull(source, overwrite,
+                stop_revision, _hook_master=master_branch,
+                _run_hooks=_run_hooks)
+        finally:
+            if master_branch:
+                master_branch.unlock()
+
+    @needs_write_lock
+    def push(self, target, overwrite=False, stop_revision=None):
+        """Updates branch.push to be bound branch aware."""
+        bound_location = target.get_bound_location()
+        master_branch = None
+        if bound_location and target.base != bound_location:
+            # not pushing to master, so we need to update master.
+            master_branch = target.get_master_branch()
+            master_branch.lock_write()
+        try:
+            if master_branch:
+                # push into the master from this branch.
+                super(BzrBranch5, self).push(master_branch, overwrite,
+                    stop_revision, _run_hooks=False)
+            # and push into the target branch from this. Note that we push from
+            # this branch again, because its considered the highest bandwidth
+            # repository.
+            return super(BzrBranch5, self).push(target, overwrite,
+                stop_revision, _hook_master=master_branch)
+        finally:
+            if master_branch:
+                master_branch.unlock()
 
     def get_bound_location(self):
         try:

=== modified file 'bzrlib/builtins.py'
--- bzrlib/builtins.py	2007-02-06 06:27:24 +0000
+++ bzrlib/builtins.py	2007-02-13 05:22:39 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2004, 2005, 2006 Canonical Ltd
+# Copyright (C) 2004, 2005, 2006, 2007 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -30,6 +30,7 @@
     branch,
     bundle,
     bzrdir,
+    delta,
     config,
     errors,
     ignores,
@@ -37,6 +38,7 @@
     merge as _mod_merge,
     osutils,
     repository,
+    symbol_versioning,
     transport,
     tree as _mod_tree,
     ui,
@@ -93,6 +95,7 @@
     return tree, new_list
 
 
+@symbol_versioning.deprecated_function(symbol_versioning.zero_fifteen)
 def get_format_type(typestring):
     """Parse and return a format specifier."""
     # Have to use BzrDirMetaFormat1 directly, so that
@@ -118,29 +121,49 @@
     This reports on versioned and unknown files, reporting them
     grouped by state.  Possible states are:
 
-    added / A
+    added
         Versioned in the working copy but not in the previous revision.
 
-    removed / D
+    removed
         Versioned in the previous revision but removed or deleted
         in the working copy.
 
-    renamed / R
+    renamed
         Path of this file changed from the previous revision;
         the text may also have changed.  This includes files whose
         parent directory was renamed.
 
-    modified / M
+    modified
         Text has changed since the previous revision.
 
-    unknown / ?
+    kind changed
+        File kind has been changed (e.g. from file to directory).
+
+    unknown
         Not versioned and not matching an ignore pattern.
 
     To see ignored files use 'bzr ignored'.  For details in the
     changes to file texts, use 'bzr diff'.
     
-    --short gives a one character status flag for each item, similar
-    to the SVN's status command.
+    --short gives a status flags for each item, similar to the SVN's status
+    command.
+
+    Column 1: versioning / renames
+      + File versioned
+      - File unversioned
+      R File renamed
+      ? File unknown
+      C File has conflicts
+      P Entry for a pending merge (not a file)
+
+    Column 2: Contents
+      N File created
+      D File deleted
+      K File kind changed
+      M File modified
+
+    Column 3: Execute
+      * The execute bit was changed
 
     If no arguments are specified, the status of the entire working
     directory is shown.  Otherwise, only the status of the specified
@@ -393,9 +416,14 @@
 
     It is also possible to restrict the list of files to a specific
     set. For example: bzr inventory --show-ids this/file
+
+    See also: bzr ls
     """
 
+    hidden = True
+
     takes_options = ['revision', 'show-ids', 'kind']
+
     takes_args = ['file*']
 
     @display_command
@@ -602,14 +630,20 @@
     """
 
     takes_options = ['remember', 'overwrite', 'verbose',
-                     Option('create-prefix', 
+                     Option('create-prefix',
                             help='Create the path leading up to the branch '
-                                 'if it does not already exist')]
+                                 'if it does not already exist'),
+                     Option('use-existing-dir',
+                            help='By default push will fail if the target'
+                                 ' directory exists, but does not already'
+                                 ' have a control directory. This flag will'
+                                 ' allow push to proceed.'),
+                     ]
     takes_args = ['location?']
     encoding_type = 'replace'
 
     def run(self, location=None, remember=False, overwrite=False,
-            create_prefix=False, verbose=False):
+            create_prefix=False, verbose=False, use_existing_dir=False):
         # FIXME: Way too big!  Put this into a function called from the
         # command.
         
@@ -628,43 +662,99 @@
         location_url = to_transport.base
 
         old_rh = []
+        count = 0
+
+        br_to = repository_to = dir_to = None
         try:
-            dir_to = bzrdir.BzrDir.open(location_url)
-            br_to = dir_to.open_branch()
+            dir_to = bzrdir.BzrDir.open_from_transport(to_transport)
         except errors.NotBranchError:
-            # create a branch.
-            to_transport = to_transport.clone('..')
-            if not create_prefix:
+            pass # Didn't find anything
+        else:
+            # If we can open a branch, use its direct repository, otherwise see
+            # if there is a repository without a branch.
+            try:
+                br_to = dir_to.open_branch()
+            except errors.NotBranchError:
+                # Didn't find a branch, can we find a repository?
                 try:
-                    relurl = to_transport.relpath(location_url)
-                    mutter('creating directory %s => %s', location_url, relurl)
-                    to_transport.mkdir(relurl)
-                except errors.NoSuchFile:
-                    raise errors.BzrCommandError("Parent directory of %s "
-                                                 "does not exist." % location)
+                    repository_to = dir_to.find_repository()
+                except errors.NoRepositoryPresent:
+                    pass
             else:
-                current = to_transport.base
-                needed = [(to_transport, to_transport.relpath(location_url))]
+                # Found a branch, so we must have found a repository
+                repository_to = br_to.repository
+
+        old_rh = []
+        if dir_to is None:
+            # XXX: Refactor the create_prefix/no_create_prefix code into a
+            #      common helper function
+            try:
+                to_transport.mkdir('.')
+            except errors.FileExists:
+                if not use_existing_dir:
+                    raise errors.BzrCommandError("Target directory %s"
+                         " already exists, but does not have a valid .bzr"
+                         " directory. Supply --use-existing-dir to push"
+                         " there anyway." % location)
+            except errors.NoSuchFile:
+                if not create_prefix:
+                    raise errors.BzrCommandError("Parent directory of %s"
+                        " does not exist."
+                        "\nYou may supply --create-prefix to create all"
+                        " leading parent directories."
+                        % location)
+
+                cur_transport = to_transport
+                needed = [cur_transport]
+                # Recurse upwards until we can create a directory successfully
+                while True:
+                    new_transport = cur_transport.clone('..')
+                    if new_transport.base == cur_transport.base:
+                        raise errors.BzrCommandError("Failed to create path"
+                                                     " prefix for %s."
+                                                     % location)
+                    try:
+                        new_transport.mkdir('.')
+                    except errors.NoSuchFile:
+                        needed.append(new_transport)
+                        cur_transport = new_transport
+                    else:
+                        break
+
+                # Now we only need to create child directories
                 while needed:
-                    try:
-                        to_transport, relpath = needed[-1]
-                        to_transport.mkdir(relpath)
-                        needed.pop()
-                    except errors.NoSuchFile:
-                        new_transport = to_transport.clone('..')
-                        needed.append((new_transport,
-                                       new_transport.relpath(to_transport.base)))
-                        if new_transport.base == to_transport.base:
-                            raise errors.BzrCommandError("Could not create "
-                                                         "path prefix.")
+                    cur_transport = needed.pop()
+                    cur_transport.mkdir('.')
+            
+            # Now the target directory exists, but doesn't have a .bzr
+            # directory. So we need to create it, along with any work to create
+            # all of the dependent branches, etc.
             dir_to = br_from.bzrdir.clone(location_url,
                 revision_id=br_from.last_revision())
             br_to = dir_to.open_branch()
+            count = br_to.last_revision_info()[0]
+            # We successfully created the target, remember it
+            if br_from.get_push_location() is None or remember:
+                br_from.set_push_location(br_to.base)
+        elif repository_to is None:
+            # we have a bzrdir but no branch or repository
+            # XXX: Figure out what to do other than complain.
+            raise errors.BzrCommandError("At %s you have a valid .bzr control"
+                " directory, but not a branch or repository. This is an"
+                " unsupported configuration. Please move the target directory"
+                " out of the way and try again."
+                % location)
+        elif br_to is None:
+            # We have a repository but no branch, copy the revisions, and then
+            # create a branch.
+            last_revision_id = br_from.last_revision()
+            repository_to.fetch(br_from.repository,
+                                revision_id=last_revision_id)
+            br_to = br_from.clone(dir_to, revision_id=last_revision_id)
             count = len(br_to.revision_history())
-            # We successfully created the target, remember it
             if br_from.get_push_location() is None or remember:
                 br_from.set_push_location(br_to.base)
-        else:
+        else: # We have a valid to branch
             # We were able to connect to the remote location, so remember it
             # we don't need to successfully push because of possible divergence.
             if br_from.get_push_location() is None or remember:
@@ -676,11 +766,16 @@
                 except errors.NotLocalUrl:
                     warning('This transport does not update the working '
                             'tree of: %s' % (br_to.base,))
-                    count = br_to.pull(br_from, overwrite)
+                    count = br_from.push(br_to, overwrite)
                 except errors.NoWorkingTree:
-                    count = br_to.pull(br_from, overwrite)
+                    count = br_from.push(br_to, overwrite)
                 else:
-                    count = tree_to.pull(br_from, overwrite)
+                    tree_to.lock_write()
+                    try:
+                        count = br_from.push(tree_to.branch, overwrite)
+                        tree_to.update()
+                    finally:
+                        tree_to.unlock()
             except errors.DivergedBranches:
                 raise errors.BzrCommandError('These branches have diverged.'
                                         '  Try using "merge" and then "push".')
@@ -793,6 +888,8 @@
     --basis is to speed up checking out from remote branches.  When specified, it
     uses the inventory and file contents from the basis branch in preference to the
     branch being checked out.
+
+    See "help checkouts" for more information on checkouts.
     """
     takes_args = ['branch_location?', 'to_location?']
     takes_options = ['revision', # , 'basis']
@@ -1093,12 +1190,14 @@
                 help='Specify a format for this branch. '
                 'See "help formats".',
                 registry=bzrdir.format_registry,
-                converter=get_format_type,
-                value_switches=True),
+                converter=bzrdir.format_registry.make_bzrdir,
+                value_switches=True,
+                title="Branch Format",
+                ),
          ]
     def run(self, location=None, format=None):
         if format is None:
-            format = get_format_type('default')
+            format = bzrdir.format_registry.make_bzrdir('default')
         if location is None:
             location = u'.'
 
@@ -1148,18 +1247,18 @@
     """
     takes_args = ["location"]
     takes_options = [RegistryOption('format',
-                            help='Specify a format for this repository.'
-                                'See "help formats".',
+                            help='Specify a format for this repository. See'
+                                 ' "bzr help formats" for details',
                             registry=bzrdir.format_registry,
-                            converter=get_format_type,
-                            value_switches=True),
+                            converter=bzrdir.format_registry.make_bzrdir,
+                            value_switches=True, title='Repository format'),
                      Option('trees',
                              help='Allows branches in repository to have'
                              ' a working tree')]
     aliases = ["init-repo"]
     def run(self, location, format=None, trees=False):
         if format is None:
-            format = get_format_type('default')
+            format = bzrdir.format_registry.make_bzrdir('default')
 
         if location is None:
             location = '.'
@@ -1309,8 +1408,13 @@
 
 
 class cmd_modified(Command):
-    """List files modified in working tree."""
+    """List files modified in working tree.
+
+    See also: "bzr status".
+    """
+
     hidden = True
+
     @display_command
     def run(self):
         tree = WorkingTree.open_containing(u'.')[0]
@@ -1320,8 +1424,13 @@
 
 
 class cmd_added(Command):
-    """List files added in working tree."""
+    """List files added in working tree.
+
+    See also: "bzr status".
+    """
+
     hidden = True
+
     @display_command
     def run(self):
         wt = WorkingTree.open_containing(u'.')[0]
@@ -1377,12 +1486,10 @@
                              help='show files changed in each revision'),
                      'show-ids', 'revision',
                      'log-format',
-                     'line', 'long', 
                      Option('message',
                             short_name='m',
                             help='show revisions whose message matches this regexp',
                             type=str),
-                     'short',
                      ]
     encoding_type = 'replace'
 
@@ -1393,11 +1500,8 @@
             forward=False,
             revision=None,
             log_format=None,
-            message=None,
-            long=False,
-            short=False,
-            line=False):
-        from bzrlib.log import log_formatter, show_log
+            message=None):
+        from bzrlib.log import show_log
         assert message is None or isinstance(message, basestring), \
             "invalid message argument %r" % message
         direction = (forward and 'forward') or 'reverse'
@@ -1464,14 +1568,11 @@
         if rev1 > rev2:
             (rev2, rev1) = (rev1, rev2)
 
-        if (log_format is None):
-            default = b.get_config().log_format()
-            log_format = get_log_format(long=long, short=short, line=line, 
-                                        default=default)
-        lf = log_formatter(log_format,
-                           show_ids=show_ids,
-                           to_file=self.outf,
-                           show_timezone=timezone)
+        if log_format is None:
+            log_format = log.log_formatter_registry.get_default(b)
+
+        lf = log_format(show_ids=show_ids, to_file=self.outf,
+                        show_timezone=timezone)
 
         show_log(b,
                  lf,
@@ -1601,7 +1702,13 @@
 
 
 class cmd_unknowns(Command):
-    """List unknown files."""
+    """List unknown files.
+
+    See also: "bzr ls --unknown".
+    """
+
+    hidden = True
+
     @display_command
     def run(self):
         for f in WorkingTree.open_containing(u'.')[0].unknowns():
@@ -1978,18 +2085,18 @@
     takes_args = ['url?']
     takes_options = [
                     RegistryOption('format',
-                        help='Upgrade to a specific format. '
-                        'See "help formats"',
+                        help='Upgrade to a specific format.  See "bzr help'
+                             ' formats" for details',
                         registry=bzrdir.format_registry,
-                        converter=get_format_type,
-                        value_switches=True),
+                        converter=bzrdir.format_registry.make_bzrdir,
+                        value_switches=True, title='Branch format'),
                     ]
 
 
     def run(self, url='.', format=None):
         from bzrlib.upgrade import upgrade
         if format is None:
-            format = get_format_type('default')
+            format = bzrdir.format_registry.make_bzrdir('default')
         upgrade(url, format)
 
 
@@ -2217,9 +2324,6 @@
         branch1 = Branch.open_containing(branch)[0]
         branch2 = Branch.open_containing(other)[0]
 
-        history_1 = branch1.revision_history()
-        history_2 = branch2.revision_history()
-
         last1 = branch1.last_revision()
         last2 = branch2.last_revision()
 
@@ -2284,10 +2388,6 @@
                              ' you do not need to commit the result.'),
                      ]
 
-    def help(self):
-        from inspect import getdoc
-        return getdoc(self) + '\n' + _mod_merge.merge_type_help()
-
     def run(self, branch=None, revision=None, force=False, merge_type=None,
             show_base=False, reprocess=False, remember=False, 
             uncommitted=False, pull=False):
@@ -2421,10 +2521,6 @@
                      Option('show-base', help="Show base revision text in "
                             "conflicts")]
 
-    def help(self):
-        from inspect import getdoc
-        return getdoc(self) + '\n' + _mod_merge.merge_type_help()
-
     def run(self, file_list=None, merge_type=None, show_base=False,
             reprocess=False):
         if merge_type is None:
@@ -2532,7 +2628,7 @@
         try:
             tree.revert(file_list, 
                         tree.branch.repository.revision_tree(rev_id),
-                        not no_backup, pb)
+                        not no_backup, pb, report_changes=True)
         finally:
             pb.finished()
 
@@ -2605,9 +2701,6 @@
                      Option('theirs-only', 
                             'Display changes in the remote branch only'), 
                      'log-format',
-                     'line',
-                     'long', 
-                     'short',
                      'show-ids',
                      'verbose'
                      ]
@@ -2625,7 +2718,10 @@
             other_branch = parent
             if other_branch is None:
                 raise errors.BzrCommandError("No peer location known or specified.")
-            print "Using last location: " + local_branch.get_parent()
+            display_url = urlutils.unescape_for_display(parent,
+                                                        self.outf.encoding)
+            print "Using last location: " + display_url
+
         remote_branch = Branch.open(other_branch)
         if remote_branch.base == local_branch.base:
             remote_branch = local_branch
@@ -2635,13 +2731,11 @@
             try:
                 local_extra, remote_extra = find_unmerged(local_branch, remote_branch)
                 if (log_format is None):
-                    default = local_branch.get_config().log_format()
-                    log_format = get_log_format(long=long, short=short, 
-                                                line=line, default=default)
-                lf = log_formatter(log_format,
-                                   to_file=self.outf,
-                                   show_ids=show_ids,
-                                   show_timezone='original')
+                    log_format = log.log_formatter_registry.get_default(
+                        local_branch)
+                lf = log_format(to_file=self.outf,
+                                show_ids=show_ids,
+                                show_timezone='original')
                 if reverse is False:
                     local_extra.reverse()
                     remote_extra.reverse()
@@ -2814,10 +2908,12 @@
 
 
 class cmd_bind(Command):
-    """Bind the current branch to a master branch.
-
-    After binding, commits must succeed on the master branch
-    before they are executed on the local one.
+    """Convert the current branch into a checkout of the supplied branch.
+
+    Once converted into a checkout, commits must succeed on the master branch
+    before they will be applied to the local branch.
+
+    See "help checkouts" for more information on checkouts.
     """
 
     takes_args = ['location']
@@ -2834,10 +2930,12 @@
 
 
 class cmd_unbind(Command):
-    """Unbind the current branch from its master branch.
-
-    After unbinding, the local branch is considered independent.
-    All subsequent commits will be local.
+    """Convert the current checkout into a regular branch.
+
+    After unbinding, the local branch is considered independent and subsequent
+    commits will be local only.
+
+    See "help checkouts" for more information on checkouts.
     """
 
     takes_args = []

=== modified file 'bzrlib/bzrdir.py'
--- bzrlib/bzrdir.py	2007-02-07 12:41:45 +0000
+++ bzrlib/bzrdir.py	2007-02-13 05:22:39 +0000
@@ -2049,9 +2049,6 @@
         self.set_default(key)
         format = self.get('default')()
         assert isinstance(format, BzrDirMetaFormat1)
-        from bzrlib import repository
-        repository.RepositoryFormat._set_default_format(
-            format.repository_format)
 
     def make_bzrdir(self, key):
         return self.get(key)()

=== modified file 'bzrlib/commit.py'
--- bzrlib/commit.py	2006-12-01 19:41:16 +0000
+++ bzrlib/commit.py	2007-02-06 23:53:30 +0000
@@ -58,8 +58,10 @@
 
 from bzrlib import (
     errors,
+    inventory,
     tree,
     )
+from bzrlib.branch import Branch
 import bzrlib.config
 from bzrlib.errors import (BzrError, PointlessCommit,
                            ConflictsInTree,
@@ -331,6 +333,8 @@
             # now the work tree is up to date with the branch
             
             self.reporter.completed(self.branch.revno(), self.rev_id)
+            # old style commit hooks - should be deprecated ? (obsoleted in
+            # 0.15)
             if self.config.post_commit() is not None:
                 hooks = self.config.post_commit().split(' ')
                 # this would be nicer with twisted.python.reflect.namedAny
@@ -339,6 +343,25 @@
                                   {'branch':self.branch,
                                    'bzrlib':bzrlib,
                                    'rev_id':self.rev_id})
+            # new style commit hooks:
+            if not self.bound_branch:
+                hook_master = self.branch
+                hook_local = None
+            else:
+                hook_master = self.master_branch
+                hook_local = self.branch
+            new_revno = self.branch.revno()
+            # With bound branches, when the master is behind the local branch,
+            # the 'old_revno' and old_revid values here are incorrect.
+            # XXX: FIXME ^. RBC 20060206
+            old_revno = new_revno - 1
+            if self.parents:
+                old_revid = self.parents[0]
+            else:
+                old_revid = bzrlib.revision.NULL_REVISION
+            for hook in Branch.hooks['post_commit']:
+                hook(hook_local, hook_master, old_revno, old_revid, new_revno,
+                    self.rev_id)
             self._emit_progress_update()
         finally:
             self._cleanup()
@@ -428,9 +451,9 @@
         #       to local.
         
         # Make sure the local branch is identical to the master
-        master_rh = self.master_branch.revision_history()
-        local_rh = self.branch.revision_history()
-        if local_rh != master_rh:
+        master_info = self.master_branch.last_revision_info()
+        local_info = self.branch.last_revision_info()
+        if local_info != master_info:
             raise errors.BoundBranchOutOfDate(self.branch,
                     self.master_branch)
 
@@ -560,6 +583,13 @@
         for path, new_ie in entries:
             self._emit_progress_update()
             file_id = new_ie.file_id
+            try:
+                kind = self.work_tree.kind(file_id)
+                if kind != new_ie.kind:
+                    new_ie = inventory.make_entry(kind, new_ie.name,
+                                                  new_ie.parent_id, file_id)
+            except errors.NoSuchFile:
+                pass
             # mutter('check %s {%s}', path, file_id)
             if (not self.specific_files or 
                 is_inside_or_parent_of_any(self.specific_files, path)):

=== modified file 'bzrlib/config.py'
--- bzrlib/config.py	2006-12-07 16:21:39 +0000
+++ bzrlib/config.py	2007-01-30 12:04:20 +0000
@@ -77,6 +77,7 @@
     osutils,
     symbol_versioning,
     urlutils,
+    win32utils,
     )
 import bzrlib.util.configobj.configobj as configobj
 """)
@@ -709,7 +710,7 @@
     base = os.environ.get('BZR_HOME', None)
     if sys.platform == 'win32':
         if base is None:
-            base = os.environ.get('APPDATA', None)
+            base = win32utils.get_appdata_location_unicode()
         if base is None:
             base = os.environ.get('HOME', None)
         if base is None:
@@ -755,7 +756,16 @@
     """
     import socket
 
-    # XXX: Any good way to get real user name on win32?
+    if sys.platform == 'win32':
+        name = win32utils.get_user_name_unicode()
+        if name is None:
+            raise errors.BzrError("Cannot autodetect user name.\n"
+                                  "Please, set your name with command like:\n"
+                                  'bzr whoami "Your Name <name@domain.com>"')
+        host = win32utils.get_host_name_unicode()
+        if host is None:
+            host = socket.gethostname()
+        return name, (name + '@' + host)
 
     try:
         import pwd

=== modified file 'bzrlib/decorators.py'
--- bzrlib/decorators.py	2006-07-28 16:05:23 +0000
+++ bzrlib/decorators.py	2007-01-25 15:54:29 +0000
@@ -17,9 +17,98 @@
 
 __all__ = ['needs_read_lock',
            'needs_write_lock',
+           'use_fast_decorators',
+           'use_pretty_decorators',
            ]
 
-def needs_read_lock(unbound):
+
+def _get_parameters(func):
+    """Recreate the parameters for a function using introspection.
+
+    :return: (function_params, calling_params)
+        function_params: is a string representing the parameters of the
+            function. (such as "a, b, c=None, d=1")
+            This is used in the function declaration.
+        calling_params: is another string representing how you would call the
+            function with the correct parameters. (such as "a, b, c=c, d=d")
+            Assuming you sued function_params in the function declaration, this
+            is the parameters to put in the function call.
+
+        For example:
+
+        def wrapper(%(function_params)s):
+            return original(%(calling_params)s)
+    """
+    # "import inspect" should stay in local scope. 'inspect' takes a long time
+    # to import the first time. And since we don't always need it, don't import
+    # it globally.
+    import inspect
+    args, varargs, varkw, defaults = inspect.getargspec(func)
+    formatted = inspect.formatargspec(args, varargs=varargs,
+                                      varkw=varkw,
+                                      defaults=defaults)
+    if defaults is None:
+        args_passed = args
+    else:
+        first_default = len(args) - len(defaults)
+        args_passed = args[:first_default]
+        for arg in args[first_default:]:
+            args_passed.append("%s=%s" % (arg, arg))
+    if varargs is not None:
+        args_passed.append('*' + varargs)
+    if varkw is not None:
+        args_passed.append('**' + varkw)
+    args_passed = ', '.join(args_passed)
+
+    return formatted[1:-1], args_passed
+
+
+def _pretty_needs_read_lock(unbound):
+    """Decorate unbound to take out and release a read lock.
+
+    This decorator can be applied to methods of any class with lock_read() and
+    unlock() methods.
+    
+    Typical usage:
+        
+    class Branch(...):
+        @needs_read_lock
+        def branch_method(self, ...):
+            stuff
+    """
+    # This compiles a function with a similar name, but wrapped with
+    # lock_read/unlock calls. We use dynamic creation, because we need the
+    # internal name of the function to be modified so that --lsprof will see
+    # the correct name.
+    # TODO: jam 20070111 Modify this template so that the generated function
+    #       has the same argument signature as the original function, which
+    #       will help commands like epydoc.
+    #       This seems possible by introspecting foo.func_defaults, and
+    #       foo.func_code.co_argcount and foo.func_code.co_varnames
+    template = """\
+def %(name)s_read_locked(%(params)s):
+    self.lock_read()
+    try:
+        return unbound(%(passed_params)s)
+    finally:
+        self.unlock()
+read_locked = %(name)s_read_locked
+"""
+    params, passed_params = _get_parameters(unbound)
+    variables = {'name':unbound.__name__,
+                 'params':params,
+                 'passed_params':passed_params,
+                }
+    func_def = template % variables
+
+    exec func_def in locals()
+
+    read_locked.__doc__ = unbound.__doc__
+    read_locked.__name__ = unbound.__name__
+    return read_locked
+
+
+def _fast_needs_read_lock(unbound):
     """Decorate unbound to take out and release a read lock.
 
     This decorator can be applied to methods of any class with lock_read() and
@@ -43,7 +132,32 @@
     return read_locked
 
 
-def needs_write_lock(unbound):
+def _pretty_needs_write_lock(unbound):
+    """Decorate unbound to take out and release a write lock."""
+    template = """\
+def %(name)s_write_locked(%(params)s):
+    self.lock_write()
+    try:
+        return unbound(%(passed_params)s)
+    finally:
+        self.unlock()
+write_locked = %(name)s_write_locked
+"""
+    params, passed_params = _get_parameters(unbound)
+    variables = {'name':unbound.__name__,
+                 'params':params,
+                 'passed_params':passed_params,
+                }
+    func_def = template % variables
+
+    exec func_def in locals()
+
+    write_locked.__doc__ = unbound.__doc__
+    write_locked.__name__ = unbound.__name__
+    return write_locked
+
+
+def _fast_needs_write_lock(unbound):
     """Decorate unbound to take out and release a write lock."""
     def write_locked(self, *args, **kwargs):
         self.lock_write()
@@ -55,3 +169,26 @@
     write_locked.__name__ = unbound.__name__
     return write_locked
 
+
+# Default is more functionality, 'bzr' the commandline will request fast
+# versions.
+needs_read_lock = _pretty_needs_read_lock
+needs_write_lock = _pretty_needs_write_lock
+
+
+def use_fast_decorators():
+    """Change the default decorators to be fast loading ones.
+
+    The alternative is to have decorators that do more work to produce
+    nice-looking decorated functions, but this slows startup time.
+    """
+    global needs_read_lock, needs_write_lock
+    needs_read_lock = _fast_needs_read_lock
+    needs_write_lock = _fast_needs_write_lock
+
+
+def use_pretty_decorators():
+    """Change the default decorators to be pretty ones."""
+    global needs_read_lock, needs_write_lock
+    needs_read_lock = _pretty_needs_read_lock
+    needs_write_lock = _pretty_needs_write_lock

=== modified file 'bzrlib/delta.py'
--- bzrlib/delta.py	2006-12-07 17:15:28 +0000
+++ bzrlib/delta.py	2007-02-06 17:12:12 +0000
@@ -14,7 +14,10 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
-from bzrlib import errors
+from bzrlib import (
+    errors,
+    osutils,
+    )
 from bzrlib.inventory import InventoryEntry
 from bzrlib.trace import mutter
 from bzrlib.symbol_versioning import deprecated_function, zero_nine
@@ -53,6 +56,7 @@
         self.added = []
         self.removed = []
         self.renamed = []
+        self.kind_changed = []
         self.modified = []
         self.unchanged = []
 
@@ -63,21 +67,24 @@
                and self.removed == other.removed \
                and self.renamed == other.renamed \
                and self.modified == other.modified \
-               and self.unchanged == other.unchanged
+               and self.unchanged == other.unchanged \
+               and self.kind_changed == other.kind_changed
 
     def __ne__(self, other):
         return not (self == other)
 
     def __repr__(self):
-        return "TreeDelta(added=%r, removed=%r, renamed=%r, modified=%r," \
-            " unchanged=%r)" % (self.added, self.removed, self.renamed,
-            self.modified, self.unchanged)
+        return "TreeDelta(added=%r, removed=%r, renamed=%r," \
+            " kind_changed=%r, modified=%r, unchanged=%r)" % (self.added,
+            self.removed, self.renamed, self.kind_changed, self.modified,
+            self.unchanged)
 
     def has_changed(self):
         return bool(self.modified
                     or self.added
                     or self.removed
-                    or self.renamed)
+                    or self.renamed
+                    or self.kind_changed)
 
     def touches_file_id(self, file_id):
         """Return True if file_id is modified by this delta."""
@@ -88,10 +95,14 @@
         for v in self.renamed:
             if v[2] == file_id:
                 return True
+        for v in self.kind_changed:
+            if v[1] == file_id:
+                return True
         return False
             
 
-    def show(self, to_file, show_ids=False, show_unchanged=False, short_status=False):
+    def show(self, to_file, show_ids=False, show_unchanged=False,
+             short_status=False):
         """output this delta in status-like form to to_file."""
         def show_list(files, short_status_letter=''):
             for item in files:
@@ -106,7 +117,8 @@
                     path += '*'
 
                 if show_ids:
-                    print >>to_file, '%s  %-30s %s' % (short_status_letter, path, fid)
+                    print >>to_file, '%s  %-30s %s' % (short_status_letter,
+                        path, fid)
                 else:
                     print >>to_file, '%s  %s' % (short_status_letter, path)
             
@@ -139,12 +151,26 @@
                 if meta_modified:
                     newpath += '*'
                 if show_ids:
-                    print >>to_file, '%s  %s => %s %s' % (short_status_letter,
-                                                          oldpath, newpath, fid)
-                else:
-                    print >>to_file, '%s  %s => %s' % (short_status_letter,
-                                                       oldpath, newpath)
-                    
+                    print >>to_file, '%s  %s => %s %s' % (
+                        short_status_letter, oldpath, newpath, fid)
+                else:
+                    print >>to_file, '%s  %s => %s' % (
+                        short_status_letter, oldpath, newpath)
+
+        if self.kind_changed:
+            if short_status:
+                short_status_letter = 'K'
+            else:
+                print >>to_file, 'kind changed:'
+                short_status_letter = ''
+            for (path, fid, old_kind, new_kind) in self.kind_changed:
+                if show_ids:
+                    suffix = ' '+fid
+                else:
+                    suffix = ''
+                print >>to_file, '%s  %s (%s => %s)%s' % (
+                    short_status_letter, path, old_kind, new_kind, suffix)
+
         if self.modified or extra_modified:
             short_status_letter = 'M'
             if not short_status:
@@ -184,8 +210,6 @@
                                                specific_file_ids):
         if not include_root and (None, None) == parent_id:
             continue
-        assert kind[0] == kind[1] or None in kind
-        # the only 'kind change' permitted is creation/deletion
         fully_present = tuple((versioned[x] and kind[x] is not None) for
                               x in range(2))
         if fully_present[0] != fully_present[1]:
@@ -208,6 +232,8 @@
                                   kind[1],
                                   content_change, 
                                   (executable[0] != executable[1])))
+        elif kind[0] != kind[1]:
+            delta.kind_changed.append((path, file_id, kind[0], kind[1]))
         elif content_change is True or executable[0] != executable[1]:
             delta.modified.append((path, file_id, kind[1],
                                    content_change, 
@@ -224,3 +250,125 @@
     delta.unchanged.sort()
 
     return delta
+
+
+class ChangeReporter(object):
+    """Report changes between two trees"""
+
+    def __init__(self, old_inventory, output=None, suppress_root_add=True,
+                 output_file=None):
+        """Constructor
+
+        :param old_inventory: The inventory of the old tree
+        :param output: a function with the signature of trace.note, i.e.
+            accepts a format and parameters.
+        :param supress_root_add: If true, adding the root will be ignored
+            (i.e. when a tree has just been initted)
+        :param output_file: If supplied, a file-like object to write to.
+            Only one of output and output_file may be supplied.
+        """
+        self.old_inventory = old_inventory
+        if output_file is not None:
+            if output is not None:
+                raise BzrError('Cannot specify both output and output_file')
+            def output(fmt, *args):
+                output_file.write((fmt % args) + '\n')
+        self.output = output
+        if self.output is None:
+            from bzrlib import trace
+            self.output = trace.note
+        self.suppress_root_add = suppress_root_add
+
+    def report(self, file_id, path, versioned, renamed, modified, exe_change,
+               kind):
+        """Report one change to a file
+
+        :param file_id: The file_id of the file
+        :param path: The path the file has (or would have) in the tree (as
+            generated by Tree._iter_changes)
+        :param versioned: may be 'added', 'removed', or 'unchanged'
+        :param renamed: may be True or False
+        :param modified: may be 'created', 'deleted', 'kind changed',
+            'modified' or 'unchanged'.
+        :param exe_change: True if the execute bit has changed
+        :param kind: A pair of file kinds, as generated by Tree._iter_changes.
+            None indicates no file present.
+        """
+        if path == '' and versioned == 'added' and self.suppress_root_add:
+            return
+        modified_map = {'kind changed': 'K',
+                        'unchanged': ' ',
+                        'created': 'N',
+                        'modified': 'M',
+                        'deleted': 'D'}
+        versioned_map = {'added': '+',
+                         'unchanged': ' ',
+                         'removed': '-'}
+        old_path = ""
+        if renamed:
+            old_path = self.old_inventory.id2path(file_id)
+            rename = "R"
+        else:
+            rename = versioned_map[versioned]
+        if modified == 'kind changed':
+            if old_path == "":
+                old_path = path
+        if modified == 'deleted':
+            path += osutils.kind_marker(kind[0])
+        elif kind[1] is not None:
+            path += osutils.kind_marker(kind[1])
+        if old_path != "":
+            if kind[0] is not None:
+                old_path += osutils.kind_marker(kind[0])
+            old_path += " => "
+        if exe_change:
+            exe = '*'
+        else:
+            exe = ' '
+        self.output("%s%s%s %s%s", rename, modified_map[modified], exe,
+                    old_path, path)
+
+
+def report_changes(change_iterator, reporter):
+    """Report the changes from a change iterator.
+
+    This is essentially a translation from low-level to medium-level changes.
+    Further processing may be required to produce a human-readable output.
+    Unfortunately, some tree-changing operations are very complex
+    :change_iterator: an iterator or sequence of changes in the format
+        generated by Tree._iter_changes
+    :param reporter: The ChangeReporter that will report the changes.
+    """
+    for (file_id, path, content_change, versioned, parent_id, name, kind,
+         executable) in change_iterator:
+        exe_change = False
+        # files are "renamed" if they are moved or if name changes, as long
+        # as it had a value
+        if None not in name and (name[0] != name[1] or
+                                 parent_id[0] != parent_id[1]):
+            renamed = True
+        else:
+            renamed = False
+        if kind[0] != kind[1]:
+            if kind[0] is None:
+                modified = "created"
+            elif kind[1] is None:
+                modified = "deleted"
+            else:
+                modified = "kind changed"
+        else:
+            if content_change:
+                modified = "modified"
+            else:
+                modified = "unchanged"
+            if kind[1] == "file":
+                exe_change = (executable[0] != executable[1])
+        if versioned[0] != versioned[1]:
+            if versioned[0]:
+                versioned_change = "removed"
+            else:
+                versioned_change = "added"
+        else:
+            versioned_change = "unchanged"
+        reporter.report(file_id, path, versioned_change, renamed, modified,
+                        exe_change, kind)

=== modified file 'bzrlib/errors.py'
--- bzrlib/errors.py	2007-01-19 19:23:53 +0000
+++ bzrlib/errors.py	2007-02-03 10:02:11 +0000
@@ -405,6 +405,16 @@
         self.args = [base] + list(args)
 
 
+class UnknownHook(BzrError):
+
+    _fmt = "The %(type)s hook '%(hook)s' is unknown in this version of bzrlib."
+
+    def __init__(self, hook_type, hook_name):
+        BzrError.__init__(self)
+        self.type = hook_type
+        self.hook = hook_name
+
+
 class UnsupportedProtocol(PathError):
 
     _fmt = 'Unsupported protocol for url "%(path)s"%(extra)s'
@@ -1667,6 +1677,7 @@
 class NoSmartMedium(BzrError):
 
     _fmt = "The transport '%(transport)s' cannot tunnel the smart protocol."
+    internal_error = True
 
     def __init__(self, transport):
         self.transport = transport

=== modified file 'bzrlib/gpg.py'
--- bzrlib/gpg.py	2006-10-16 01:25:46 +0000
+++ bzrlib/gpg.py	2007-02-08 16:28:05 +0000
@@ -76,6 +76,8 @@
         self._config = config
 
     def sign(self, content):
+        if isinstance(content, unicode):
+            raise errors.BzrBadParameterUnicode('content')
         ui.ui_factory.clear_term()
 
         preexec_fn = _set_gpg_tty

=== modified file 'bzrlib/help_topics.py'
--- bzrlib/help_topics.py	2007-01-17 14:46:47 +0000
+++ bzrlib/help_topics.py	2007-02-07 22:31:07 +0000
@@ -141,7 +141,7 @@
                This does not suppress other plugin effects
 --no-plugins   Do not process any plugins
 
---Derror       Instead of normal error handling, always print a traceback on
+-Derror        Instead of normal error handling, always print a traceback on
                error.
 --profile      Profile execution using the hotshot profiler
 --lsprof       Profile execution using the lsprof profiler
@@ -151,6 +151,84 @@
 Note: --version must be supplied before any command.
 """
 
+_checkouts = \
+"""Checkouts
+
+Checkouts are source trees that are connected to a branch, so that when
+you commit in the source tree, the commit goes into that branch.  They
+allow you to use a simpler, more centralized workflow, ignoring some of
+Bazaar's decentralized features until you want them. Using checkouts
+with shared repositories is very similar to working with SVN or CVS, but
+doesn't have the same restrictions.  And using checkouts still allows
+others working on the project to use whatever workflow they like.
+
+A checkout is created with the bzr checkout command (see "help checkout").
+You pass it a reference to another branch, and it will create a local copy
+for you that still contains a reference to the branch you created the
+checkout from (the master branch). Then if you make any commits they will be
+made on the other branch first. This creates an instant mirror of your work, or
+facilitates lockstep development, where each developer is working together,
+continuously integrating the changes of others.
+
+However the checkout is still a first class branch in Bazaar terms, so that
+you have the full history locally.  As you have a first class branch you can
+also commit locally if you want, for instance due to the temporary loss af a
+network connection. Use the --local option to commit to do this. All the local
+commits will then be made on the master branch the next time you do a non-local
+commit.
+
+If you are using a checkout from a shared branch you will periodically want to
+pull in all the changes made by others. This is done using the "update"
+command. The changes need to be applied before any non-local commit, but
+Bazaar will tell you if there are any changes and suggest that you use this
+command when needed.
+
+It is also possible to create a "lightweight" checkout by passing the
+--lightweight flag to checkout. A lightweight checkout is even closer to an
+SVN checkout in that it is not a first class branch, it mainly consists of the
+working tree. This means that any history operations must query the master
+branch, which could be slow if a network connection is involved. Also, as you
+don't have a local branch, then you cannot commit locally.
+
+Lightwieght checkouts work best when you have fast reliable access to the
+master branch. This means that if the master branch is on the same disk or LAN
+a lightweight checkout will be faster than a heavyweight one for any commands
+that modify the revision history (as only one copy branch needs to be updated).
+Heavyweight checkouts will generally be faster for any command that uses the
+history but does not change it, but if the master branch is on the same disk
+then there wont be a noticeable difference.
+
+Another possible use for a checkout is to use it with a treeless repository
+containing your branches, where you maintain only only one working tree by
+switching the master branch that the checkout points to when you want to 
+work on a different branch.
+
+Obviously to commit on a checkout you need to be able to write to the master
+branch. This means that the master branch must be accessable over a writeable
+protocol , such as sftp://, and that you have write permissions at the other
+end. Checkouts also work on the local file system, so that all that matters is
+file permissions.
+
+You can change the master of a checkout by using the "bind" command (see "help
+bind"). This will change the location that the commits are sent to. The bind
+command can also be used to turn a branch into a heavy checkout. If you
+would like to convert your heavy checkout into a normal branch so that every
+commit is local, you can use the "unbind" command.
+
+Related commands:
+
+  checkout    Create a checkout. Pass --lightweight to get a lightweight
+              checkout
+  update      Pull any changes in the master branch in to your checkout
+  commit      Make a commit that is sent to the master branch. If you have
+              a heavy checkout then the --local option will commit to the 
+              checkout without sending the commit to the master
+  bind        Change the master branch that the commits in the checkout will
+              be sent to
+  unbind      Turn a heavy checkout into a standalone branch so that any
+              commits are only made locally
+"""
+
 
 topic_registry.register("revisionspec", _help_on_revisionspec,
                         "Explain how to use --revision")
@@ -162,3 +240,6 @@
 topic_registry.register('formats', get_format_topic, 'Directory formats')
 topic_registry.register('global-options', _global_options,
                         'Options that can be used with any command')
+topic_registry.register('checkouts', _checkouts,
+                        'Information on what a checkout is')
+

=== modified file 'bzrlib/info.py'
--- bzrlib/info.py	2006-12-21 06:00:17 +0000
+++ bzrlib/info.py	2007-02-03 10:56:04 +0000
@@ -27,7 +27,7 @@
 from bzrlib.errors import (NoWorkingTree, NotBranchError,
                            NoRepositoryPresent, NotLocalUrl)
 from bzrlib.missing import find_unmerged
-from bzrlib.symbol_versioning import (deprecated_function, 
+from bzrlib.symbol_versioning import (deprecated_function,
         zero_eight)
 
 
@@ -176,15 +176,15 @@
     branch = working.branch
     basis = working.basis_tree()
     work_inv = working.inventory
-    history = branch.revision_history()
+    branch_revno, branch_last_revision = branch.last_revision_info()
     try:
         tree_last_id = working.get_parent_ids()[0]
     except IndexError:
         tree_last_id = None
 
-    if len(history) and tree_last_id != history[-1]:
+    if branch_revno and tree_last_id != branch_last_revision:
         tree_last_revno = branch.revision_id_to_revno(tree_last_id)
-        missing_count = len(history) - tree_last_revno
+        missing_count = branch_revno - tree_last_revno
         print
         print 'Working tree is out of date: missing %d revision%s.' % (
             missing_count, plural(missing_count))
@@ -225,40 +225,24 @@
 
 def _show_branch_stats(branch, verbose):
     """Show statistics about a branch."""
-    repository = branch.repository
-    history = branch.revision_history()
-
+    revno, head = branch.last_revision_info()
     print
     print 'Branch history:'
-    revno = len(history)
     print '  %8d revision%s' % (revno, plural(revno))
+    stats = branch.repository.gather_stats(head, committers=verbose)
     if verbose:
-        committers = {}
-        for rev in history:
-            committers[repository.get_revision(rev).committer] = True
-        print '  %8d committer%s' % (len(committers), plural(len(committers)))
-    if revno > 0:
-        firstrev = repository.get_revision(history[0])
-        age = int((time.time() - firstrev.timestamp) / 3600 / 24)
+        committers = stats['committers']
+        print '  %8d committer%s' % (committers, plural(committers))
+    if revno:
+        timestamp, timezone = stats['firstrev']
+        age = int((time.time() - timestamp) / 3600 / 24)
         print '  %8d day%s old' % (age, plural(age))
-        print '   first revision: %s' % osutils.format_date(firstrev.timestamp,
-                                                            firstrev.timezone)
-
-        lastrev = repository.get_revision(history[-1])
-        print '  latest revision: %s' % osutils.format_date(lastrev.timestamp,
-                                                            lastrev.timezone)
-
-#     print
-#     print 'Text store:'
-#     c, t = branch.text_store.total_size()
-#     print '  %8d file texts' % c
-#     print '  %8d KiB' % (t/1024)
-
-#     print
-#     print 'Inventory store:'
-#     c, t = branch.inventory_store.total_size()
-#     print '  %8d inventories' % c
-#     print '  %8d KiB' % (t/1024)
+        print '   first revision: %s' % osutils.format_date(timestamp,
+            timezone)
+        timestamp, timezone = stats['latestrev']
+        print '  latest revision: %s' % osutils.format_date(timestamp,
+            timezone)
+    return stats
 
 
 def _show_repository_info(repository):
@@ -268,14 +252,16 @@
         print 'Create working tree for new branches inside the repository.'
 
 
-def _show_repository_stats(repository):
+def _show_repository_stats(stats):
     """Show statistics about a repository."""
-    if repository.bzrdir.root_transport.listable():
+    if 'revisions' in stats or 'size' in stats:
         print
         print 'Revision store:'
-        c, t = repository._revision_store.total_size(repository.get_transaction())
-        print '  %8d revision%s' % (c, plural(c))
-        print '  %8d KiB' % (t/1024)
+    if 'revisions' in stats:
+        revisions = stats['revisions']
+        print '  %8d revision%s' % (revisions, plural(revisions))
+    if 'size' in stats:
+        print '  %8d KiB' % (stats['size']/1024)
 
 
 @deprecated_function(zero_eight)
@@ -336,8 +322,8 @@
     _show_missing_revisions_branch(branch)
     _show_missing_revisions_working(working)
     _show_working_stats(working)
-    _show_branch_stats(branch, verbose)
-    _show_repository_stats(repository)
+    stats = _show_branch_stats(branch, verbose)
+    _show_repository_stats(stats)
 
 
 def show_branch_info(branch, verbose):
@@ -350,8 +336,8 @@
     _show_format_info(control, repository, branch)
     _show_locking_info(repository, branch)
     _show_missing_revisions_branch(branch)
-    _show_branch_stats(branch, verbose)
-    _show_repository_stats(repository)
+    stats = _show_branch_stats(branch, verbose)
+    _show_repository_stats(stats)
 
 
 def show_repository_info(repository, verbose):
@@ -362,4 +348,5 @@
     _show_format_info(control, repository)
     _show_locking_info(repository)
     _show_repository_info(repository)
-    _show_repository_stats(repository)
+    stats = repository.gather_stats()
+    _show_repository_stats(stats)

=== modified file 'bzrlib/inventory.py'
--- bzrlib/inventory.py	2006-12-22 17:11:36 +0000
+++ bzrlib/inventory.py	2007-02-06 14:52:16 +0000
@@ -384,6 +384,8 @@
             return 'added'
         elif new_entry is None:
             return 'removed'
+        if old_entry.kind != new_entry.kind:
+            return 'modified'
         text_modified, meta_modified = new_entry.detect_changes(old_entry)
         if text_modified or meta_modified:
             modified = True

=== modified file 'bzrlib/knit.py'
--- bzrlib/knit.py	2007-01-17 15:37:08 +0000
+++ bzrlib/knit.py	2007-01-31 18:58:10 +0000
@@ -1130,29 +1130,22 @@
         # so - wc -l of a knit index is != the number of unique names
         # in the knit.
         self._history = []
-        decode_utf8 = cache_utf8.decode
-        pb = ui.ui_factory.nested_progress_bar()
         try:
-            pb.update('read knit index', 0, 1)
+            fp = self._transport.get(self._filename)
             try:
-                fp = self._transport.get(self._filename)
-                try:
-                    # _load_data may raise NoSuchFile if the target knit is
-                    # completely empty.
-                    self._load_data(fp)
-                finally:
-                    fp.close()
-            except NoSuchFile:
-                if mode != 'w' or not create:
-                    raise
-                elif delay_create:
-                    self._need_to_create = True
-                else:
-                    self._transport.put_bytes_non_atomic(
-                        self._filename, self.HEADER, mode=self._file_mode)
-        finally:
-            pb.update('read knit index', 1, 1)
-            pb.finished()
+                # _load_data may raise NoSuchFile if the target knit is
+                # completely empty.
+                self._load_data(fp)
+            finally:
+                fp.close()
+        except NoSuchFile:
+            if mode != 'w' or not create:
+                raise
+            elif delay_create:
+                self._need_to_create = True
+            else:
+                self._transport.put_bytes_non_atomic(
+                    self._filename, self.HEADER, mode=self._file_mode)
 
     def _load_data(self, fp):
         cache = self._cache

=== modified file 'bzrlib/lockdir.py'
--- bzrlib/lockdir.py	2006-11-10 21:06:11 +0000
+++ bzrlib/lockdir.py	2007-01-31 18:49:12 +0000
@@ -220,6 +220,8 @@
             self.transport.rename(tmpname, self._held_dir)
             self._lock_held = True
             self.confirm()
+        except errors.PermissionDenied:
+            raise
         except (PathError, DirectoryNotEmpty, FileExists, ResourceBusy), e:
             mutter("contention on %r: %s", self, e)
             raise LockContention(self)

=== modified file 'bzrlib/log.py'
--- bzrlib/log.py	2006-10-16 09:14:47 +0000
+++ bzrlib/log.py	2007-02-07 03:09:58 +0000
@@ -54,7 +54,10 @@
 from itertools import izip
 import re
 
-from bzrlib import symbol_versioning
+from bzrlib import(
+    registry,
+    symbol_versioning,
+    )
 import bzrlib.errors as errors
 from bzrlib.symbol_versioning import deprecated_method, zero_eleven
 from bzrlib.trace import mutter
@@ -296,8 +299,6 @@
     elif direction != 'reverse':
         raise ValueError('invalid direction %r' % direction)
 
-    revision_history = branch.revision_history()
-
     for sequence, rev_id, merge_depth, revno, end_of_merge in merge_sorted_revisions:
         yield rev_id, '.'.join(map(str, revno)), merge_depth
 
@@ -461,14 +462,36 @@
     lf = LineLogFormatter(None)
     return lf.log_string(None, rev, max_chars)
 
-FORMATTERS = {
-              'long': LongLogFormatter,
-              'short': ShortLogFormatter,
-              'line': LineLogFormatter,
-              }
+
+class LogFormatterRegistry(registry.Registry):
+    """Registry for log formatters"""
+
+    def make_formatter(self, name, *args, **kwargs):
+        """Construct a formatter from arguments.
+
+        :param name: Name of the formatter to construct.  'short', 'long' and
+            'line' are built-in.
+        """
+        return self.get(name)(*args, **kwargs)
+
+    def get_default(self, branch):
+        return self.get(branch.get_config().log_format())
+
+
+log_formatter_registry = LogFormatterRegistry()
+
+
+log_formatter_registry.register('short', ShortLogFormatter,
+                                'Moderately short log format')
+log_formatter_registry.register('long', LongLogFormatter,
+                                'Detailed log format')
+log_formatter_registry.register('line', LineLogFormatter,
+                                'Log format with one line per revision')
+
 
 def register_formatter(name, formatter):
-    FORMATTERS[name] = formatter
+    log_formatter_registry.register(name, formatter)
+
 
 def log_formatter(name, *args, **kwargs):
     """Construct a formatter from arguments.
@@ -478,10 +501,11 @@
     """
     from bzrlib.errors import BzrCommandError
     try:
-        return FORMATTERS[name](*args, **kwargs)
+        return log_formatter_registry.make_formatter(name, *args, **kwargs)
     except KeyError:
         raise BzrCommandError("unknown log formatter: %r" % name)
 
+
 def show_one_log(revno, rev, delta, verbose, to_file, show_timezone):
     # deprecated; for compatibility
     lf = LongLogFormatter(to_file=to_file, show_timezone=show_timezone)

=== modified file 'bzrlib/memorytree.py'
--- bzrlib/memorytree.py	2006-09-22 04:52:17 +0000
+++ bzrlib/memorytree.py	2007-02-06 14:52:16 +0000
@@ -99,6 +99,9 @@
     def is_executable(self, file_id, path=None):
         return self._inventory[file_id].executable
 
+    def kind(self, file_id):
+        return self._inventory[file_id].kind
+
     def mkdir(self, path, file_id=None):
         """See MutableTree.mkdir()."""
         self.add(path, file_id, 'directory')

=== modified file 'bzrlib/merge.py'
--- bzrlib/merge.py	2006-11-10 21:06:11 +0000
+++ bzrlib/merge.py	2007-02-07 16:10:56 +0000
@@ -21,6 +21,7 @@
 
 from bzrlib import (
     osutils,
+    registry,
     )
 from bzrlib.branch import Branch
 from bzrlib.conflicts import ConflictList, Conflict
@@ -141,7 +142,8 @@
 
     def check_basis(self, check_clean, require_commits=True):
         if self.this_basis is None and require_commits is True:
-            raise BzrCommandError("This branch has no commits")
+            raise BzrCommandError("This branch has no commits."
+                                  " (perhaps you would prefer 'bzr pull')")
         if check_clean:
             self.compare_basis()
             if self.this_basis != self.this_rev_id:
@@ -572,7 +574,8 @@
             parent_id = self.tt.final_parent(trans_id)
             if file_id in self.this_tree.inventory:
                 self.tt.unversion_file(trans_id)
-                self.tt.delete_contents(trans_id)
+                if file_id in self.this_tree:
+                    self.tt.delete_contents(trans_id)
             file_group = self._dump_conflicts(name, parent_id, file_id, 
                                               set_version=True)
             self._raw_conflicts.append(('contents conflict', file_group))
@@ -959,14 +962,10 @@
     merger.other_basis = other_rev_id
     return merger.do_merge()
 
-
-merge_types = {     "merge3": (Merge3Merger, "Native diff3-style merge"), 
-                     "diff3": (Diff3Merger,  "Merge using external diff3"),
-                     'weave': (WeaveMerger, "Weave-based merge")
-              }
-
-
-def merge_type_help():
-    templ = '%s%%7s: %%s' % (' '*12)
-    lines = [templ % (f[0], f[1][1]) for f in merge_types.iteritems()]
-    return '\n'.join(lines)
+def get_merge_type_registry():
+    """Merge type registry is in bzrlib.option to avoid circular imports.
+
+    This method provides a sanctioned way to retrieve it.
+    """
+    from bzrlib import option
+    return option._merge_type_registry

=== modified file 'bzrlib/option.py'
--- bzrlib/option.py	2007-02-06 06:27:24 +0000
+++ bzrlib/option.py	2007-02-13 05:22:39 +0000
@@ -25,6 +25,8 @@
 
 from bzrlib import (
     errors,
+    log,
+    registry,
     revisionspec,
     symbol_versioning,
     )
@@ -225,7 +227,7 @@
             return self.converter(value)
 
     def __init__(self, name, help, registry, converter=None,
-        value_switches=False):
+        value_switches=False, title=None):
         """
         Constructor.
 
@@ -243,9 +245,14 @@
         self.name = name
         self.converter = converter
         self.value_switches = value_switches
+        self.title = title
+        if self.title is None:
+            self.title = name
 
     def add_option(self, parser, short_name):
         """Add this option to an Optparse parser"""
+        if self.value_switches:
+            parser = parser.add_option_group(self.title)
         Option.add_option(self, parser, short_name)
         if self.value_switches:
             for key in self.registry.keys():
@@ -295,6 +302,24 @@
     """Register o as a global option."""
     Option.OPTIONS[name] = Option(name, **kwargs)
 
+
+def _global_registry_option(name, help, registry, **kwargs):
+    Option.OPTIONS[name] = RegistryOption(name, help, registry, **kwargs)
+
+
+class MergeTypeRegistry(registry.Registry):
+
+    pass
+
+
+_merge_type_registry = MergeTypeRegistry()
+_merge_type_registry.register_lazy('merge3', 'bzrlib.merge', 'Merge3Merger',
+                                   "Native diff3-style merge")
+_merge_type_registry.register_lazy('diff3', 'bzrlib.merge', 'Diff3Merger',
+                                   "Merge using external diff3")
+_merge_type_registry.register_lazy('weave', 'bzrlib.merge', 'WeaveMerger',
+                                   "Weave-based merge")
+
 _global_option('all')
 _global_option('overwrite', help='Ignore differences between branches and '
                'overwrite unconditionally')
@@ -329,15 +354,18 @@
 _global_option('version')
 _global_option('email')
 _global_option('update')
-_global_option('log-format', type=str, help="Use this log format")
+_global_registry_option('log-format', "Use this log format",
+                        log.log_formatter_registry, value_switches=True,
+                        title='Log format')
 _global_option('long', help='Use detailed log format. Same as --log-format long',
                short_name='l')
 _global_option('short', help='Use moderately short log format. Same as --log-format short')
 _global_option('line', help='Use log format with one line per revision. Same as --log-format line')
 _global_option('root', type=str)
 _global_option('no-backup')
-_global_option('merge-type', type=_parse_merge_type, 
-               help='Select a particular merge algorithm')
+_global_registry_option('merge-type', 'Select a particular merge algorithm',
+                        _merge_type_registry, value_switches=True,
+                        title='Merge algorithm')
 _global_option('pattern', type=str)
 _global_option('quiet', short_name='q')
 _global_option('remember', help='Remember the specified location as a'

=== modified file 'bzrlib/osutils.py'
--- bzrlib/osutils.py	2007-01-04 23:36:44 +0000
+++ bzrlib/osutils.py	2007-02-02 09:14:30 +0000
@@ -40,7 +40,6 @@
 from shutil import (
     rmtree,
     )
-import string
 import tempfile
 from tempfile import (
     mkdtemp,
@@ -49,6 +48,7 @@
 
 from bzrlib import (
     errors,
+    win32utils,
     )
 """)
 
@@ -777,7 +777,15 @@
 
 def contains_whitespace(s):
     """True if there are any whitespace characters in s."""
-    for ch in string.whitespace:
+    # string.whitespace can include '\xa0' in certain locales, because it is
+    # considered "non-breaking-space" as part of ISO-8859-1. But it
+    # 1) Isn't a breaking whitespace
+    # 2) Isn't one of ' \t\r\n' which are characters we sometimes use as
+    #    separators
+    # 3) '\xa0' isn't unicode safe since it is >128.
+    # So we are following textwrap's example and hard-coding our own.
+    # We probably could ignore \v and \f, too.
+    for ch in u' \t\n\r\v\f':
         if ch in s:
             return True
     else:
@@ -890,8 +898,7 @@
 def terminal_width():
     """Return estimated terminal width."""
     if sys.platform == 'win32':
-        import bzrlib.win32console
-        return bzrlib.win32console.get_console_size()[0]
+        return win32utils.get_console_size()[0]
     width = 0
     try:
         import struct, fcntl, termios
@@ -915,6 +922,19 @@
     return sys.platform != "win32"
 
 
+def supports_posix_readonly():
+    """Return True if 'readonly' has POSIX semantics, False otherwise.
+
+    Notably, a win32 readonly file cannot be deleted, unlike POSIX where the
+    directory controls creation/deletion, etc.
+
+    And under win32, readonly means that the directory itself cannot be
+    deleted.  The contents of a readonly directory can be changed, unlike POSIX
+    where files in readonly directories cannot be added, deleted or renamed.
+    """
+    return sys.platform != "win32"
+
+
 def set_or_unset_env(env_variable, value):
     """Modify the environment, setting or removing the env_variable.
 

=== modified file 'bzrlib/plugin.py'
--- bzrlib/plugin.py	2007-01-03 00:23:45 +0000
+++ bzrlib/plugin.py	2007-02-02 20:27:53 +0000
@@ -15,37 +15,29 @@
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
 
-"""bzr python plugin support
-
-Any python module in $BZR_PLUGIN_PATH will be imported upon initialization of
-bzrlib. The module will be imported as 'bzrlib.plugins.$BASENAME(PLUGIN)'.
-In the plugin's main body, it should update any bzrlib registries it wants to
-extend; for example, to add new commands, import bzrlib.commands and add your
-new command to the plugin_cmds variable.
+"""bzr python plugin support.
+
+When load_plugins() is invoked, any python module in any directory in
+$BZR_PLUGIN_PATH will be imported.  The module will be imported as
+'bzrlib.plugins.$BASENAME(PLUGIN)'.  In the plugin's main body, it should
+update any bzrlib registries it wants to extend; for example, to add new
+commands, import bzrlib.commands and add your new command to the plugin_cmds
+variable.
+
+BZR_PLUGIN_PATH is also honoured for any plugins imported via
+'import bzrlib.plugins.PLUGINNAME', as long as set_plugins_path has been 
+called.
 """
 
-# TODO: Refactor this to make it more testable.  The main problem at the
-# moment is that loading plugins affects the global process state -- for bzr
-# in general use it's a reasonable assumption that all plugins are loaded at
-# startup and then stay loaded, but this is less good for testing.
-# 
-# Several specific issues:
-#  - plugins can't be unloaded and will continue to effect later tests
-#  - load_plugins does nothing if called a second time
-#  - plugin hooks can't be removed
-#
-# Our options are either to remove these restrictions, or work around them by
-# loading the plugins into a different space than the one running the tests.
-# That could be either a separate Python interpreter or perhaps a new
-# namespace inside this interpreter.
-
 import os
 import sys
 
 from bzrlib.lazy_import import lazy_import
 lazy_import(globals(), """
 import imp
+import re
 import types
+import zipimport
 
 from bzrlib import (
     config,
@@ -58,7 +50,7 @@
 
 
 DEFAULT_PLUGIN_PATH = None
-
+_loaded = False
 
 def get_default_plugin_path():
     """Get the DEFAULT_PLUGIN_PATH"""
@@ -68,9 +60,6 @@
     return DEFAULT_PLUGIN_PATH
 
 
-_loaded = False
-
-
 def all_plugins():
     """Return a dictionary of the plugins."""
     result = {}
@@ -91,6 +80,16 @@
     _loaded = True
 
 
+def set_plugins_path():
+    """Set the path for plugins to be loaded from."""
+    path = os.environ.get('BZR_PLUGIN_PATH',
+                          get_default_plugin_path()).split(os.pathsep)
+    # search the bzrlib installed dir before anything else.
+    path.insert(0, os.path.dirname(plugins.__file__))
+    plugins.__path__ = path
+    return path
+
+
 def load_plugins():
     """Load bzrlib plugins.
 
@@ -108,15 +107,11 @@
         return
     _loaded = True
 
-    dirs = os.environ.get('BZR_PLUGIN_PATH',
-                          get_default_plugin_path()).split(os.pathsep)
-    dirs.insert(0, os.path.dirname(plugins.__file__))
-
-    load_from_dirs(dirs)
-    load_from_zips(dirs)
-
-
-def load_from_dirs(dirs):
+    # scan for all plugins in the path.
+    load_from_path(set_plugins_path())
+
+
+def load_from_path(dirs):
     """Load bzrlib plugins found in each dir in dirs.
 
     Loading a plugin means importing it into the python interpreter.
@@ -125,145 +120,150 @@
 
     Plugins are loaded into bzrlib.plugins.NAME, and can be found there
     for future reference.
+
+    The python module path for bzrlib.plugins will be modified to be 'dirs'.
     """
+    plugins.__path__ = dirs
+    for d in dirs:
+        if not d:
+            continue
+        mutter('looking for plugins in %s', d)
+        if os.path.isdir(d):
+            load_from_dir(d)
+        else:
+            # it might be a zip: try loading from the zip.
+            load_from_zip(d)
+            continue
+
+
+# backwards compatability: load_from_dirs was the old name
+# This was changed in 0.15
+load_from_dirs = load_from_path
+
+
+def load_from_dir(d):
+    """Load the plugins in directory d."""
     # Get the list of valid python suffixes for __init__.py?
     # this includes .py, .pyc, and .pyo (depending on if we are running -O)
     # but it doesn't include compiled modules (.so, .dll, etc)
     valid_suffixes = [suffix for suffix, mod_type, flags in imp.get_suffixes()
                               if flags in (imp.PY_SOURCE, imp.PY_COMPILED)]
     package_entries = ['__init__'+suffix for suffix in valid_suffixes]
-    for d in dirs:
-        if not d:
-            continue
-        mutter('looking for plugins in %s', d)
-        plugin_names = set()
-        if not os.path.isdir(d):
-            continue
-        for f in os.listdir(d):
-            path = osutils.pathjoin(d, f)
-            if os.path.isdir(path):
-                for entry in package_entries:
-                    # This directory should be a package, and thus added to
-                    # the list
-                    if os.path.isfile(osutils.pathjoin(path, entry)):
-                        break
-                else: # This directory is not a package
-                    continue
-            else:
-                for suffix_info in imp.get_suffixes():
-                    if f.endswith(suffix_info[0]):
-                        f = f[:-len(suffix_info[0])]
-                        if suffix_info[2] == imp.C_EXTENSION and f.endswith('module'):
-                            f = f[:-len('module')]
-                        break
-                else:
-                    continue
-            if getattr(plugins, f, None):
-                mutter('Plugin name %s already loaded', f)
-            else:
-                # mutter('add plugin name %s', f)
-                plugin_names.add(f)
-
-        plugin_names = list(plugin_names)
-        plugin_names.sort()
-        for name in plugin_names:
-            try:
-                plugin_info = imp.find_module(name, [d])
-                # mutter('load plugin %r', plugin_info)
-                try:
-                    plugin = imp.load_module('bzrlib.plugins.' + name,
-                                             *plugin_info)
-                    setattr(plugins, name, plugin)
-                finally:
-                    if plugin_info[0] is not None:
-                        plugin_info[0].close()
-                # mutter('loaded succesfully')
-            except KeyboardInterrupt:
-                raise
-            except Exception, e:
-                ## import pdb; pdb.set_trace()
+    plugin_names = set()
+    for f in os.listdir(d):
+        path = osutils.pathjoin(d, f)
+        if os.path.isdir(path):
+            for entry in package_entries:
+                # This directory should be a package, and thus added to
+                # the list
+                if os.path.isfile(osutils.pathjoin(path, entry)):
+                    break
+            else: # This directory is not a package
+                continue
+        else:
+            for suffix_info in imp.get_suffixes():
+                if f.endswith(suffix_info[0]):
+                    f = f[:-len(suffix_info[0])]
+                    if suffix_info[2] == imp.C_EXTENSION and f.endswith('module'):
+                        f = f[:-len('module')]
+                    break
+            else:
+                continue
+        if getattr(plugins, f, None):
+            mutter('Plugin name %s already loaded', f)
+        else:
+            # mutter('add plugin name %s', f)
+            plugin_names.add(f)
+    
+    for name in plugin_names:
+        try:
+            exec "import bzrlib.plugins.%s" % name in {}
+        except KeyboardInterrupt:
+            raise
+        except Exception, e:
+            ## import pdb; pdb.set_trace()
+            if re.search('\.|-| ', name):
+                warning('Unable to load plugin %r from %r: '
+                    'It is not a valid python module name.' % (name, d))
+            else:
                 warning('Unable to load plugin %r from %r' % (name, d))
-                log_exception_quietly()
-
-
-def load_from_zips(zips):
-    """Load bzr plugins from zip archives with zipimport.
-    It's similar to load_from_dirs but plugins searched inside archives.
-    """
-    import zipfile
-    import zipimport
-
+            log_exception_quietly()
+
+
+def load_from_zip(zip_name):
+    """Load all the plugins in a zip."""
     valid_suffixes = ('.py', '.pyc', '.pyo')    # only python modules/packages
                                                 # is allowed
-    for zip_name in zips:
-        if '.zip' not in zip_name:
-            continue
+    if '.zip' not in zip_name:
+        return
+    try:
+        ziobj = zipimport.zipimporter(zip_name)
+    except zipimport.ZipImportError:
+        # not a valid zip
+        return
+    mutter('Looking for plugins in %r', zip_name)
+    
+    import zipfile
+
+    # use zipfile to get list of files/dirs inside zip
+    z = zipfile.ZipFile(ziobj.archive)
+    namelist = z.namelist()
+    z.close()
+    
+    if ziobj.prefix:
+        prefix = ziobj.prefix.replace('\\','/')
+        ix = len(prefix)
+        namelist = [name[ix:]
+                    for name in namelist
+                    if name.startswith(prefix)]
+    
+    mutter('Names in archive: %r', namelist)
+    
+    for name in namelist:
+        if not name or name.endswith('/'):
+            continue
+    
+        # '/' is used to separate pathname components inside zip archives
+        ix = name.rfind('/')
+        if ix == -1:
+            head, tail = '', name
+        else:
+            head, tail = name.rsplit('/',1)
+        if '/' in head:
+            # we don't need looking in subdirectories
+            continue
+    
+        base, suffix = osutils.splitext(tail)
+        if suffix not in valid_suffixes:
+            continue
+    
+        if base == '__init__':
+            # package
+            plugin_name = head
+        elif head == '':
+            # module
+            plugin_name = base
+        else:
+            continue
+    
+        if not plugin_name:
+            continue
+        if getattr(plugins, plugin_name, None):
+            mutter('Plugin name %s already loaded', plugin_name)
+            continue
+    
         try:
-            ziobj = zipimport.zipimporter(zip_name)
-        except zipimport.ZipImportError:
-            # not a valid zip
+            plugin = ziobj.load_module(plugin_name)
+            setattr(plugins, plugin_name, plugin)
+            mutter('Load plugin %s from zip %r', plugin_name, zip_name)
+        except zipimport.ZipImportError, e:
+            mutter('Unable to load plugin %r from %r: %s',
+                   plugin_name, zip_name, str(e))
             continue
-        mutter('Looking for plugins in %r', zip_name)
-
-        # use zipfile to get list of files/dirs inside zip
-        z = zipfile.ZipFile(ziobj.archive)
-        namelist = z.namelist()
-        z.close()
-
-        if ziobj.prefix:
-            prefix = ziobj.prefix.replace('\\','/')
-            ix = len(prefix)
-            namelist = [name[ix:]
-                        for name in namelist
-                        if name.startswith(prefix)]
-
-        mutter('Names in archive: %r', namelist)
-
-        for name in namelist:
-            if not name or name.endswith('/'):
-                continue
-
-            # '/' is used to separate pathname components inside zip archives
-            ix = name.rfind('/')
-            if ix == -1:
-                head, tail = '', name
-            else:
-                head, tail = name.rsplit('/',1)
-            if '/' in head:
-                # we don't need looking in subdirectories
-                continue
-
-            base, suffix = osutils.splitext(tail)
-            if suffix not in valid_suffixes:
-                continue
-
-            if base == '__init__':
-                # package
-                plugin_name = head
-            elif head == '':
-                # module
-                plugin_name = base
-            else:
-                continue
-
-            if not plugin_name:
-                continue
-            if getattr(plugins, plugin_name, None):
-                mutter('Plugin name %s already loaded', plugin_name)
-                continue
-
-            try:
-                plugin = ziobj.load_module(plugin_name)
-                setattr(plugins, plugin_name, plugin)
-                mutter('Load plugin %s from zip %r', plugin_name, zip_name)
-            except zipimport.ZipImportError, e:
-                mutter('Unable to load plugin %r from %r: %s',
-                       plugin_name, zip_name, str(e))
-                continue
-            except KeyboardInterrupt:
-                raise
-            except Exception, e:
-                ## import pdb; pdb.set_trace()
-                warning('Unable to load plugin %r from %r'
-                        % (name, zip_name))
-                log_exception_quietly()
+        except KeyboardInterrupt:
+            raise
+        except Exception, e:
+            ## import pdb; pdb.set_trace()
+            warning('Unable to load plugin %r from %r'
+                    % (name, zip_name))
+            log_exception_quietly()

=== modified file 'bzrlib/plugins/launchpad/__init__.py'
--- bzrlib/plugins/launchpad/__init__.py	2006-10-11 23:08:27 +0000
+++ bzrlib/plugins/launchpad/__init__.py	2007-01-26 04:44:10 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006 Canonical Ltd
+# Copyright (C) 2006, 2007 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -14,9 +14,7 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
-"""Launchpad.net branch registration plugin for bzr
-
-This adds commands that tell launchpad about newly-created branches, etc.
+"""Launchpad.net integration plugin for Bazaar
 
 To install this file, put the 'bzr_lp' directory, or a symlink to it,
 in your ~/.bazaar/plugins/ directory.
@@ -28,7 +26,8 @@
 # see http://bazaar-vcs.org/Specs/BranchRegistrationTool
 
 from bzrlib.commands import Command, Option, register_command
-
+from bzrlib.transport import register_lazy_transport
+from bzrlib.help_topics import topic_registry
 
 
 class cmd_register_branch(Command):
@@ -115,8 +114,48 @@
 
 register_command(cmd_register_branch)
 
+register_lazy_transport(
+    'lp:',
+    'bzrlib.plugins.launchpad.lp_indirect',
+    'launchpad_transport_indirect')
+
+register_lazy_transport(
+    'lp://',
+    'bzrlib.plugins.launchpad.lp_indirect',
+    'launchpad_transport_indirect')
+
 def test_suite():
     """Called by bzrlib to fetch tests for this plugin"""
     from unittest import TestSuite, TestLoader
     import test_register
-    return TestLoader().loadTestsFromModule(test_register)
+    import test_lp_indirect
+
+    loader = TestLoader()
+    suite = TestSuite()
+    for m in [test_register, test_lp_indirect]:
+        suite.addTests(loader.loadTestsFromModule(m))
+    return suite
+
+_launchpad_help = """Integration with Launchpad.net
+
+Launchpad.net provides free Bazaar branch hosting with integrated bug and
+specification tracking.
+
+The bzr client (through the plugin called 'launchpad') has two special
+features to communicate with Launchpad:
+
+    * The register-branch command tells launchpad about the url of a 
+      public branch.  Launchpad will then mirror the branch, display
+      its contents and allow it to be attached to bugs and other 
+      objects.
+
+    * The 'lp:' transport uses Launchpad as a directory service: 
+      for example 'lp:bzr' and 'lp:python' refer to the main branches of the
+      relevant projects and may be branched, logged, etc.  (Only read access
+      is supported at present.)
+
+For more information see http://help.launchpad.net/
+"""
+topic_registry.register('launchpad',
+    _launchpad_help,
+    'Using Bazaar with Launchpad.net')

=== added file 'bzrlib/plugins/launchpad/lp_indirect.py'
--- bzrlib/plugins/launchpad/lp_indirect.py	1970-01-01 00:00:00 +0000
+++ bzrlib/plugins/launchpad/lp_indirect.py	2007-01-26 04:44:10 +0000
@@ -0,0 +1,48 @@
+# Copyright (C) 2007 Canonical Ltd
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+
+
+"""Transport indirection that uses Launchpad as a directory lookup.
+
+When the transport is opened, it immediately redirects to a url
+on Launchpad, which can then either serve the branch itself or redirect
+again.
+"""
+
+from bzrlib import (
+    errors,
+    )
+from bzrlib.transport import (
+    get_transport,
+    Transport,
+    )
+
+
+def launchpad_transport_indirect(base_url):
+    """Uses Launchpad.net as a directory of open source software"""
+    if base_url.startswith('lp:///'):
+        real_url = 'http://code.launchpad.net/' + base_url[6:]
+    elif base_url.startswith('lp:') and base_url[3] != '/':
+        real_url = 'http://code.launchpad.net/' + base_url[3:]
+    else:
+        raise errors.InvalidURL(path=base_url)
+    return get_transport(real_url)
+
+
+def get_test_permutations():
+    # Since this transport doesn't do anything once opened, it's not subjected
+    # to the usual transport tests.
+    return []

=== added file 'bzrlib/plugins/launchpad/test_lp_indirect.py'
--- bzrlib/plugins/launchpad/test_lp_indirect.py	1970-01-01 00:00:00 +0000
+++ bzrlib/plugins/launchpad/test_lp_indirect.py	2007-02-08 08:33:26 +0000
@@ -0,0 +1,50 @@
+# Copyright (C) 2007 Canonical Ltd
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+
+"""Tests for indirect branch urls through Launchpad.net"""
+
+from bzrlib import (
+    errors,
+    transport,
+    )
+from bzrlib.transport import get_transport
+from bzrlib.tests import TestCase, TestSkipped
+
+
+class IndirectUrlTests(TestCase):
+    """Tests for indirect branch urls through Launchpad.net"""
+
+    def test_short_form(self):
+        """A launchpad url should map to a http url"""
+        url = 'lp:apt'
+        t = get_transport(url)
+        self.assertEquals(t.base, 'http://code.launchpad.net/apt/')
+
+    def test_indirect_through_url(self):
+        """A launchpad url should map to a http url"""
+        # These can change to use the smartserver protocol or something 
+        # else in the future.
+        url = 'lp:///apt'
+        t = get_transport(url)
+        real_url = t.base
+        self.assertEquals(real_url, 'http://code.launchpad.net/apt/')
+
+    # TODO: check we get an error if the url is unreasonable
+    def test_error_for_bad_indirection(self):
+        self.assertRaises(errors.InvalidURL,
+            get_transport,
+            'lp://ratotehunoahu')
+

=== modified file 'bzrlib/repository.py'
--- bzrlib/repository.py	2007-02-13 01:47:25 +0000
+++ bzrlib/repository.py	2007-02-13 05:22:39 +0000
@@ -230,6 +230,56 @@
         return self.control_files.get_physical_lock_status()
 
     @needs_read_lock
+    def gather_stats(self, revid=None, committers=None):
+        """Gather statistics from a revision id.
+
+        :param revid: The revision id to gather statistics from, if None, then
+            no revision specific statistics are gathered.
+        :param committers: Optional parameter controlling whether to grab
+            a count of committers from the revision specific statistics.
+        :return: A dictionary of statistics. Currently this contains:
+            committers: The number of committers if requested.
+            firstrev: A tuple with timestamp, timezone for the penultimate left
+                most ancestor of revid, if revid is not the NULL_REVISION.
+            latestrev: A tuple with timestamp, timezone for revid, if revid is
+                not the NULL_REVISION.
+            revisions: The total revision count in the repository.
+            size: An estimate disk size of the repository in bytes.
+        """
+        result = {}
+        if revid and committers:
+            result['committers'] = 0
+        if revid and revid != _mod_revision.NULL_REVISION:
+            if committers:
+                all_committers = set()
+            revisions = self.get_ancestry(revid)
+            # pop the leading None
+            revisions.pop(0)
+            first_revision = None
+            if not committers:
+                # ignore the revisions in the middle - just grab first and last
+                revisions = revisions[0], revisions[-1]
+            for revision in self.get_revisions(revisions):
+                if not first_revision:
+                    first_revision = revision
+                if committers:
+                    all_committers.add(revision.committer)
+            last_revision = revision
+            if committers:
+                result['committers'] = len(all_committers)
+            result['firstrev'] = (first_revision.timestamp,
+                first_revision.timezone)
+            result['latestrev'] = (last_revision.timestamp,
+                last_revision.timezone)
+
+        # now gather global repository information
+        if self.bzrdir.root_transport.listable():
+            c, t = self._revision_store.total_size(self.get_transaction())
+            result['revisions'] = c
+            result['size'] = t
+        return result
+
+    @needs_read_lock
     def missing_revision_ids(self, other, revision_id=None):
         """Return the revision ids that other has that this does not.
         
@@ -960,19 +1010,6 @@
             raise errors.UnknownFormatError(format=format_string)
 
     @classmethod
-    @deprecated_method(symbol_versioning.zero_fourteen)
-    def set_default_format(klass, format):
-        klass._set_default_format(format)
-
-    @classmethod
-    def _set_default_format(klass, format):
-        """Set the default format for new Repository creation.
-
-        The format must already be registered.
-        """
-        format_registry.default_key = format.get_format_string()
-
-    @classmethod
     def register_format(klass, format):
         format_registry.register(format.get_format_string(), format)
 
@@ -983,7 +1020,8 @@
     @classmethod
     def get_default_format(klass):
         """Return the current default format."""
-        return format_registry.get(format_registry.default_key)
+        from bzrlib import bzrdir
+        return bzrdir.format_registry.make_bzrdir('default').repository_format
 
     def _get_control_store(self, repo_transport, control_files):
         """Return the control store for this repository."""

=== modified file 'bzrlib/revisionspec.py'
--- bzrlib/revisionspec.py	2006-11-08 16:29:27 +0000
+++ bzrlib/revisionspec.py	2007-02-01 14:47:47 +0000
@@ -326,6 +326,8 @@
                 return RevisionInfo(branch, None, revisions[0][1])
         else:
             if revno < 0:
+                # if get_rev_id supported negative revnos, there would not be a
+                # need for this special case.
                 if (-revno) >= len(revs):
                     revno = 1
                 else:

=== modified file 'bzrlib/status.py'
--- bzrlib/status.py	2006-12-07 20:25:00 +0000
+++ bzrlib/status.py	2007-02-05 15:34:47 +0000
@@ -16,6 +16,10 @@
 
 import sys
 
+from bzrlib import (
+    delta as _mod_delta,
+    tree,
+    )
 from bzrlib.diff import _raise_if_nonexistent
 import bzrlib.errors as errors
 from bzrlib.log import line_log
@@ -135,13 +139,22 @@
             else:
                 new = wt
         _raise_if_nonexistent(specific_files, old, new)
-        delta = new.changes_from(old, want_unchanged=show_unchanged,
-                              specific_files=specific_files)
-        delta.show(to_file,
-                   show_ids=show_ids,
-                   show_unchanged=show_unchanged,
-                   short_status=short)
-        short_status_letter = '?'
+        if short:
+            specific_file_ids = tree.find_ids_across_trees(specific_files,
+                (old, new), require_versioned=False)
+            changes = new._iter_changes(old, show_unchanged,
+                                        specific_file_ids)
+            reporter = _mod_delta.ChangeReporter(old.inventory,
+                output_file=to_file)
+            _mod_delta.report_changes(changes, reporter)
+        else:
+            delta = new.changes_from(old, want_unchanged=show_unchanged,
+                                  specific_files=specific_files)
+            delta.show(to_file,
+                       show_ids=show_ids,
+                       show_unchanged=show_unchanged,
+                       short_status=short)
+        short_status_letter = '? '
         if not short:
             short_status_letter = ''
         list_paths('unknown', new.unknowns(), specific_files, to_file,
@@ -153,7 +166,7 @@
                 print >> to_file, "conflicts:"
                 conflict_title = True
             if short:
-                prefix = 'C '
+                prefix = 'C  '
             else:
                 prefix = ' '
             print >> to_file, "%s %s" % (prefix, conflict)
@@ -190,7 +203,7 @@
             width = terminal_width()
             m_revision = branch.repository.get_revision(merge)
             if short:
-                prefix = 'P '
+                prefix = 'P  '
             else:
                 prefix = ' '
             print >> to_file, prefix, line_log(m_revision, width - 4)
@@ -203,14 +216,14 @@
                     continue
                 mm_revision = branch.repository.get_revision(mmerge)
                 if short:
-                    prefix = 'P. '
+                    prefix = 'P.  '
                 else:
                     prefix = '   '
                 print >> to_file, prefix, line_log(mm_revision, width - 5)
                 ignore.add(mmerge)
         except errors.NoSuchRevision:
             if short:
-                prefix = 'P '
+                prefix = 'P  '
             else:
                 prefix = ' '
             print >> to_file, prefix, merge

=== modified file 'bzrlib/tests/__init__.py'
--- bzrlib/tests/__init__.py	2007-01-19 19:42:19 +0000
+++ bzrlib/tests/__init__.py	2007-02-01 23:48:08 +0000
@@ -569,6 +569,12 @@
         self._startLogFile()
         self._benchcalls = []
         self._benchtime = None
+        # prevent hooks affecting tests
+        self._preserved_hooks = bzrlib.branch.Branch.hooks
+        self.addCleanup(self._restoreHooks)
+        # this list of hooks must be kept in sync with the defaults
+        # in branch.py
+        bzrlib.branch.Branch.hooks = bzrlib.branch.BranchHooks()
 
     def _silenceUI(self):
         """Turn off UI for duration of test"""
@@ -835,6 +841,9 @@
         for name, value in self.__old_env.iteritems():
             osutils.set_or_unset_env(name, value)
 
+    def _restoreHooks(self):
+        bzrlib.branch.Branch.hooks = self._preserved_hooks
+
     def tearDown(self):
         self._runCleanups()
         unittest.TestCase.tearDown(self)
@@ -1760,6 +1769,7 @@
                    'bzrlib.tests.test_config',
                    'bzrlib.tests.test_conflicts',
                    'bzrlib.tests.test_decorators',
+                   'bzrlib.tests.test_delta',
                    'bzrlib.tests.test_diff',
                    'bzrlib.tests.test_doc_generate',
                    'bzrlib.tests.test_errors',

=== modified file 'bzrlib/tests/blackbox/test_bound_branches.py'
--- bzrlib/tests/blackbox/test_bound_branches.py	2007-01-05 17:12:03 +0000
+++ bzrlib/tests/blackbox/test_bound_branches.py	2007-02-06 02:33:42 +0000
@@ -349,7 +349,8 @@
 
         bzr('cat-revision', new_rev_id)
 
-    def test_pull_overwrite_fails(self):
+    def test_pull_overwrite(self):
+        # XXX: This test should be moved to branch-implemenations/test_pull
         bzr = self.run_bzr
         self.create_branches()
 
@@ -373,17 +374,8 @@
         self.check_revno(2)
         self.check_revno(2, '../base')
 
-        # It might be possible that we want pull --overwrite to
-        # actually succeed.
-        # If we want it, just change this test to make sure that 
-        # both base and child are updated properly
-        bzr('pull', '--overwrite', '../other', retcode=3)
-
-        # It should fail without changing the local revision
-        self.check_revno(2)
-        self.check_revno(2, '../base')
-
-    # TODO: jam 20051230 Test that commit & pull fail when the branch we 
-    #       are bound to is not available
-
-
+        bzr('pull', '--overwrite', '../other')
+
+        # both the local and master should have been updated.
+        self.check_revno(4)
+        self.check_revno(4, '../base')

=== modified file 'bzrlib/tests/blackbox/test_help.py'
--- bzrlib/tests/blackbox/test_help.py	2006-12-14 21:45:21 +0000
+++ bzrlib/tests/blackbox/test_help.py	2007-02-02 00:16:10 +0000
@@ -51,6 +51,12 @@
         self.assertContainsRe(out, 'ancestor:')
         self.assertContainsRe(out, 'branch:')
 
+    def test_help_checkouts(self):
+        """Smoke test for 'bzr help checkouts'"""
+        out, err = self.runbzr('help checkouts')
+        self.assertContainsRe(out, 'checkout')
+        self.assertContainsRe(out, 'lightweight')
+
     def test_help_commands(self):
         dash_help  = self.runbzr('--help commands')[0]
         commands   = self.runbzr('help commands')[0]
@@ -85,3 +91,4 @@
         for line in help.split('\n'):
             if '--long' in line:
                 self.assertTrue('show help on all commands' in line)
+

=== modified file 'bzrlib/tests/blackbox/test_init.py'
--- bzrlib/tests/blackbox/test_init.py	2006-10-11 23:08:27 +0000
+++ bzrlib/tests/blackbox/test_init.py	2007-02-05 11:13:22 +0000
@@ -124,7 +124,7 @@
 
         # make sure using 'bzr checkout' is not suggested
         # for remote locations missing a working tree
-        self.assertFalse(re.search(r'checkout', err))
+        self.assertFalse(re.search(r'use bzr checkout', err))
 
     def test_init_existing_branch_with_workingtree(self):
         # don't distinguish between the branch having a working tree or not

=== modified file 'bzrlib/tests/blackbox/test_merge.py'
--- bzrlib/tests/blackbox/test_merge.py	2006-11-25 20:38:39 +0000
+++ bzrlib/tests/blackbox/test_merge.py	2007-02-06 15:32:30 +0000
@@ -23,8 +23,8 @@
 
 from bzrlib.branch import Branch
 from bzrlib.bzrdir import BzrDir
-from bzrlib.conflicts import ConflictList
-from bzrlib.osutils import abspath
+from bzrlib.conflicts import ConflictList, ContentsConflict
+from bzrlib.osutils import abspath, file_kind
 from bzrlib.tests.blackbox import ExternalBase
 import bzrlib.urlutils as urlutils
 from bzrlib.workingtree import WorkingTree
@@ -269,3 +269,23 @@
         self.assertContainsRe(err, '1 revision\\(s\\) pulled')
         tree_a = WorkingTree.open('.')
         self.assertEqual([self.id2], tree_a.get_parent_ids())
+
+    def test_merge_kind_change(self):
+        tree_a = self.make_branch_and_tree('tree_a')
+        self.build_tree_contents([('tree_a/file', 'content_1')])
+        tree_a.add('file', 'file-id')
+        tree_a.commit('added file')
+        tree_b = tree_a.bzrdir.sprout('tree_b').open_workingtree()
+        os.unlink('tree_a/file')
+        self.build_tree(['tree_a/file/'])
+        tree_a.commit('changed file to directory')
+        os.chdir('tree_b')
+        self.run_bzr('merge', '../tree_a')
+        self.assertEqual('directory', file_kind('file'))
+        tree_b.revert([])
+        self.assertEqual('file', file_kind('file'))
+        self.build_tree_contents([('file', 'content_2')])
+        tree_b.commit('content change')
+        self.run_bzr('merge', '../tree_a', retcode=1)
+        self.assertEqual(tree_b.conflicts(),
+                         [ContentsConflict('file', file_id='file-id')])

=== modified file 'bzrlib/tests/blackbox/test_missing.py'
--- bzrlib/tests/blackbox/test_missing.py	2006-10-11 23:08:27 +0000
+++ bzrlib/tests/blackbox/test_missing.py	2007-01-24 13:03:32 +0000
@@ -20,11 +20,13 @@
 
 import os
 
+from bzrlib import osutils
+
 from bzrlib.branch import Branch
-from bzrlib.tests import TestCaseInTempDir
-
-
-class TestMissing(TestCaseInTempDir):
+from bzrlib.tests import TestCaseWithTransport
+
+
+class TestMissing(TestCaseWithTransport):
 
     def test_missing(self):
         def bzr(*args, **kwargs):
@@ -118,3 +120,26 @@
         self.assertEqual("Branches are up to date.\n", 
                          bzr('missing', '../a'))
 
+    def test_missing_check_last_location(self):
+        # check that last location shown as filepath not file URL
+
+        # create a source branch
+        os.mkdir('a')
+        os.chdir('a')
+        wt = self.make_branch_and_tree('.')
+        b = wt.branch
+        self.build_tree(['foo'])
+        wt.add('foo')
+        wt.commit('initial')
+
+        location = osutils.getcwd() + '/'
+
+        # clone
+        b.bzrdir.sprout('../b')
+
+        # check last location
+        lines, err = self.run_bzr('missing', working_dir='../b')
+        self.assertEquals('Using last location: %s\n'
+                          'Branches are up to date.\n' % location,
+                          lines)
+        self.assertEquals('', err)

=== modified file 'bzrlib/tests/blackbox/test_push.py'
--- bzrlib/tests/blackbox/test_push.py	2007-02-07 09:11:31 +0000
+++ bzrlib/tests/blackbox/test_push.py	2007-02-13 05:22:39 +0000
@@ -20,6 +20,9 @@
 
 import os
 
+from bzrlib import (
+    errors,
+    )
 import bzrlib
 from bzrlib.branch import Branch
 from bzrlib.bzrdir import BzrDirMetaFormat1
@@ -160,3 +163,73 @@
         t.add('filename', 'funky-chars<>%&;"\'')
         t.commit('commit filename')
         self.run_bzr('push', '../new-tree')
+
+    def create_simple_tree(self):
+        tree = self.make_branch_and_tree('tree')
+        self.build_tree(['tree/a'])
+        tree.add(['a'], ['a-id'])
+        tree.commit('one', rev_id='r1')
+        return tree
+
+    def test_push_create_prefix(self):
+        """'bzr push --create-prefix' will create leading directories."""
+        tree = self.create_simple_tree()
+
+        self.run_bzr_error(['Parent directory of ../new/tree does not exist'],
+                           'push', '../new/tree',
+                           working_dir='tree')
+        self.run_bzr('push', '../new/tree', '--create-prefix',
+                     working_dir='tree')
+        new_tree = WorkingTree.open('new/tree')
+        self.assertEqual(tree.last_revision(), new_tree.last_revision())
+        self.failUnlessExists('new/tree/a')
+
+    def test_push_use_existing(self):
+        """'bzr push --use-existing-dir' can push into an existing dir.
+
+        By default, 'bzr push' will not use an existing, non-versioned dir.
+        """
+        tree = self.create_simple_tree()
+        self.build_tree(['target/'])
+
+        self.run_bzr_error(['Target directory ../target already exists',
+                            'Supply --use-existing-dir',
+                           ], 'push', '../target',
+                           working_dir='tree')
+
+        self.run_bzr('push', '--use-existing-dir', '../target',
+                     working_dir='tree')
+
+        new_tree = WorkingTree.open('target')
+        self.assertEqual(tree.last_revision(), new_tree.last_revision())
+        # The push should have created target/a
+        self.failUnlessExists('target/a')
+
+    def test_push_onto_repo(self):
+        """We should be able to 'bzr push' into an existing bzrdir."""
+        tree = self.create_simple_tree()
+        repo = self.make_repository('repo', shared=True)
+
+        self.run_bzr('push', '../repo',
+                     working_dir='tree')
+
+        # Pushing onto an existing bzrdir will create a repository and
+        # branch as needed, but will only create a working tree if there was
+        # no BzrDir before.
+        self.assertRaises(errors.NoWorkingTree, WorkingTree.open, 'repo')
+        new_branch = Branch.open('repo')
+        self.assertEqual(tree.last_revision(), new_branch.last_revision())
+
+    def test_push_onto_just_bzrdir(self):
+        """We don't handle when the target is just a bzrdir.
+
+        Because you shouldn't be able to create *just* a bzrdir in the wild.
+        """
+        # TODO: jam 20070109 Maybe it would be better to create the repository
+        #       if at this point
+        tree = self.create_simple_tree()
+        a_bzrdir = self.make_bzrdir('dir')
+
+        self.run_bzr_error(['At ../dir you have a valid .bzr control'],
+                'push', '../dir',
+                working_dir='tree')

=== modified file 'bzrlib/tests/blackbox/test_revert.py'
--- bzrlib/tests/blackbox/test_revert.py	2006-10-11 23:08:27 +0000
+++ bzrlib/tests/blackbox/test_revert.py	2007-02-01 20:36:13 +0000
@@ -103,6 +103,15 @@
         self.failIfExists('h')
         self.failUnlessExists('a/d/e')
 
+    def test_revert_chatter(self):
+        self._prepare_rename_mod_tree()
+        chatter = self.run_bzr('revert')[1]
+        self.assertEqualDiff('R   j/ => f/\n'
+                             'R   j/b => a/b\n'
+                             'R   j/d/ => a/d/\n'
+                             'R   j/e => a/d/e\n'
+                             'R   a/g => f/g\n'
+                             'R   h => f/h\n', chatter)
     def test_revert(self):
         self.run_bzr('init')
 
@@ -152,4 +161,3 @@
         os.chdir('revertdir')
         self.run_bzr('revert')
         os.chdir('..')
-

=== modified file 'bzrlib/tests/blackbox/test_selftest.py'
--- bzrlib/tests/blackbox/test_selftest.py	2006-12-18 09:26:03 +0000
+++ bzrlib/tests/blackbox/test_selftest.py	2007-02-07 15:38:35 +0000
@@ -262,7 +262,8 @@
         self.assertContainsRe(result[1], 'unknown command')
         err = self.run_bzr_subprocess('merge', '--merge-type', 'magic merge', 
                                       retcode=3)[1]
-        self.assertContainsRe(err, 'No known merge type magic merge')
+        self.assertContainsRe(err, 'Bad value "magic merge" for option'
+                              ' "merge-type"')
 
     def test_run_bzr_subprocess_env(self):
         """run_bzr_subprocess can set environment variables in the child only.

=== modified file 'bzrlib/tests/blackbox/test_status.py'
--- bzrlib/tests/blackbox/test_status.py	2006-11-23 18:56:25 +0000
+++ bzrlib/tests/blackbox/test_status.py	2007-02-06 14:02:32 +0000
@@ -24,7 +24,7 @@
 
 from cStringIO import StringIO
 import codecs
-from os import mkdir, chdir
+from os import mkdir, chdir, rmdir, unlink
 import sys
 from tempfile import TemporaryFile
 
@@ -76,8 +76,8 @@
             ],
             wt)
         self.assertStatus([
-                '?  bye.c\n',
-                '?  hello.c\n',
+                '?   bye.c\n',
+                '?   hello.c\n',
             ],
             wt, short=True)
 
@@ -94,9 +94,9 @@
             ],
             wt)
         self.assertStatus([
-                '?  bye.c\n',
-                '?  hello.c\n',
-                'P  pending@pending-0-0\n',
+                '?   bye.c\n',
+                '?   hello.c\n',
+                'P   pending@pending-0-0\n',
             ],
             wt, short=True)
 
@@ -174,9 +174,9 @@
                 wt)
 
         self.assertStatus([
-                '?  bye.c\n',
-                '?  dir2\n',
-                '?  directory/hello.c\n'
+                '?   bye.c\n',
+                '?   dir2\n',
+                '?   directory/hello.c\n'
                 ],
                 wt, short=True)
 
@@ -197,7 +197,7 @@
         show_tree_status(wt, specific_files=['directory'], to_file=tof,
                          short=True)
         tof.seek(0)
-        self.assertEquals(tof.readlines(), ['?  directory/hello.c\n'])
+        self.assertEquals(tof.readlines(), ['?   directory/hello.c\n'])
 
         tof = StringIO()
         show_tree_status(wt, specific_files=['dir2'], to_file=tof)
@@ -209,7 +209,7 @@
         tof = StringIO()
         show_tree_status(wt, specific_files=['dir2'], to_file=tof, short=True)
         tof.seek(0)
-        self.assertEquals(tof.readlines(), ['?  dir2\n'])
+        self.assertEquals(tof.readlines(), ['?   dir2\n'])
 
     def test_status_nonexistent_file(self):
         # files that don't exist in either the basis tree or working tree
@@ -258,32 +258,50 @@
         result = self.run_bzr("status")[0]
         self.assert_("unknown:\n  hello.txt\n" in result, result)
         result = self.run_bzr("status","--short")[0]
-        self.assert_("?  hello.txt\n" in result, result)
+        self.assertContainsRe(result, "[?]   hello.txt\n")
 
         self.run_bzr("add", "hello.txt")
         result = self.run_bzr("status")[0]
-        self.assert_("added:\n  hello.txt\n" in result, result)
+        self.assertContainsRe(result, "added:\n  hello.txt\n")
         result = self.run_bzr("status","--short")[0]
-        self.assert_("A  hello.txt\n" in result, result)
+        self.assertContainsRe(result, "[+]N  hello.txt\n")
 
         self.run_bzr("commit", "-m", "added")
         result = self.run_bzr("status", "-r", "0..1")[0]
-        self.assert_("added:\n  hello.txt\n" in result, result)
+        self.assertContainsRe(result, "added:\n  hello.txt\n")
         result = self.run_bzr("status", "--short", "-r", "0..1")[0]
-        self.assert_("A  hello.txt\n" in result, result)
+        self.assertContainsRe(result, "[+]N  hello.txt\n")
 
         self.build_tree(['world.txt'])
         result = self.run_bzr("status", "-r", "0")[0]
-        self.assert_("added:\n  hello.txt\n" \
-                     "unknown:\n  world.txt\n" in result, result)
+        self.assertContainsRe(result, "added:\n  hello.txt\n" \
+                                      "unknown:\n  world.txt\n")
         result2 = self.run_bzr("status", "-r", "0..")[0]
         self.assertEquals(result2, result)
         result = self.run_bzr("status", "--short", "-r", "0")[0]
-        self.assert_("A  hello.txt\n" \
-                     "?  world.txt\n" in result, result)
+        self.assertContainsRe(result, "[+]N  hello.txt\n" \
+                                      "[?]   world.txt\n")
         result2 = self.run_bzr("status", "--short", "-r", "0..")[0]
         self.assertEquals(result2, result)
 
+    def assertStatusContains(self, pattern):
+        """Run status, and assert it contains the given pattern"""
+        result = self.run_bzr("status", "--short")[0]
+        self.assertContainsRe(result, pattern)
+
+    def test_kind_change_short(self):
+        tree = self.make_branch_and_tree('.')
+        self.build_tree(['file'])
+        tree.add('file')
+        tree.commit('added file')
+        unlink('file')
+        self.build_tree(['file/'])
+        self.assertStatusContains('K  file => file/')
+        tree.rename_one('file', 'directory')
+        self.assertStatusContains('RK  file => directory/')
+        rmdir('directory')
+        self.assertStatusContains('RD  file => directory')
+
 
 class TestStatusEncodings(TestCaseWithTransport):
     

=== modified file 'bzrlib/tests/branch_implementations/__init__.py'
--- bzrlib/tests/branch_implementations/__init__.py	2006-10-11 23:08:27 +0000
+++ bzrlib/tests/branch_implementations/__init__.py	2007-02-06 02:33:42 +0000
@@ -42,11 +42,16 @@
         'bzrlib.tests.branch_implementations.test_bound_sftp',
         'bzrlib.tests.branch_implementations.test_branch',
         'bzrlib.tests.branch_implementations.test_break_lock',
+        'bzrlib.tests.branch_implementations.test_commit',
+        'bzrlib.tests.branch_implementations.test_hooks',
         'bzrlib.tests.branch_implementations.test_http',
+        'bzrlib.tests.branch_implementations.test_last_revision_info',
         'bzrlib.tests.branch_implementations.test_locking',
         'bzrlib.tests.branch_implementations.test_parent',
         'bzrlib.tests.branch_implementations.test_permissions',
         'bzrlib.tests.branch_implementations.test_pull',
+        'bzrlib.tests.branch_implementations.test_push',
+        'bzrlib.tests.branch_implementations.test_uncommit',
         'bzrlib.tests.branch_implementations.test_update',
         ]
     adapter = BranchTestProviderAdapter(

=== modified file 'bzrlib/tests/branch_implementations/test_bound_sftp.py'
--- bzrlib/tests/branch_implementations/test_bound_sftp.py	2007-01-05 17:12:03 +0000
+++ bzrlib/tests/branch_implementations/test_bound_sftp.py	2007-01-30 20:58:25 +0000
@@ -184,18 +184,6 @@
         self.assertEqual(['r@b-1'], wt_child.branch.revision_history())
         self.assertEqual(['r@b-1'], sftp_b_newbase.revision_history())
 
-    def test_pull_updates_both(self):
-        b_base, wt_child = self.create_branches()
-
-        wt_newchild = b_base.bzrdir.sprout('newchild').open_workingtree()
-        open('newchild/b', 'wb').write('newchild b contents\n')
-        wt_newchild.commit('newchild', rev_id='r@d-2')
-        self.assertEqual(['r@b-1', 'r@d-2'], wt_newchild.branch.revision_history())
-
-        wt_child.pull(wt_newchild.branch)
-        self.assertEqual(['r@b-1', 'r@d-2'], wt_child.branch.revision_history())
-        self.assertEqual(['r@b-1', 'r@d-2'], b_base.revision_history())
-
     def test_bind_diverged(self):
         from bzrlib.builtins import merge
 
@@ -333,25 +321,6 @@
         self.assertRaises(errors.BoundBranchConnectionFailure,
                 wt_child.commit, 'added text', rev_id='r@c-2')
 
-    def test_pull_fails(self):
-        b_base, wt_child = self.create_branches()
-
-        wt_other = wt_child.bzrdir.sprout('other').open_workingtree()
-        open('other/a', 'wb').write('new contents\n')
-        wt_other.commit('changed a', rev_id='r@d-2')
-
-        self.assertEqual(['r@b-1'], b_base.revision_history())
-        self.assertEqual(['r@b-1'], wt_child.branch.revision_history())
-        self.assertEqual(['r@b-1', 'r@d-2'], wt_other.branch.revision_history())
-
-        # this deletes the branch from memory
-        del b_base
-        # and this moves it out of the way on disk
-        os.rename('base', 'hidden_base')
-
-        self.assertRaises(errors.BoundBranchConnectionFailure,
-                wt_child.pull, wt_other.branch)
-
     # TODO: jam 20051231 We need invasive failure tests, so that we can show
     #       performance even when something fails.
 

=== modified file 'bzrlib/tests/branch_implementations/test_branch.py'
--- bzrlib/tests/branch_implementations/test_branch.py	2007-01-11 17:20:25 +0000
+++ bzrlib/tests/branch_implementations/test_branch.py	2007-02-06 02:33:42 +0000
@@ -327,17 +327,6 @@
         branch.nick = u"\u1234"
         self.assertEqual(branch.nick, u"\u1234")
 
-    def test_commit_nicks(self):
-        """Nicknames are committed to the revision"""
-        get_transport(self.get_url()).mkdir('bzr.dev')
-        wt = self.make_branch_and_tree('bzr.dev')
-        branch = wt.branch
-        branch.nick = "My happy branch"
-        wt.commit('My commit respect da nick.')
-        committed = branch.repository.get_revision(branch.last_revision())
-        self.assertEqual(committed.properties["branch-nick"], 
-                         "My happy branch")
-
     def test_create_open_branch_uses_repository(self):
         try:
             repo = self.make_repository('.', shared=True)

=== added file 'bzrlib/tests/branch_implementations/test_commit.py'
--- bzrlib/tests/branch_implementations/test_commit.py	1970-01-01 00:00:00 +0000
+++ bzrlib/tests/branch_implementations/test_commit.py	2007-02-06 02:33:42 +0000
@@ -0,0 +1,114 @@
+# Copyright (C) 2007 Canonical Ltd
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+
+"""Tests for the contract of commit on branches."""
+
+from bzrlib.branch import Branch
+from bzrlib import errors
+from bzrlib.tests.branch_implementations.test_branch import TestCaseWithBranch
+from bzrlib.revision import NULL_REVISION
+from bzrlib.transport import get_transport
+
+
+class TestCommit(TestCaseWithBranch):
+
+    def test_commit_nicks(self):
+        """Nicknames are committed to the revision"""
+        get_transport(self.get_url()).mkdir('bzr.dev')
+        wt = self.make_branch_and_tree('bzr.dev')
+        branch = wt.branch
+        branch.nick = "My happy branch"
+        wt.commit('My commit respect da nick.')
+        committed = branch.repository.get_revision(branch.last_revision())
+        self.assertEqual(committed.properties["branch-nick"], 
+                         "My happy branch")
+
+
+class TestCommitHook(TestCaseWithBranch):
+
+    def setUp(self):
+        self.hook_calls = []
+        TestCaseWithBranch.setUp(self)
+
+    def capture_post_commit_hook(self, local, master, old_revno,
+        old_revid, new_revno, new_revid):
+        """Capture post commit hook calls to self.hook_calls.
+        
+        The call is logged, as is some state of the two branches.
+        """
+        if local:
+            local_locked = local.is_locked()
+            local_base = local.base
+        else:
+            local_locked = None
+            local_base = None
+        self.hook_calls.append(
+            ('post_commit', local_base, master.base, old_revno, old_revid,
+             new_revno, new_revid, local_locked, master.is_locked()))
+
+    def test_post_commit_to_origin(self):
+        tree = self.make_branch_and_memory_tree('branch')
+        Branch.hooks.install_hook('post_commit',
+            self.capture_post_commit_hook)
+        tree.lock_write()
+        tree.add('')
+        revid = tree.commit('a revision')
+        # should have had one notification, from origin, and
+        # have the branch locked at notification time.
+        self.assertEqual([
+            ('post_commit', None, tree.branch.base, 0, NULL_REVISION, 1, revid,
+             None, True)
+            ],
+            self.hook_calls)
+        tree.unlock()
+
+    def test_post_commit_bound(self):
+        master = self.make_branch('master')
+        tree = self.make_branch_and_memory_tree('local')
+        try:
+            tree.branch.bind(master)
+        except errors.UpgradeRequired:
+            # cant bind this format, the test is irrelevant.
+            return
+        Branch.hooks.install_hook('post_commit',
+            self.capture_post_commit_hook)
+        tree.lock_write()
+        tree.add('')
+        revid = tree.commit('a revision')
+        # with a bound branch, local is set.
+        self.assertEqual([
+            ('post_commit', tree.branch.base, master.base, 0, NULL_REVISION,
+             1, revid, True, True)
+            ],
+            self.hook_calls)
+        tree.unlock()
+
+    def test_post_commit_not_to_origin(self):
+        tree = self.make_branch_and_memory_tree('branch')
+        tree.lock_write()
+        tree.add('')
+        revid = tree.commit('first revision')
+        Branch.hooks.install_hook('post_commit',
+            self.capture_post_commit_hook)
+        revid2 = tree.commit('second revision')
+        # having committed from up the branch, we should get the
+        # before and after revnos and revids correctly.
+        self.assertEqual([
+            ('post_commit', None, tree.branch.base, 1, revid, 2, revid2,
+             None, True)
+            ],
+            self.hook_calls)
+        tree.unlock()

=== added file 'bzrlib/tests/branch_implementations/test_hooks.py'
--- bzrlib/tests/branch_implementations/test_hooks.py	1970-01-01 00:00:00 +0000
+++ bzrlib/tests/branch_implementations/test_hooks.py	2007-02-06 02:33:42 +0000
@@ -0,0 +1,66 @@
+# Copyright (C) 2007 Canonical Ltd
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+
+"""Tests that branch classes implement hook callouts correctly."""
+
+from bzrlib.branch import Branch
+from bzrlib.tests import TestCaseWithMemoryTransport
+
+
+class TestSetRevisionHistoryHook(TestCaseWithMemoryTransport):
+
+    def setUp(self):
+        self.hook_calls = []
+        TestCaseWithMemoryTransport.setUp(self)
+
+    def capture_set_rh_hook(self, branch, rev_history):
+        """Capture post set-rh hook calls to self.hook_calls.
+        
+        The call is logged, as is some state of the branch.
+        """
+        self.hook_calls.append(
+            ('set_rh', branch, rev_history, branch.is_locked()))
+
+    def test_set_rh_empty_history(self):
+        branch = self.make_branch('source')
+        Branch.hooks.install_hook('set_rh', self.capture_set_rh_hook)
+        branch.set_revision_history([])
+        self.assertEqual(self.hook_calls,
+            [('set_rh', branch, [], True)])
+
+    def test_set_rh_nonempty_history(self):
+        branch = self.make_branch('source')
+        Branch.hooks.install_hook('set_rh', self.capture_set_rh_hook)
+        branch.set_revision_history([u'foo'])
+        self.assertEqual(self.hook_calls,
+            [('set_rh', branch, [u'foo'], True)])
+
+    def test_set_rh_branch_is_locked(self):
+        branch = self.make_branch('source')
+        Branch.hooks.install_hook('set_rh', self.capture_set_rh_hook)
+        branch.set_revision_history([])
+        self.assertEqual(self.hook_calls,
+            [('set_rh', branch, [], True)])
+
+    def test_set_rh_calls_all_hooks_no_errors(self):
+        branch = self.make_branch('source')
+        Branch.hooks.install_hook('set_rh', self.capture_set_rh_hook)
+        Branch.hooks.install_hook('set_rh', self.capture_set_rh_hook)
+        branch.set_revision_history([])
+        self.assertEqual(self.hook_calls,
+            [('set_rh', branch, [], True),
+             ('set_rh', branch, [], True),
+            ])

=== added file 'bzrlib/tests/branch_implementations/test_last_revision_info.py'
--- bzrlib/tests/branch_implementations/test_last_revision_info.py	1970-01-01 00:00:00 +0000
+++ bzrlib/tests/branch_implementations/test_last_revision_info.py	2007-02-01 13:33:45 +0000
@@ -0,0 +1,35 @@
+# Copyright (C) 2004, 2005, 2007 Canonical Ltd
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+
+"""Tests for branch.last_revision_info."""
+
+from bzrlib.revision import NULL_REVISION
+from bzrlib.tests import TestCaseWithTransport
+
+
+class TestLastRevisionInfo(TestCaseWithTransport):
+
+    def test_empty_branch(self):
+        # on an empty branch we want (0, NULL_REVISION)
+        branch = self.make_branch('branch')
+        self.assertEqual((0, NULL_REVISION), branch.last_revision_info())
+    
+    def test_non_empty_branch(self):
+        # after the second commit we want (2, 'second-revid')
+        tree = self.make_branch_and_tree('branch')
+        tree.commit('1st post')
+        revid = tree.commit('2st post', allow_pointless=True)
+        self.assertEqual((2, revid), tree.branch.last_revision_info())

=== modified file 'bzrlib/tests/branch_implementations/test_pull.py'
--- bzrlib/tests/branch_implementations/test_pull.py	2006-10-11 23:08:27 +0000
+++ bzrlib/tests/branch_implementations/test_pull.py	2007-02-06 02:33:42 +0000
@@ -19,11 +19,13 @@
 import os
 
 from bzrlib.branch import Branch
-from bzrlib.osutils import abspath, realpath
-from bzrlib.tests import TestCaseWithTransport
-
-
-class TestPull(TestCaseWithTransport):
+from bzrlib import errors
+from bzrlib.memorytree import MemoryTree
+from bzrlib.revision import NULL_REVISION
+from bzrlib.tests.branch_implementations.test_branch import TestCaseWithBranch
+
+
+class TestPull(TestCaseWithBranch):
 
     def test_pull_convergence_simple(self):
         # when revisions are pulled, the left-most accessible parents must 
@@ -53,3 +55,106 @@
         parent.commit('merge other', rev_id='P2')
         mine.pull(parent.branch)
         self.assertEqual(['P1', 'P2'], mine.branch.revision_history())
+
+    def test_pull_updates_checkout_and_master(self):
+        """Pulling into a checkout updates the checkout and the master branch"""
+        master_tree = self.make_branch_and_tree('master')
+        rev1 = master_tree.commit('master')
+        checkout = master_tree.branch.create_checkout('checkout')
+
+        other = master_tree.branch.bzrdir.sprout('other').open_workingtree()
+        rev2 = other.commit('other commit')
+        # now pull, which should update both checkout and master.
+        checkout.branch.pull(other.branch)
+        self.assertEqual([rev1, rev2], checkout.branch.revision_history())
+        self.assertEqual([rev1, rev2], master_tree.branch.revision_history())
+
+    def test_pull_raises_specific_error_on_master_connection_error(self):
+        master_tree = self.make_branch_and_tree('master')
+        checkout = master_tree.branch.create_checkout('checkout')
+        other = master_tree.branch.bzrdir.sprout('other').open_workingtree()
+        # move the branch out of the way on disk to cause a connection
+        # error.
+        os.rename('master', 'master_gone')
+        # try to pull, which should raise a BoundBranchConnectionFailure.
+        self.assertRaises(errors.BoundBranchConnectionFailure,
+                checkout.branch.pull, other.branch)
+
+
+class TestPullHook(TestCaseWithBranch):
+
+    def setUp(self):
+        self.hook_calls = []
+        TestCaseWithBranch.setUp(self)
+
+    def capture_post_pull_hook(self, source, local, master, old_revno,
+        old_revid, new_revno, new_revid):
+        """Capture post pull hook calls to self.hook_calls.
+        
+        The call is logged, as is some state of the two branches.
+        """
+        if local:
+            local_locked = local.is_locked()
+            local_base = local.base
+        else:
+            local_locked = None
+            local_base = None
+        self.hook_calls.append(
+            ('post_pull', source, local_base, master.base, old_revno, old_revid,
+             new_revno, new_revid, source.is_locked(), local_locked,
+             master.is_locked()))
+
+    def test_post_pull_empty_history(self):
+        target = self.make_branch('target')
+        source = self.make_branch('source')
+        Branch.hooks.install_hook('post_pull', self.capture_post_pull_hook)
+        target.pull(source)
+        # with nothing there we should still get a notification, and
+        # have both branches locked at the notification time.
+        self.assertEqual([
+            ('post_pull', source, None, target.base, 0, NULL_REVISION,
+             0, NULL_REVISION, True, None, True)
+            ],
+            self.hook_calls)
+
+    def test_post_pull_bound_branch(self):
+        # pulling to a bound branch should pass in the master branch to the
+        # hook, allowing the correct number of emails to be sent, while still
+        # allowing hooks that want to modify the target to do so to both 
+        # instances.
+        target = self.make_branch('target')
+        local = self.make_branch('local')
+        try:
+            local.bind(target)
+        except errors.UpgradeRequired:
+            # cant bind this format, the test is irrelevant.
+            return
+        source = self.make_branch('source')
+        Branch.hooks.install_hook('post_pull', self.capture_post_pull_hook)
+        local.pull(source)
+        # with nothing there we should still get a notification, and
+        # have both branches locked at the notification time.
+        self.assertEqual([
+            ('post_pull', source, local.base, target.base, 0, NULL_REVISION,
+             0, NULL_REVISION, True, True, True)
+            ],
+            self.hook_calls)
+
+    def test_post_pull_nonempty_history(self):
+        target = self.make_branch_and_memory_tree('target')
+        target.lock_write()
+        target.add('')
+        rev1 = target.commit('rev 1')
+        target.unlock()
+        sourcedir = target.bzrdir.clone(self.get_url('source'))
+        source = MemoryTree.create_on_branch(sourcedir.open_branch())
+        rev2 = source.commit('rev 2')
+        Branch.hooks.install_hook('post_pull', self.capture_post_pull_hook)
+        target.branch.pull(source.branch)
+        # with nothing there we should still get a notification, and
+        # have both branches locked at the notification time.
+        self.assertEqual([
+            ('post_pull', source.branch, None, target.branch.base, 1, rev1,
+             2, rev2, True, None, True)
+            ],
+            self.hook_calls)

=== added file 'bzrlib/tests/branch_implementations/test_push.py'
--- bzrlib/tests/branch_implementations/test_push.py	1970-01-01 00:00:00 +0000
+++ bzrlib/tests/branch_implementations/test_push.py	2007-02-06 02:33:42 +0000
@@ -0,0 +1,170 @@
+# Copyright (C) 2004, 2005, 2007 Canonical Ltd
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+
+"""Tests for branch.push behaviour."""
+
+import os
+
+from bzrlib.branch import Branch
+from bzrlib import errors
+from bzrlib.memorytree import MemoryTree
+from bzrlib.revision import NULL_REVISION
+from bzrlib.tests.branch_implementations.test_branch import TestCaseWithBranch
+
+
+class TestPush(TestCaseWithBranch):
+
+    def test_push_convergence_simple(self):
+        # when revisions are pushed, the left-most accessible parents must 
+        # become the revision-history.
+        mine = self.make_branch_and_tree('mine')
+        mine.commit('1st post', rev_id='P1', allow_pointless=True)
+        other = mine.bzrdir.sprout('other').open_workingtree()
+        other.commit('my change', rev_id='M1', allow_pointless=True)
+        mine.merge_from_branch(other.branch)
+        mine.commit('merge my change', rev_id='P2')
+        mine.branch.push(other.branch)
+        self.assertEqual(['P1', 'P2'], other.branch.revision_history())
+
+    def test_push_merged_indirect(self):
+        # it should be possible to do a push from one branch into another
+        # when the tip of the target was merged into the source branch
+        # via a third branch - so its buried in the ancestry and is not
+        # directly accessible.
+        mine = self.make_branch_and_tree('mine')
+        mine.commit('1st post', rev_id='P1', allow_pointless=True)
+        target = mine.bzrdir.sprout('target').open_workingtree()
+        target.commit('my change', rev_id='M1', allow_pointless=True)
+        other = mine.bzrdir.sprout('other').open_workingtree()
+        other.merge_from_branch(target.branch)
+        other.commit('merge my change', rev_id='O2')
+        mine.merge_from_branch(other.branch)
+        mine.commit('merge other', rev_id='P2')
+        mine.branch.push(target.branch)
+        self.assertEqual(['P1', 'P2'], target.branch.revision_history())
+
+    def test_push_to_checkout_updates_master(self):
+        """Pushing into a checkout updates the checkout and the master branch"""
+        master_tree = self.make_branch_and_tree('master')
+        checkout = self.make_branch_and_tree('checkout')
+        try:
+            checkout.branch.bind(master_tree.branch)
+        except errors.UpgradeRequired:
+            # cant bind this format, the test is irrelevant.
+            return
+        rev1 = checkout.commit('master')
+
+        other = master_tree.branch.bzrdir.sprout('other').open_workingtree()
+        rev2 = other.commit('other commit')
+        # now push, which should update both checkout and master.
+        other.branch.push(checkout.branch)
+        self.assertEqual([rev1, rev2], checkout.branch.revision_history())
+        self.assertEqual([rev1, rev2], master_tree.branch.revision_history())
+
+    def test_push_raises_specific_error_on_master_connection_error(self):
+        master_tree = self.make_branch_and_tree('master')
+        checkout = self.make_branch_and_tree('checkout')
+        try:
+            checkout.branch.bind(master_tree.branch)
+        except errors.UpgradeRequired:
+            # cant bind this format, the test is irrelevant.
+            return
+        other = master_tree.branch.bzrdir.sprout('other').open_workingtree()
+        # move the branch out of the way on disk to cause a connection
+        # error.
+        os.rename('master', 'master_gone')
+        # try to push, which should raise a BoundBranchConnectionFailure.
+        self.assertRaises(errors.BoundBranchConnectionFailure,
+                other.branch.push, checkout.branch)
+
+
+class TestPushHook(TestCaseWithBranch):
+
+    def setUp(self):
+        self.hook_calls = []
+        TestCaseWithBranch.setUp(self)
+
+    def capture_post_push_hook(self, source, local, master, old_revno,
+        old_revid, new_revno, new_revid):
+        """Capture post push hook calls to self.hook_calls.
+        
+        The call is logged, as is some state of the two branches.
+        """
+        if local:
+            local_locked = local.is_locked()
+            local_base = local.base
+        else:
+            local_locked = None
+            local_base = None
+        self.hook_calls.append(
+            ('post_push', source, local_base, master.base, old_revno, old_revid,
+             new_revno, new_revid, source.is_locked(), local_locked,
+             master.is_locked()))
+
+    def test_post_push_empty_history(self):
+        target = self.make_branch('target')
+        source = self.make_branch('source')
+        Branch.hooks.install_hook('post_push', self.capture_post_push_hook)
+        source.push(target)
+        # with nothing there we should still get a notification, and
+        # have both branches locked at the notification time.
+        self.assertEqual([
+            ('post_push', source, None, target.base, 0, NULL_REVISION,
+             0, NULL_REVISION, True, None, True)
+            ],
+            self.hook_calls)
+
+    def test_post_push_bound_branch(self):
+        # pushing to a bound branch should pass in the master branch to the
+        # hook, allowing the correct number of emails to be sent, while still
+        # allowing hooks that want to modify the target to do so to both 
+        # instances.
+        target = self.make_branch('target')
+        local = self.make_branch('local')
+        try:
+            local.bind(target)
+        except errors.UpgradeRequired:
+            # cant bind this format, the test is irrelevant.
+            return
+        source = self.make_branch('source')
+        Branch.hooks.install_hook('post_push', self.capture_post_push_hook)
+        source.push(local)
+        # with nothing there we should still get a notification, and
+        # have both branches locked at the notification time.
+        self.assertEqual([
+            ('post_push', source, local.base, target.base, 0, NULL_REVISION,
+             0, NULL_REVISION, True, True, True)
+            ],
+            self.hook_calls)
+
+    def test_post_push_nonempty_history(self):
+        target = self.make_branch_and_memory_tree('target')
+        target.lock_write()
+        target.add('')
+        rev1 = target.commit('rev 1')
+        target.unlock()
+        sourcedir = target.bzrdir.clone(self.get_url('source'))
+        source = MemoryTree.create_on_branch(sourcedir.open_branch())
+        rev2 = source.commit('rev 2')
+        Branch.hooks.install_hook('post_push', self.capture_post_push_hook)
+        source.branch.push(target.branch)
+        # with nothing there we should still get a notification, and
+        # have both branches locked at the notification time.
+        self.assertEqual([
+            ('post_push', source.branch, None, target.branch.base, 1, rev1,
+             2, rev2, True, None, True)
+            ],
+            self.hook_calls)

=== added file 'bzrlib/tests/branch_implementations/test_uncommit.py'
--- bzrlib/tests/branch_implementations/test_uncommit.py	1970-01-01 00:00:00 +0000
+++ bzrlib/tests/branch_implementations/test_uncommit.py	2007-02-06 02:33:42 +0000
@@ -0,0 +1,108 @@
+# Copyright (C) 2007 Canonical Ltd
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+
+"""Tests for the contract of uncommit on branches.
+
+Note that uncommit currently is not a branch method; it should be.
+"""
+
+from bzrlib.branch import Branch
+from bzrlib import errors
+from bzrlib.tests.branch_implementations.test_branch import TestCaseWithBranch
+from bzrlib.uncommit import uncommit
+
+
+class TestUncommitHook(TestCaseWithBranch):
+
+    def setUp(self):
+        self.hook_calls = []
+        TestCaseWithBranch.setUp(self)
+
+    def capture_post_uncommit_hook(self, local, master, old_revno,
+        old_revid, new_revno, new_revid):
+        """Capture post uncommit hook calls to self.hook_calls.
+        
+        The call is logged, as is some state of the two branches.
+        """
+        if local:
+            local_locked = local.is_locked()
+            local_base = local.base
+        else:
+            local_locked = None
+            local_base = None
+        self.hook_calls.append(
+            ('post_uncommit', local_base, master.base, old_revno, old_revid,
+             new_revno, new_revid, local_locked, master.is_locked()))
+
+    def test_post_uncommit_to_origin(self):
+        tree = self.make_branch_and_memory_tree('branch')
+        tree.lock_write()
+        tree.add('')
+        revid = tree.commit('a revision')
+        tree.unlock()
+        Branch.hooks.install_hook('post_uncommit',
+            self.capture_post_uncommit_hook)
+        uncommit(tree.branch)
+        # with nothing left we should still get a notification, and
+        # have the branch locked at notification time.
+        self.assertEqual([
+            ('post_uncommit', None, tree.branch.base, 1, revid,
+             0, None, None, True)
+            ],
+            self.hook_calls)
+
+    def test_post_uncommit_bound(self):
+        master = self.make_branch('master')
+        tree = self.make_branch_and_memory_tree('local')
+        try:
+            tree.branch.bind(master)
+        except errors.UpgradeRequired:
+            # cant bind this format, the test is irrelevant.
+            return
+        tree.lock_write()
+        tree.add('')
+        revid = tree.commit('a revision')
+        tree.unlock()
+        Branch.hooks.install_hook('post_uncommit',
+            self.capture_post_uncommit_hook)
+        uncommit(tree.branch)
+        # with nothing left we should still get a notification, and
+        # have the branch locked at notification time.
+        self.assertEqual([
+            ('post_uncommit', tree.branch.base, master.base, 1, revid,
+             0, None, True, True)
+            ],
+            self.hook_calls)
+
+    def test_post_uncommit_not_to_origin(self):
+        tree = self.make_branch_and_memory_tree('branch')
+        tree.lock_write()
+        tree.add('')
+        revid = tree.commit('first revision')
+        revid2 = tree.commit('second revision')
+        revid3 = tree.commit('third revision')
+        tree.unlock()
+        Branch.hooks.install_hook('post_uncommit',
+            self.capture_post_uncommit_hook)
+        uncommit(tree.branch, revno=2)
+        # having uncommitted from up the branch, we should get the
+        # before and after revnos and revids correctly.
+        self.assertEqual([
+            ('post_uncommit', None, tree.branch.base, 3, revid3,
+             1, revid, None, True)
+            ],
+            self.hook_calls)
+

=== modified file 'bzrlib/tests/interrepository_implementations/test_interrepository.py'
--- bzrlib/tests/interrepository_implementations/test_interrepository.py	2007-02-06 06:27:24 +0000
+++ bzrlib/tests/interrepository_implementations/test_interrepository.py	2007-02-13 05:22:39 +0000
@@ -97,6 +97,15 @@
     raise
 
 
+def check_repo_format_for_funky_id_on_win32(repo):
+    if sys.platform == 'win32':
+        if isinstance(repo, (repository.AllInOneRepository,
+                             repository.WeaveMetaDirRepository)):
+            raise TestSkipped("funky chars does not permitted"
+                              " on this platform in repository"
+                              " %s" % repo.__class__.__name__)
+
+
 class TestInterRepository(TestCaseWithInterRepository):
 
     def test_interrepository_get_returns_correct_optimiser(self):
@@ -188,6 +197,9 @@
 
     def test_fetch_funky_file_id(self):
         from_tree = self.make_branch_and_tree('tree')
+        if sys.platform == 'win32':
+            from_repo = from_tree.branch.repository
+            check_repo_format_for_funky_id_on_win32(from_repo)
         self.build_tree(['tree/filename'])
         from_tree.add('filename', 'funky-chars<>%&;"\'')
         from_tree.commit('commit filename')
@@ -197,6 +209,9 @@
     def test_fetch_no_inventory_revision(self):
         """Old inventories lack revision_ids, so simulate this"""
         from_tree = self.make_branch_and_tree('tree')
+        if sys.platform == 'win32':
+            from_repo = from_tree.branch.repository
+            check_repo_format_for_funky_id_on_win32(from_repo)
         self.build_tree(['tree/filename'])
         from_tree.add('filename', 'funky-chars<>%&;"\'')
         from_tree.commit('commit filename')

=== modified file 'bzrlib/tests/repository_implementations/__init__.py'
--- bzrlib/tests/repository_implementations/__init__.py	2007-02-07 12:41:45 +0000
+++ bzrlib/tests/repository_implementations/__init__.py	2007-02-13 05:22:39 +0000
@@ -50,6 +50,7 @@
         'bzrlib.tests.repository_implementations.test_reconcile',
         'bzrlib.tests.repository_implementations.test_repository',
         'bzrlib.tests.repository_implementations.test_revision',
+        'bzrlib.tests.repository_implementations.test_statistics',
         ]
     registry = repository.format_registry
     all_formats = [registry.get(k) for k in registry.keys()]

=== added file 'bzrlib/tests/repository_implementations/test_statistics.py'
--- bzrlib/tests/repository_implementations/test_statistics.py	1970-01-01 00:00:00 +0000
+++ bzrlib/tests/repository_implementations/test_statistics.py	2007-02-03 10:56:04 +0000
@@ -0,0 +1,93 @@
+# Copyright (C) 2007 Canonical Ltd
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+
+"""Tests for repository statistic-gathering apis."""
+
+from bzrlib.tests.repository_implementations.test_repository import TestCaseWithRepository
+
+
+class TestGatherStats(TestCaseWithRepository):
+
+    def check_stats_has_size(self, stats):
+        """Check that stats has a reasonable size entry."""
+        # actual disk size varies from implementation to implementation,
+        # but they should all provide it on their native transport.
+        self.assertTrue('size' in stats)
+        # and it should be a number
+        self.assertIsInstance(stats['size'], (int, long))
+        # and now remove it to make other assertions work without variation.
+        del stats['size']
+
+    def test_gather_stats(self):
+        """First smoke test covering the refactoring into the Repository api."""
+        tree = self.make_branch_and_memory_tree('.')
+        tree.lock_write()
+        tree.add('')
+        # three commits: one to be included by reference, one to be 
+        # requested, and one to be in the repository but [mostly] ignored.
+        rev1 = tree.commit('first post', committer='person 1',
+            timestamp=1170491381, timezone=0)
+        rev2 = tree.commit('second post', committer='person 2',
+            timestamp=1171491381, timezone=0)
+        rev3 = tree.commit('third post', committer='person 3',
+            timestamp=1172491381, timezone=0)
+        tree.unlock()
+        # now, in the same repository, asking for stats with/without the 
+        # committers flag generates the same date information.
+        stats = tree.branch.repository.gather_stats(rev2, committers=False)
+        self.check_stats_has_size(stats)
+        self.assertEqual({
+            'firstrev': (1170491381.0, 0),
+            'latestrev': (1171491381.0, 0),
+            'revisions': 3,
+            },
+            stats)
+        stats = tree.branch.repository.gather_stats(rev2, committers=True)
+        self.check_stats_has_size(stats)
+        self.assertEqual({
+            'committers': 2,
+            'firstrev': (1170491381.0, 0),
+            'latestrev': (1171491381.0, 0),
+            'revisions': 3,
+            },
+            stats)
+
+    def test_gather_stats_norevid_gets_size(self):
+        """Without a revid, repository size is still gathered."""
+        tree = self.make_branch_and_memory_tree('.')
+        tree.lock_write()
+        tree.add('')
+        # put something in the repository, because zero-size is borink.
+        rev1 = tree.commit('first post')
+        tree.unlock()
+        # now ask for global repository stats.
+        stats = tree.branch.repository.gather_stats()
+        self.check_stats_has_size(stats)
+        self.assertEqual({
+            'revisions': 1
+            },
+            stats)
+
+    def test_gather_stats_empty_repo(self):
+        """An empty repository still has size and revisions."""
+        tree = self.make_branch_and_memory_tree('.')
+        # now ask for global repository stats.
+        stats = tree.branch.repository.gather_stats()
+        self.check_stats_has_size(stats)
+        self.assertEqual({
+            'revisions': 0
+            },
+            stats)

=== modified file 'bzrlib/tests/test_annotate.py'
--- bzrlib/tests/test_annotate.py	2006-12-17 18:57:05 +0000
+++ bzrlib/tests/test_annotate.py	2007-01-29 21:11:28 +0000
@@ -101,6 +101,17 @@
 class TestAnnotate(tests.TestCaseWithTransport):
 
     def create_merged_trees(self):
+        """create 2 trees with merges between them.
+
+        rev-1 --+
+         |      |
+        rev-2  rev-1_1_1
+         |      |
+         +------+
+         |
+        rev-3
+        """
+
         tree1 = self.make_branch_and_tree('tree1')
         self.build_tree_contents([('tree1/a', 'first\n')])
         tree1.add(['a'], ['a-id'])
@@ -132,11 +143,33 @@
         return tree1, tree2
 
     def create_deeply_merged_trees(self):
+        """Create some trees with a more complex merge history.
+
+        rev-1 --+
+         |      |
+        rev-2  rev-1_1_1 --+
+         |      |          |
+         +------+          |
+         |      |          |
+        rev-3  rev-1_1_2  rev-1_1_1_1_1 --+
+         |      |          |              |
+         +------+          |              |
+         |                 |              |
+        rev-4             rev-1_1_1_1_2  rev-1_1_1_1_1_1_1
+         |                 |              |
+         +-----------------+              |
+         |                                |
+        rev-5                             |
+         |                                |
+         +--------------------------------+
+         |
+        rev-6
+        """
         tree1, tree2 = self.create_merged_trees()
 
         tree3 = tree2.bzrdir.clone('tree3').open_workingtree()
 
-        tree2.commit('noop', rev_id='rev-1.1.2')
+        tree2.commit('noop', rev_id='rev-1_1_2')
         self.assertEqual(0, tree1.merge_from_branch(tree2.branch))
         tree1.commit('noop merge', rev_id='rev-4')
 
@@ -147,7 +180,7 @@
 
         tree4 = tree3.bzrdir.clone('tree4').open_workingtree()
 
-        tree3.commit('noop', rev_id='rev-1.1.1.1.2',
+        tree3.commit('noop', rev_id='rev-1_1_1_1_2',
                      committer='jerry@foo.com',
                      timestamp=1166046004.00, timezone=0)
         self.assertEqual(0, tree1.merge_from_branch(tree3.branch))
@@ -221,7 +254,25 @@
                              '1.1.1.1.1.1.1 george@foo.com 20061213 | fifth\n'
                              '1.1.1.1.1.1.1 george@foo.com 20061213 | sixth\n',
                              sio.getvalue())
-    
+
+    def test_annotate_uses_branch_context(self):
+        """Dotted revnos should use the Branch context.
+
+        When annotating a non-mainline revision, the annotation should still
+        use dotted revnos from the mainline.
+        """
+        tree1 = self.create_deeply_merged_trees()
+
+        sio = StringIO()
+        annotate.annotate_file(tree1.branch, 'rev-1_1_1_1_1_1_1', 'a-id',
+                               to_file=sio, verbose=False, full=False)
+        self.assertEqualDiff('1            joe@foo | first\n'
+                             '1.1.1        barry@f | third\n'
+                             '1.1.1.1.1    jerry@f | fourth\n'
+                             '1.1.1.1.1.1> george@ | fifth\n'
+                             '                     | sixth\n',
+                             sio.getvalue())
+
     def test_annotate_show_ids(self):
         tree1 = self.create_deeply_merged_trees()
 

=== modified file 'bzrlib/tests/test_branch.py'
--- bzrlib/tests/test_branch.py	2006-09-07 23:31:28 +0000
+++ bzrlib/tests/test_branch.py	2007-02-06 02:33:42 +0000
@@ -32,6 +32,7 @@
                            BzrDir, BzrDirFormat)
 from bzrlib.errors import (NotBranchError,
                            UnknownFormatError,
+                           UnknownHook,
                            UnsupportedFormatError,
                            )
 
@@ -162,3 +163,31 @@
         self.assertEqual(made_branch.base, target_branch.base)
         opened_branch = branch_dir.open_branch()
         self.assertEqual(opened_branch.base, target_branch.base)
+
+
+class TestHooks(TestCase):
+
+    def test_constructor(self):
+        """Check that creating a BranchHooks instance has the right defaults."""
+        hooks = bzrlib.branch.BranchHooks()
+        self.assertTrue("set_rh" in hooks, "set_rh not in %s" % hooks)
+        self.assertTrue("post_push" in hooks, "post_push not in %s" % hooks)
+        self.assertTrue("post_commit" in hooks, "post_commit not in %s" % hooks)
+        self.assertTrue("post_pull" in hooks, "post_pull not in %s" % hooks)
+        self.assertTrue("post_uncommit" in hooks, "post_uncommit not in %s" % hooks)
+
+    def test_installed_hooks_are_BranchHooks(self):
+        """The installed hooks object should be a BranchHooks."""
+        # the installed hooks are saved in self._preserved_hooks.
+        self.assertIsInstance(self._preserved_hooks, bzrlib.branch.BranchHooks)
+
+    def test_install_hook_raises_unknown_hook(self):
+        """install_hook should raise UnknownHook if a hook is unknown."""
+        hooks = bzrlib.branch.BranchHooks()
+        self.assertRaises(UnknownHook, hooks.install_hook, 'silly', None)
+
+    def test_install_hook_appends_known_hook(self):
+        """install_hook should append the callable for known hooks."""
+        hooks = bzrlib.branch.BranchHooks()
+        hooks.install_hook('set_rh', None)
+        self.assertEqual(hooks['set_rh'], [None])

=== modified file 'bzrlib/tests/test_commit.py'
--- bzrlib/tests/test_commit.py	2006-11-28 19:19:15 +0000
+++ bzrlib/tests/test_commit.py	2007-02-06 14:52:16 +0000
@@ -21,6 +21,8 @@
 from bzrlib import (
     errors,
     lockdir,
+    osutils,
+    tests,
     )
 from bzrlib.branch import Branch
 from bzrlib.bzrdir import BzrDir, BzrDirMetaFormat1
@@ -552,6 +554,51 @@
         timestamp_1ms = round(timestamp, 3)
         self.assertEqual(timestamp_1ms, timestamp)
 
+    def test_commit_kind_changes(self):
+        if not osutils.has_symlinks():
+            raise tests.TestSkipped('Test requires symlink support')
+        tree = self.make_branch_and_tree('.')
+        os.symlink('target', 'name')
+        tree.add('name', 'a-file-id')
+        tree.commit('Added a symlink')
+        self.assertEqual('symlink', tree.basis_tree().kind('a-file-id'))
+
+        os.unlink('name')
+        self.build_tree(['name'])
+        tree.commit('Changed symlink to file')
+        self.assertEqual('file', tree.basis_tree().kind('a-file-id'))
+
+        os.unlink('name')
+        os.symlink('target', 'name')
+        tree.commit('file to symlink')
+        self.assertEqual('symlink', tree.basis_tree().kind('a-file-id'))
+
+        os.unlink('name')
+        os.mkdir('name')
+        tree.commit('symlink to directory')
+        self.assertEqual('directory', tree.basis_tree().kind('a-file-id'))
+
+        os.rmdir('name')
+        os.symlink('target', 'name')
+        tree.commit('directory to symlink')
+        self.assertEqual('symlink', tree.basis_tree().kind('a-file-id'))
+
+        # prepare for directory <-> file tests
+        os.unlink('name')
+        os.mkdir('name')
+        tree.commit('symlink to directory')
+        self.assertEqual('directory', tree.basis_tree().kind('a-file-id'))
+
+        os.rmdir('name')
+        self.build_tree(['name'])
+        tree.commit('Changed directory to file')
+        self.assertEqual('file', tree.basis_tree().kind('a-file-id'))
+
+        os.unlink('name')
+        os.mkdir('name')
+        tree.commit('file to directory')
+        self.assertEqual('directory', tree.basis_tree().kind('a-file-id'))
+
     def test_commit_unversioned_specified(self):
         """Commit should raise if specified files isn't in basis or worktree"""
         tree = self.make_branch_and_tree('.')

=== modified file 'bzrlib/tests/test_decorators.py'
--- bzrlib/tests/test_decorators.py	2006-07-28 16:05:23 +0000
+++ bzrlib/tests/test_decorators.py	2007-01-24 17:59:50 +0000
@@ -17,20 +17,40 @@
 
 """Tests for decorator functions"""
 
-from bzrlib.decorators import needs_read_lock
+import inspect
+
+from bzrlib import decorators
+from bzrlib.decorators import needs_read_lock, needs_write_lock
 from bzrlib.tests import TestCase
 
 
 class DecoratorSample(object):
     """Sample class that uses decorators.
 
-    This doesn't actually work because the class doesn't have the 
-    requiste lock_read()/unlock() methods.
+    Log when requests go through lock_read()/unlock() or lock_write()/unlock.
     """
 
+    def __init__(self):
+        self.actions = []
+
+    def lock_read(self):
+        self.actions.append('lock_read')
+
+    def lock_write(self):
+        self.actions.append('lock_write')
+
+    def unlock(self):
+        self.actions.append('unlock')
+
     @needs_read_lock
     def frob(self):
         """Frob the sample object"""
+        self.actions.append('frob')
+
+    @needs_write_lock
+    def bank(self, bar, biz=None):
+        """Bank the sample, but using bar and biz."""
+        self.actions.append(('bank', bar, biz))
 
 
 class TestDecoratorDocs(TestCase):
@@ -39,6 +59,118 @@
     def test_read_lock_passthrough(self):
         """@needs_read_lock exposes underlying name and doc."""
         sam = DecoratorSample()
-        self.assertEqual(sam.frob.__name__, 'frob')
-        self.assertEqual(sam.frob.__doc__, 
-                'Frob the sample object')
+        self.assertEqual('frob', sam.frob.__name__)
+        self.assertEqual('Frob the sample object', sam.frob.__doc__)
+
+    def test_write_lock_passthrough(self):
+        """@needs_write_lock exposes underlying name and doc."""
+        sam = DecoratorSample()
+        self.assertEqual('bank', sam.bank.__name__)
+        self.assertEqual('Bank the sample, but using bar and biz.',
+                         sam.bank.__doc__)
+
+    def test_argument_passthrough(self):
+        """Test that arguments get passed around properly."""
+        sam = DecoratorSample()
+        sam.bank('1', biz='2')
+        self.assertEqual(['lock_write',
+                          ('bank', '1', '2'),
+                          'unlock',
+                         ], sam.actions)
+
+
+class TestPrettyDecorators(TestCase):
+    """Test that pretty decorators generate nice looking wrappers."""
+
+    def get_formatted_args(self, func):
+        """Return a nicely formatted string for the arguments to a function.
+
+        This generates something like "(foo, bar=None)".
+        """
+        return inspect.formatargspec(*inspect.getargspec(func))
+
+    def test__pretty_needs_read_lock(self):
+        """Test that _pretty_needs_read_lock generates a nice wrapper."""
+
+        @decorators._pretty_needs_read_lock
+        def my_function(foo, bar, baz=None, biz=1):
+            """Just a function that supplies several arguments."""
+
+        self.assertEqual('my_function', my_function.__name__)
+        self.assertEqual('my_function_read_locked',
+                         my_function.func_code.co_name)
+        self.assertEqual('(foo, bar, baz=None, biz=1)',
+                         self.get_formatted_args(my_function))
+        self.assertEqual('Just a function that supplies several arguments.',
+                         inspect.getdoc(my_function))
+
+    def test__fast_needs_read_lock(self):
+        """Test the output of _fast_needs_read_lock."""
+
+        @decorators._fast_needs_read_lock
+        def my_function(foo, bar, baz=None, biz=1):
+            """Just a function that supplies several arguments."""
+
+        self.assertEqual('my_function', my_function.__name__)
+        self.assertEqual('read_locked', my_function.func_code.co_name)
+        self.assertEqual('(self, *args, **kwargs)',
+                         self.get_formatted_args(my_function))
+        self.assertEqual('Just a function that supplies several arguments.',
+                         inspect.getdoc(my_function))
+
+    def test__pretty_needs_write_lock(self):
+        """Test that _pretty_needs_write_lock generates a nice wrapper."""
+
+        @decorators._pretty_needs_write_lock
+        def my_function(foo, bar, baz=None, biz=1):
+            """Just a function that supplies several arguments."""
+
+        self.assertEqual('my_function', my_function.__name__)
+        self.assertEqual('my_function_write_locked',
+                         my_function.func_code.co_name)
+        self.assertEqual('(foo, bar, baz=None, biz=1)',
+                         self.get_formatted_args(my_function))
+        self.assertEqual('Just a function that supplies several arguments.',
+                         inspect.getdoc(my_function))
+
+    def test__fast_needs_write_lock(self):
+        """Test the output of _fast_needs_write_lock."""
+
+        @decorators._fast_needs_write_lock
+        def my_function(foo, bar, baz=None, biz=1):
+            """Just a function that supplies several arguments."""
+
+        self.assertEqual('my_function', my_function.__name__)
+        self.assertEqual('write_locked', my_function.func_code.co_name)
+        self.assertEqual('(self, *args, **kwargs)',
+                         self.get_formatted_args(my_function))
+        self.assertEqual('Just a function that supplies several arguments.',
+                         inspect.getdoc(my_function))
+
+    def test_use_decorators(self):
+        """Test that you can switch the type of the decorators."""
+        cur_read = decorators.needs_read_lock
+        cur_write = decorators.needs_write_lock
+        try:
+            decorators.use_fast_decorators()
+            self.assertIs(decorators._fast_needs_read_lock,
+                          decorators.needs_read_lock)
+            self.assertIs(decorators._fast_needs_write_lock,
+                          decorators.needs_write_lock)
+
+            decorators.use_pretty_decorators()
+            self.assertIs(decorators._pretty_needs_read_lock,
+                          decorators.needs_read_lock)
+            self.assertIs(decorators._pretty_needs_write_lock,
+                          decorators.needs_write_lock)
+
+            # One more switch to make sure it wasn't just good luck that the
+            # functions pointed to the correct version
+            decorators.use_fast_decorators()
+            self.assertIs(decorators._fast_needs_read_lock,
+                          decorators.needs_read_lock)
+            self.assertIs(decorators._fast_needs_write_lock,
+                          decorators.needs_write_lock)
+        finally:
+            decorators.needs_read_lock = cur_read
+            decorators.needs_write_lock = cur_write

=== added file 'bzrlib/tests/test_delta.py'
--- bzrlib/tests/test_delta.py	1970-01-01 00:00:00 +0000
+++ bzrlib/tests/test_delta.py	2007-02-06 17:12:12 +0000
@@ -0,0 +1,212 @@
+# Copyright (C) 2007 Canonical Ltd
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+
+import os
+from StringIO import StringIO
+
+from bzrlib import (
+    delta as _mod_delta,
+    inventory,
+    tests,
+    )
+
+
+class InstrumentedReporter(object):
+    def __init__(self):
+        self.calls = []
+
+    def report(self, file_id, path, versioned, renamed, modified, exe_change,
+               kind):
+        self.calls.append((file_id, path, versioned, renamed, modified,
+                           exe_change, kind))
+
+
+class TestReportChanges(tests.TestCase):
+    """Test the new change reporting infrastructure"""
+
+    def assertReport(self, expected, file_id='fid', path='path',
+                     versioned_change='unchanged', renamed=False,
+                     modified='unchanged', exe_change=False,
+                     kind=('file', 'file'), old_path=None):
+        result = []
+        def result_line(format, *args):
+            result.append(format % args)
+        inv = inventory.Inventory()
+        if old_path is not None:
+            inv.add(inventory.InventoryFile(file_id, old_path,
+                                            inv.root.file_id))
+        reporter = _mod_delta.ChangeReporter(inv, result_line)
+        reporter.report(file_id, path, versioned_change, renamed, modified,
+                         exe_change, kind)
+        self.assertEqualDiff(expected, result[0])
+
+    def test_rename(self):
+        self.assertReport('R   old => path', renamed=True, old_path='old')
+        self.assertReport('    path')
+        self.assertReport('RN  old => path', renamed=True, old_path='old',
+                          modified='created', kind=(None, 'file'))
+
+    def test_kind(self):
+        self.assertReport(' K  path => path/', modified='kind changed',
+                          kind=('file', 'directory'))
+        self.assertReport(' K  path/ => path', modified='kind changed',
+                          kind=('directory', 'file'), old_path='old')
+        self.assertReport('RK  old => path/', renamed=True,
+                          modified='kind changed',
+                          kind=('file', 'directory'), old_path='old')
+    def test_new(self):
+        self.assertReport(' N  path/', modified='created',
+                          kind=(None, 'directory'))
+        self.assertReport('+   path/', versioned_change='added',
+                          modified='unchanged', kind=(None, 'directory'))
+        self.assertReport('+   path', versioned_change='added',
+                          modified='unchanged', kind=(None, None))
+        self.assertReport('+N  path/', versioned_change='added',
+                          modified='created', kind=(None, 'directory'))
+        self.assertReport('+M  path/', versioned_change='added',
+                          modified='modified', kind=(None, 'directory'))
+        self.assertReport('+K  path => path/', versioned_change='added',
+                          modified='kind changed', kind=('file', 'directory'))
+
+    def test_removal(self):
+        self.assertReport(' D  path/', modified='deleted',
+                          kind=('directory', None), old_path='old')
+        self.assertReport('-   path/', versioned_change='removed',
+                          kind=(None, 'directory'))
+        self.assertReport('-D  path', versioned_change='removed',
+                          modified='deleted', kind=('file', 'directory'))
+
+    def test_modification(self):
+        self.assertReport(' M  path', modified='modified')
+        self.assertReport(' M* path', modified='modified', exe_change=True)
+
+    def assertChangesEqual(self,
+                           file_id='fid',
+                           path='path',
+                           content_change=False,
+                           versioned=(True, True),
+                           parent_id=('pid', 'pid'),
+                           name=('name', 'name'),
+                           kind=('file', 'file'),
+                           executable=(False, False),
+                           versioned_change='unchanged',
+                           renamed=False,
+                           modified='unchanged',
+                           exe_change=False):
+        reporter = InstrumentedReporter()
+        _mod_delta.report_changes([(file_id, path, content_change, versioned,
+            parent_id, name, kind, executable)], reporter)
+        output = reporter.calls[0]
+        self.assertEqual(file_id, output[0])
+        self.assertEqual(path, output[1])
+        self.assertEqual(versioned_change, output[2])
+        self.assertEqual(renamed, output[3])
+        self.assertEqual(modified, output[4])
+        self.assertEqual(exe_change, output[5])
+        self.assertEqual(kind, output[6])
+
+    def test_report_changes(self):
+        """Test change detection of report_changes"""
+        #Ensure no changes are detected by default
+        self.assertChangesEqual(modified='unchanged', renamed=False,
+                                versioned_change='unchanged',
+                                exe_change=False)
+        self.assertChangesEqual(modified='kind changed',
+                                kind=('file', 'directory'))
+        self.assertChangesEqual(modified='created', kind=(None, 'directory'))
+        self.assertChangesEqual(modified='deleted', kind=('directory', None))
+        self.assertChangesEqual(content_change=True, modified='modified')
+        self.assertChangesEqual(renamed=True, name=('old', 'new'))
+        self.assertChangesEqual(renamed=True,
+                                parent_id=('old-parent', 'new-parent'))
+        self.assertChangesEqual(versioned_change='added',
+                                versioned=(False, True))
+        self.assertChangesEqual(versioned_change='removed',
+                                versioned=(True, False))
+        # execute bit is only detected as "changed" if the file is and was
+        # a regular file.
+        self.assertChangesEqual(exe_change=True, executable=(True, False))
+        self.assertChangesEqual(exe_change=False, executable=(True, False),
+                                kind=('directory', 'directory'))
+        self.assertChangesEqual(exe_change=False, modified='kind changed',
+                                executable=(False, True),
+                                kind=('directory', 'file'))
+
+        # Now make sure they all work together
+        self.assertChangesEqual(versioned_change='removed',
+                                modified='deleted', versioned=(True, False),
+                                kind=('directory', None))
+        self.assertChangesEqual(versioned_change='removed',
+                                modified='created', versioned=(True, False),
+                                kind=(None, 'file'))
+        self.assertChangesEqual(versioned_change='removed',
+                                modified='modified', renamed=True,
+                                exe_change=True, versioned=(True, False),
+                                content_change=True, name=('old', 'new'),
+                                executable=(False, True))
+
+
+class TestChangesFrom (tests.TestCaseWithTransport):
+
+    def show_string(self, delta, *args,  **kwargs):
+        to_file = StringIO()
+        delta.show(to_file, *args, **kwargs)
+        return to_file.getvalue()
+
+    def test_kind_change(self):
+        """Doing a status when a file has changed kind should work"""
+        tree = self.make_branch_and_tree('.')
+        self.build_tree(['filename'])
+        tree.add('filename', 'file-id')
+        tree.commit('added filename')
+        os.unlink('filename')
+        self.build_tree(['filename/'])
+        delta = tree.changes_from(tree.basis_tree())
+        self.assertEqual([('filename', 'file-id', 'file', 'directory')],
+                         delta.kind_changed)
+        self.assertEqual([], delta.added)
+        self.assertEqual([], delta.removed)
+        self.assertEqual([], delta.renamed)
+        self.assertEqual([], delta.modified)
+        self.assertEqual([], delta.unchanged)
+        self.assertTrue(delta.has_changed())
+        self.assertTrue(delta.touches_file_id('file-id'))
+        self.assertEqual('kind changed:\n  filename (file => directory)\n',
+                         self.show_string(delta))
+        other_delta = _mod_delta.TreeDelta()
+        self.assertNotEqual(other_delta, delta)
+        other_delta.kind_changed = [('filename', 'file-id', 'file',
+                                     'symlink')]
+        self.assertNotEqual(other_delta, delta)
+        other_delta.kind_changed = [('filename', 'file-id', 'file',
+                                     'directory')]
+        self.assertEqual(other_delta, delta)
+        self.assertEqualDiff("TreeDelta(added=[], removed=[], renamed=[],"
+            " kind_changed=[(u'filename', 'file-id', 'file', 'directory')],"
+            " modified=[], unchanged=[])", repr(delta))
+        self.assertEqual('K  filename (file => directory) file-id\n',
+                         self.show_string(delta, show_ids=True,
+                         short_status=True))
+
+        tree.rename_one('filename', 'dirname')
+        delta = tree.changes_from(tree.basis_tree())
+        self.assertEqual([], delta.kind_changed)
+        # This loses the fact that kind changed, remembering it as a
+        # modification
+        self.assertEqual([('filename', 'dirname', 'file-id', 'directory',
+                           True, False)], delta.renamed)
+        self.assertTrue(delta.has_changed())
+        self.assertTrue(delta.touches_file_id('file-id'))

=== modified file 'bzrlib/tests/test_diff.py'
--- bzrlib/tests/test_diff.py	2006-11-16 18:17:59 +0000
+++ bzrlib/tests/test_diff.py	2007-01-28 18:15:53 +0000
@@ -205,7 +205,7 @@
         # Make sure external_diff doesn't fail in the current LANG
         lines = external_udiff_lines(['\x00foobar\n'], ['foo\x00bar\n'])
 
-        cmd = ['diff', '-u', 'old', 'new']
+        cmd = ['diff', '-u', '--binary', 'old', 'new']
         open('old', 'wb').write('\x00foobar\n')
         open('new', 'wb').write('foo\x00bar\n')
         pipe = subprocess.Popen(cmd, stdout=subprocess.PIPE,

=== modified file 'bzrlib/tests/test_errors.py'
--- bzrlib/tests/test_errors.py	2006-12-21 20:07:34 +0000
+++ bzrlib/tests/test_errors.py	2007-01-30 11:52:30 +0000
@@ -94,6 +94,16 @@
             "the current request that is open.",
             str(error))
 
+    def test_unknown_hook(self):
+        error = errors.UnknownHook("branch", "foo")
+        self.assertEqualDiff("The branch hook 'foo' is unknown in this version"
+            " of bzrlib.",
+            str(error))
+        error = errors.UnknownHook("tree", "bar")
+        self.assertEqualDiff("The tree hook 'bar' is unknown in this version"
+            " of bzrlib.",
+            str(error))
+
     def test_up_to_date(self):
         error = errors.UpToDateFormat(bzrdir.BzrDirFormat4())
         self.assertEqualDiff("The branch format Bazaar-NG branch, "

=== modified file 'bzrlib/tests/test_generate_docs.py'
--- bzrlib/tests/test_generate_docs.py	2007-01-02 12:40:19 +0000
+++ bzrlib/tests/test_generate_docs.py	2007-01-18 14:49:08 +0000
@@ -22,7 +22,7 @@
 
 from cStringIO import StringIO
 
-from bzrlib.tests import TestCase
+from bzrlib.tests import TestCase, TestSkipped
 
 
 class Options:
@@ -38,13 +38,19 @@
         self.options.bzr_name = 'bzr'
 
     def test_man_page(self):
-        from tools.doc_generate import autodoc_man
+        try:
+            from tools.doc_generate import autodoc_man
+        except ImportError:
+            raise TestSkipped('The package "tools" is not available to test.')
 
         autodoc_man.infogen(self.options, self.sio)
         self.assertNotEqual('', self.sio.getvalue())
 
     def test_rstx_man(self):
-        from tools.doc_generate import autodoc_rstx
+        try:
+            from tools.doc_generate import autodoc_rstx
+        except ImportError:
+            raise TestSkipped('The package "tools" is not available to test.')
 
         autodoc_rstx.infogen(self.options, self.sio)
         self.assertNotEqual('', self.sio.getvalue())

=== modified file 'bzrlib/tests/test_gpg.py'
--- bzrlib/tests/test_gpg.py	2006-10-11 23:08:27 +0000
+++ bzrlib/tests/test_gpg.py	2007-02-08 23:40:24 +0000
@@ -80,6 +80,11 @@
             ui.ui_factory.clear_term = old_clear_term
         self.assertEqual([True], clear_term_called)
 
+    def test_aborts_on_unicode(self):
+        """You can't sign Unicode text; it must be encoded first."""
+        self.assertRaises(errors.BzrBadParameterUnicode,
+                          self.assertProduces, u'foo')
+
 
 class TestDisabled(TestCase):
 

=== modified file 'bzrlib/tests/test_http.py'
--- bzrlib/tests/test_http.py	2006-12-15 02:47:54 +0000
+++ bzrlib/tests/test_http.py	2007-02-08 17:01:20 +0000
@@ -636,6 +636,57 @@
     """Tests range requests refusing server for pycurl implementation"""
 
 
+class TestHttpProxyWhiteBox(TestCase):
+    """Whitebox test proxy http authorization."""
+
+    def setUp(self):
+        TestCase.setUp(self)
+        self._old_env = {}
+
+    def tearDown(self):
+        self._restore_env()
+
+    def _set_and_capture_env_var(self, name, new_value):
+        """Set an environment variable, and reset it when finished."""
+        self._old_env[name] = osutils.set_or_unset_env(name, new_value)
+
+    def _install_env(self, env):
+        for name, value in env.iteritems():
+            self._set_and_capture_env_var(name, value)
+
+    def _restore_env(self):
+        for name, value in self._old_env.iteritems():
+            osutils.set_or_unset_env(name, value)
+
+    def _proxied_request(self):
+        from bzrlib.transport.http._urllib2_wrappers import (
+            ProxyHandler,
+            Request,
+            )
+
+        handler = ProxyHandler()
+        request = Request('GET','http://baz/buzzle')
+        handler.set_proxy(request, 'http')
+        return request
+
+    def test_empty_user(self):
+        self._install_env({'http_proxy': 'http://bar.com'})
+        request = self._proxied_request()
+        self.assertFalse(request.headers.has_key('Proxy-authorization'))
+
+    def test_empty_pass(self):
+        self._install_env({'http_proxy': 'http://joe@bar.com'})
+        request = self._proxied_request()
+        self.assertEqual('Basic ' + 'joe:'.encode('base64').strip(),
+                         request.headers['Proxy-authorization'])
+    def test_user_pass(self):
+        self._install_env({'http_proxy': 'http://joe:foo@bar.com'})
+        request = self._proxied_request()
+        self.assertEqual('Basic ' + 'joe:foo'.encode('base64').strip(),
+                         request.headers['Proxy-authorization'])
+
+
+
 class TestProxyHttpServer(object):
     """Tests proxy server.
 
@@ -655,6 +706,10 @@
     # FIXME: We don't have an https server available, so we don't
     # test https connections.
 
+    # FIXME: Once the test suite is better fitted to test
+    # authorization schemes, test proxy authorizations too (see
+    # bug #83954).
+
     def setUp(self):
         TestCaseWithTwoWebservers.setUp(self)
         self.build_tree_contents([('foo', 'contents of foo\n'),

=== modified file 'bzrlib/tests/test_lockdir.py'
--- bzrlib/tests/test_lockdir.py	2006-09-29 20:12:58 +0000
+++ bzrlib/tests/test_lockdir.py	2007-02-01 14:59:04 +0000
@@ -17,13 +17,16 @@
 """Tests for LockDir"""
 
 from cStringIO import StringIO
+import os
 from threading import Thread, Lock
 import time
 
 import bzrlib
 from bzrlib import (
     config,
+    errors,
     osutils,
+    tests,
     )
 from bzrlib.errors import (
         LockBreakMismatch,
@@ -600,3 +603,12 @@
         ld1.create()
         ld1.lock_write()
         ld1.unlock()
+
+    def test_lock_permission(self):
+        if not osutils.supports_posix_readonly():
+            raise tests.TestSkipped('Cannot induce a permission failure')
+        ld1 = self.get_lock()
+        lock_path = ld1.transport.local_abspath('test_lock')
+        os.mkdir(lock_path)
+        osutils.make_readonly(lock_path)
+        self.assertRaises(errors.PermissionDenied, ld1.attempt_lock)

=== modified file 'bzrlib/tests/test_merge.py'
--- bzrlib/tests/test_merge.py	2006-10-11 23:08:27 +0000
+++ bzrlib/tests/test_merge.py	2007-02-07 16:05:09 +0000
@@ -17,13 +17,17 @@
 import os
 from StringIO import StringIO
 
-from bzrlib import conflicts
+from bzrlib import (
+    conflicts,
+    merge as _mod_merge,
+    option,
+    )
 from bzrlib.branch import Branch
 from bzrlib.builtins import merge
 from bzrlib.conflicts import ConflictList, TextConflict
 from bzrlib.errors import UnrelatedBranches, NoCommits, BzrCommandError
 from bzrlib.merge import transform_tree, merge_inner
-from bzrlib.osutils import pathjoin
+from bzrlib.osutils import pathjoin, file_kind
 from bzrlib.revision import common_ancestor
 from bzrlib.tests import TestCaseWithTransport
 from bzrlib.trace import (enable_test_log, disable_test_log)
@@ -173,3 +177,49 @@
             conflicts.DeletingParent('Not deleting', 'b', 'b-id'),
             conflicts.UnversionedParent('Versioned directory', 'b', 'b-id')],
             tree_a.conflicts())
+
+    def test_merge_with_missing(self):
+        tree_a = self.make_branch_and_tree('tree_a')
+        self.build_tree_contents([('tree_a/file', 'content_1')])
+        tree_a.add('file')
+        tree_a.commit('commit base')
+        base_tree = tree_a.basis_tree()
+        tree_b = tree_a.bzrdir.sprout('tree_b').open_workingtree()
+        self.build_tree_contents([('tree_a/file', 'content_2')])
+        tree_a.commit('commit other')
+        other_tree = tree_a.basis_tree()
+        os.unlink('tree_b/file')
+        merge_inner(tree_b.branch, other_tree, base_tree, this_tree=tree_b)
+
+    def test_merge_kind_change(self):
+        tree_a = self.make_branch_and_tree('tree_a')
+        self.build_tree_contents([('tree_a/file', 'content_1')])
+        tree_a.add('file', 'file-id')
+        tree_a.commit('added file')
+        tree_b = tree_a.bzrdir.sprout('tree_b').open_workingtree()
+        os.unlink('tree_a/file')
+        self.build_tree(['tree_a/file/'])
+        tree_a.commit('changed file to directory')
+        tree_b.merge_from_branch(tree_a.branch)
+        self.assertEqual('directory', file_kind('tree_b/file'))
+        tree_b.revert([])
+        self.assertEqual('file', file_kind('tree_b/file'))
+        self.build_tree_contents([('tree_b/file', 'content_2')])
+        tree_b.commit('content change')
+        tree_b.merge_from_branch(tree_a.branch)
+        self.assertEqual(tree_b.conflicts(),
+                         [conflicts.ContentsConflict('file',
+                          file_id='file-id')])
+    
+    def test_merge_type_registry(self):
+        merge_type_option = option.Option.OPTIONS['merge-type']
+        self.assertFalse('merge4' in [x[0] for x in 
+                        merge_type_option.iter_switches()])
+        registry = _mod_merge.get_merge_type_registry()
+        registry.register_lazy('merge4', 'bzrlib.merge', 'Merge4Merger',
+                               'time-travelling merge')
+        self.assertTrue('merge4' in [x[0] for x in 
+                        merge_type_option.iter_switches()])
+        registry.remove('merge4')
+        self.assertFalse('merge4' in [x[0] for x in 
+                        merge_type_option.iter_switches()])

=== modified file 'bzrlib/tests/test_merge_core.py'
--- bzrlib/tests/test_merge_core.py	2006-11-02 22:48:49 +0000
+++ bzrlib/tests/test_merge_core.py	2007-01-28 18:19:32 +0000
@@ -259,6 +259,9 @@
 
     def test_contents_merge2(self):
         """Test diff3 merging"""
+        if sys.platform == 'win32':
+            raise TestSkipped("diff3 does not have --binary flag"
+                              " and therefore always fails on win32")
         try:
             self.do_contents_test(Diff3Merger)
         except NoDiff3:

=== modified file 'bzrlib/tests/test_options.py'
--- bzrlib/tests/test_options.py	2007-02-07 09:11:31 +0000
+++ bzrlib/tests/test_options.py	2007-02-13 05:22:39 +0000
@@ -160,7 +160,7 @@
 
     def test_registry_converter(self):
         options = [option.RegistryOption('format', '',
-                   bzrdir.format_registry, builtins.get_format_type)]
+                   bzrdir.format_registry, bzrdir.format_registry.make_bzrdir)]
         opts, args = self.parse(options, ['--format', 'knit'])
         self.assertIsInstance(opts.format.repository_format,
                               knitrepo.RepositoryFormatKnit1)
@@ -172,11 +172,12 @@
             repo_module='bzrlib.repofmt.knitrepo')
         registry.set_default('one')
         options = [option.RegistryOption('format', 'format help', registry,
-                   str, value_switches=True)]
+                   str, value_switches=True, title='Formats')]
         parser = option.get_optparser(dict((o.name, o) for o in options))
         value = parser.format_option_help()
         self.assertContainsRe(value, 'format.*format help')
         self.assertContainsRe(value, 'one.*one help')
+        self.assertContainsRe(value, 'Formats:\n *--format')
 
     def test_iter_switches(self):
         opt = option.Option('hello', help='fg')

=== modified file 'bzrlib/tests/test_osutils.py'
--- bzrlib/tests/test_osutils.py	2007-01-04 23:36:44 +0000
+++ bzrlib/tests/test_osutils.py	2007-02-01 14:49:53 +0000
@@ -38,6 +38,20 @@
 
 class TestOSUtils(TestCaseInTempDir):
 
+    def test_contains_whitespace(self):
+        self.failUnless(osutils.contains_whitespace(u' '))
+        self.failUnless(osutils.contains_whitespace(u'hello there'))
+        self.failUnless(osutils.contains_whitespace(u'hellothere\n'))
+        self.failUnless(osutils.contains_whitespace(u'hello\nthere'))
+        self.failUnless(osutils.contains_whitespace(u'hello\rthere'))
+        self.failUnless(osutils.contains_whitespace(u'hello\tthere'))
+
+        # \xa0 is "Non-breaking-space" which on some python locales thinks it
+        # is whitespace, but we do not.
+        self.failIf(osutils.contains_whitespace(u''))
+        self.failIf(osutils.contains_whitespace(u'hellothere'))
+        self.failIf(osutils.contains_whitespace(u'hello\xa0there'))
+
     def test_fancy_rename(self):
         # This should work everywhere
         def rename(a, b):

=== modified file 'bzrlib/tests/test_plugins.py'
--- bzrlib/tests/test_plugins.py	2006-12-29 07:53:17 +0000
+++ bzrlib/tests/test_plugins.py	2007-02-02 16:17:55 +0000
@@ -22,56 +22,16 @@
 
 import os
 from StringIO import StringIO
+import sys
 import zipfile
 
 import bzrlib.plugin
 import bzrlib.plugins
 import bzrlib.commands
 import bzrlib.help
-from bzrlib.tests import TestCaseInTempDir
+from bzrlib.tests import TestCase, TestCaseInTempDir
 from bzrlib.osutils import pathjoin, abspath
 
-class PluginTest(TestCaseInTempDir):
-    """Create an external plugin and test loading."""
-#    def test_plugin_loading(self):
-#        orig_help = self.run_bzr_captured('bzr help commands')[0]
-#        os.mkdir('plugin_test')
-#        f = open(pathjoin('plugin_test', 'myplug.py'), 'wt')
-#        f.write(PLUGIN_TEXT)
-#        f.close()
-#        newhelp = self.run_bzr_captured('bzr help commands')[0]
-#        assert newhelp.startswith('You have been overridden\n')
-#        # We added a line, but the rest should work
-#        assert newhelp[25:] == help
-#
-#        assert backtick('bzr commit -m test') == "I'm sorry dave, you can't do that\n"
-#
-#        shutil.rmtree('plugin_test')
-#
-
-#         os.environ['BZRPLUGINPATH'] = abspath('plugin_test')
-#         help = backtick('bzr help commands')
-#         assert help.find('myplug') != -1
-#         assert help.find('Just a simple test plugin.') != -1
-
-
-#         assert backtick('bzr myplug') == 'Hello from my plugin\n'
-#         assert backtick('bzr mplg') == 'Hello from my plugin\n'
-
-#         f = open(pathjoin('plugin_test', 'override.py'), 'wb')
-#         f.write("""import bzrlib, bzrlib.commands
-#     class cmd_commit(bzrlib.commands.cmd_commit):
-#         '''Commit changes into a new revision.'''
-#         def run(self, *args, **kwargs):
-#             print "I'm sorry dave, you can't do that"
-
-#     class cmd_help(bzrlib.commands.cmd_help):
-#         '''Show help on a command or other topic.'''
-#         def run(self, *args, **kwargs):
-#             print "You have been overridden"
-#             bzrlib.commands.cmd_help.run(self, *args, **kwargs)
-
-#         """
 
 PLUGIN_TEXT = """\
 import bzrlib.commands
@@ -84,21 +44,21 @@
 
 # TODO: Write a test for plugin decoration of commands.
 
-class TestOneNamedPluginOnly(TestCaseInTempDir):
+class TestLoadingPlugins(TestCaseInTempDir):
 
     activeattributes = {}
 
     def test_plugins_with_the_same_name_are_not_loaded(self):
-        # This test tests that having two plugins in different
-        # directories does not result in both being loaded.
-        # get a file name we can use which is also a valid attribute
-        # for accessing in activeattributes. - we cannot give import parameters.
+        # This test tests that having two plugins in different directories does
+        # not result in both being loaded when they have the same name.  get a
+        # file name we can use which is also a valid attribute for accessing in
+        # activeattributes. - we cannot give import parameters.
         tempattribute = "0"
         self.failIf(tempattribute in self.activeattributes)
         # set a place for the plugins to record their loading, and at the same
         # time validate that the location the plugins should record to is
         # valid and correct.
-        bzrlib.tests.test_plugins.TestOneNamedPluginOnly.activeattributes \
+        bzrlib.tests.test_plugins.TestLoadingPlugins.activeattributes \
             [tempattribute] = []
         self.failUnless(tempattribute in self.activeattributes)
         # create two plugin directories
@@ -106,13 +66,51 @@
         os.mkdir('second')
         # write a plugin that will record when its loaded in the 
         # tempattribute list.
-        template = ("from bzrlib.tests.test_plugins import TestOneNamedPluginOnly\n"
-                    "TestOneNamedPluginOnly.activeattributes[%r].append('%s')\n")
+        template = ("from bzrlib.tests.test_plugins import TestLoadingPlugins\n"
+                    "TestLoadingPlugins.activeattributes[%r].append('%s')\n")
         print >> file(os.path.join('first', 'plugin.py'), 'w'), template % (tempattribute, 'first')
         print >> file(os.path.join('second', 'plugin.py'), 'w'), template % (tempattribute, 'second')
         try:
-            bzrlib.plugin.load_from_dirs(['first', 'second'])
-            self.assertEqual(['first'], self.activeattributes[tempattribute])
+            bzrlib.plugin.load_from_path(['first', 'second'])
+            self.assertEqual(['first'], self.activeattributes[tempattribute])
+        finally:
+            # remove the plugin 'plugin'
+            del self.activeattributes[tempattribute]
+            if getattr(bzrlib.plugins, 'plugin', None):
+                del bzrlib.plugins.plugin
+        self.failIf(getattr(bzrlib.plugins, 'plugin', None))
+
+    def test_plugins_from_different_dirs_can_demand_load(self):
+        # This test tests that having two plugins in different
+        # directories with different names allows them both to be loaded, when
+        # we do a direct import statement.
+        # Determine a file name we can use which is also a valid attribute
+        # for accessing in activeattributes. - we cannot give import parameters.
+        tempattribute = "different-dirs"
+        self.failIf(tempattribute in self.activeattributes)
+        # set a place for the plugins to record their loading, and at the same
+        # time validate that the location the plugins should record to is
+        # valid and correct.
+        bzrlib.tests.test_plugins.TestLoadingPlugins.activeattributes \
+            [tempattribute] = []
+        self.failUnless(tempattribute in self.activeattributes)
+        # create two plugin directories
+        os.mkdir('first')
+        os.mkdir('second')
+        # write plugins that will record when they are loaded in the 
+        # tempattribute list.
+        template = ("from bzrlib.tests.test_plugins import TestLoadingPlugins\n"
+                    "TestLoadingPlugins.activeattributes[%r].append('%s')\n")
+        print >> file(os.path.join('first', 'pluginone.py'), 'w'), template % (tempattribute, 'first')
+        print >> file(os.path.join('second', 'plugintwo.py'), 'w'), template % (tempattribute, 'second')
+        oldpath = bzrlib.plugins.__path__
+        try:
+            bzrlib.plugins.__path__ = ['first', 'second']
+            exec "import bzrlib.plugins.pluginone"
+            self.assertEqual(['first'], self.activeattributes[tempattribute])
+            exec "import bzrlib.plugins.plugintwo"
+            self.assertEqual(['first', 'second'],
+                self.activeattributes[tempattribute])
         finally:
             # remove the plugin 'plugin'
             del self.activeattributes[tempattribute]
@@ -130,13 +128,15 @@
         # write a plugin that _cannot_ fail to load.
         print >> file('plugin.py', 'w'), ""
         try:
-            bzrlib.plugin.load_from_dirs(['.'])
+            bzrlib.plugin.load_from_path(['.'])
             self.failUnless('plugin' in bzrlib.plugin.all_plugins())
             self.failUnless(getattr(bzrlib.plugins, 'plugin', None))
             self.assertEqual(bzrlib.plugin.all_plugins()['plugin'],
                              bzrlib.plugins.plugin)
         finally:
             # remove the plugin 'plugin'
+            if 'bzrlib.plugins.plugin' in sys.modules:
+                del sys.modules['bzrlib.plugins.plugin']
             if getattr(bzrlib.plugins, 'plugin', None):
                 del bzrlib.plugins.plugin
         self.failIf(getattr(bzrlib.plugins, 'plugin', None))
@@ -184,7 +184,7 @@
 
         try:
             # Check its help
-            bzrlib.plugin.load_from_dirs(['plugin_test'])
+            bzrlib.plugin.load_from_path(['plugin_test'])
             bzrlib.commands.register_command( bzrlib.plugins.myplug.cmd_myplug)
             help = self.capture('help myplug')
             self.assertContainsRe(help, 'From plugin "myplug"')
@@ -210,7 +210,7 @@
         self.assertFalse(plugin_name in dir(bzrlib.plugins),
                          'Plugin already loaded')
         try:
-            bzrlib.plugin.load_from_zips([zip_name])
+            bzrlib.plugin.load_from_zip(zip_name)
             self.assertTrue(plugin_name in dir(bzrlib.plugins),
                             'Plugin is not loaded')
         finally:
@@ -225,3 +225,16 @@
     def test_load_package(self):
         self.make_zipped_plugin('./test.zip', 'ziplug/__init__.py')
         self.check_plugin_load('./test.zip', 'ziplug')
+
+
+class TestSetPluginsPath(TestCase):
+    
+    def test_set_plugins_path(self):
+        """set_plugins_path should set the module __path__ correctly."""
+        old_path = bzrlib.plugins.__path__
+        try:
+            bzrlib.plugins.__path__ = []
+            expected_path = bzrlib.plugin.set_plugins_path()
+            self.assertEqual(expected_path, bzrlib.plugins.__path__)
+        finally:
+            bzrlib.plugins.__path__ = old_path

=== modified file 'bzrlib/tests/test_repository.py'
--- bzrlib/tests/test_repository.py	2007-02-12 07:14:48 +0000
+++ bzrlib/tests/test_repository.py	2007-02-13 05:22:39 +0000
@@ -49,26 +49,29 @@
 class TestDefaultFormat(TestCase):
 
     def test_get_set_default_format(self):
-        old_format = RepositoryFormat.get_default_format()
-        test_format = SampleRepositoryFormat()
-        RepositoryFormat.register_format(test_format)
+        old_default = bzrdir.format_registry.get('default')
+        private_default = old_default().repository_format.__class__
+        old_format = repository.RepositoryFormat.get_default_format()
+        self.assertTrue(isinstance(old_format, private_default))
+        def make_sample_bzrdir():
+            my_bzrdir = bzrdir.BzrDirMetaFormat1()
+            my_bzrdir.repository_format = SampleRepositoryFormat()
+            return my_bzrdir
+        bzrdir.format_registry.remove('default')
+        bzrdir.format_registry.register('sample', make_sample_bzrdir, '')
+        bzrdir.format_registry.set_default('sample')
+        # creating a repository should now create an instrumented dir.
         try:
-            self.applyDeprecated(symbol_versioning.zero_fourteen, 
-                RepositoryFormat.set_default_format, 
-                test_format)
-            # creating a repository should now create an instrumented dir.
-            try:
-                # the default branch format is used by the meta dir format
-                # which is not the default bzrdir format at this point
-                dir = bzrdir.BzrDirMetaFormat1().initialize('memory:///')
-                result = dir.create_repository()
-                self.assertEqual(result, 'A bzr repository dir')
-            finally:
-                self.applyDeprecated(symbol_versioning.zero_fourteen,
-                    RepositoryFormat.set_default_format, old_format)
+            # the default branch format is used by the meta dir format
+            # which is not the default bzrdir format at this point
+            dir = bzrdir.BzrDirMetaFormat1().initialize('memory:///')
+            result = dir.create_repository()
+            self.assertEqual(result, 'A bzr repository dir')
         finally:
-            RepositoryFormat.unregister_format(test_format)
-        self.assertEqual(old_format, RepositoryFormat.get_default_format())
+            bzrdir.format_registry.remove('default')
+            bzrdir.format_registry.register('default', old_default, '')
+        self.assertIsInstance(repository.RepositoryFormat.get_default_format(),
+                              old_format.__class__)
 
 
 class SampleRepositoryFormat(repository.RepositoryFormat):

=== modified file 'bzrlib/tests/test_selftest.py'
--- bzrlib/tests/test_selftest.py	2007-02-06 06:27:24 +0000
+++ bzrlib/tests/test_selftest.py	2007-02-13 05:22:39 +0000
@@ -853,7 +853,12 @@
         self.assertContainsRe(
             output_stream.getvalue(),
             r"\d+ms/ +\d+ms\n$")
-        
+
+    def test_hooks_sanitised(self):
+        """The bzrlib hooks should be sanitised by setUp."""
+        self.assertEqual(bzrlib.branch.BranchHooks(),
+            bzrlib.branch.Branch.hooks)
+
     def test__gather_lsprof_in_benchmarks(self):
         """When _gather_lsprof_in_benchmarks is on, accumulate profile data.
         

=== modified file 'bzrlib/tests/test_source.py'
--- bzrlib/tests/test_source.py	2006-11-06 21:00:45 +0000
+++ bzrlib/tests/test_source.py	2007-01-18 16:26:15 +0000
@@ -258,6 +258,8 @@
         incorrect = []
 
         for fname, text in self.get_source_file_contents():
+            if '/util/' in fname or '/plugins/' in fname:
+                continue
             if '\t' in text:
                 incorrect.append(fname)
 

=== modified file 'bzrlib/tests/test_transport.py'
--- bzrlib/tests/test_transport.py	2006-11-30 14:55:34 +0000
+++ bzrlib/tests/test_transport.py	2007-02-05 05:19:13 +0000
@@ -39,7 +39,8 @@
                               Transport,
                               )
 from bzrlib.transport.memory import MemoryTransport
-from bzrlib.transport.local import LocalTransport
+from bzrlib.transport.local import (LocalTransport,
+                                    EmulatedWin32LocalTransport)
 
 
 # TODO: Should possibly split transport-specific tests into their own files.
@@ -551,3 +552,18 @@
         t = get_transport(here_url)
         self.assertIsInstance(t, LocalTransport)
         self.assertEquals(t.base, here_url)
+
+
+class TestWin32LocalTransport(TestCase):
+
+    def test_unc_clone_to_root(self):
+        # Win32 UNC path like \\HOST\path
+        # clone to root should stop at least at \\HOST part
+        # not on \\
+        t = EmulatedWin32LocalTransport('file://HOST/path/to/some/dir/')
+        for i in xrange(4):
+            t = t.clone('..')
+        self.assertEquals(t.base, 'file://HOST/')
+        # make sure we reach the root
+        t = t.clone('..')
+        self.assertEquals(t.base, 'file://HOST/')

=== modified file 'bzrlib/tests/test_transport_implementations.py'
--- bzrlib/tests/test_transport_implementations.py	2006-12-01 15:06:29 +0000
+++ bzrlib/tests/test_transport_implementations.py	2007-01-28 21:43:32 +0000
@@ -1030,14 +1030,14 @@
         # directory of this transport
         root_transport = orig_transport
         new_transport = root_transport.clone("..")
-        # as we are walking up directories, the path must be must be 
+        # as we are walking up directories, the path must be
         # growing less, except at the top
         self.assertTrue(len(new_transport.base) < len(root_transport.base)
             or new_transport.base == root_transport.base)
         while new_transport.base != root_transport.base:
             root_transport = new_transport
             new_transport = root_transport.clone("..")
-            # as we are walking up directories, the path must be must be 
+            # as we are walking up directories, the path must be
             # growing less, except at the top
             self.assertTrue(len(new_transport.base) < len(root_transport.base)
                 or new_transport.base == root_transport.base)

=== modified file 'bzrlib/trace.py'
--- bzrlib/trace.py	2006-11-17 05:53:17 +0000
+++ bzrlib/trace.py	2007-01-30 10:51:38 +0000
@@ -137,24 +137,34 @@
         return
 
 
-def open_tracefile(tracefilename='~/.bzr.log'):
+def open_tracefile(tracefilename=None):
     # Messages are always written to here, so that we have some
     # information if something goes wrong.  In a future version this
     # file will be removed on successful completion.
     global _file_handler, _bzr_log_file
     import codecs
 
-    trace_fname = os.path.join(os.path.expanduser(tracefilename))
+    if tracefilename is None:
+        if sys.platform == 'win32':
+            from bzrlib import win32utils
+            home = win32utils.get_home_location()
+        else:
+            home = os.path.expanduser('~')
+        tracefilename = os.path.join(home, '.bzr.log')
+
+    trace_fname = os.path.expanduser(tracefilename)
     _rollover_trace_maybe(trace_fname)
     try:
         LINE_BUFFERED = 1
         #tf = codecs.open(trace_fname, 'at', 'utf8', buffering=LINE_BUFFERED)
         tf = open(trace_fname, 'at', LINE_BUFFERED)
         _bzr_log_file = tf
-        if tf.tell() == 0:
-            tf.write("\nthis is a debug log for diagnosing/reporting problems in bzr\n")
+        # tf.tell() on windows always return 0 until some writing done
+        tf.write('\n')
+        if tf.tell() <= 2:
+            tf.write("this is a debug log for diagnosing/reporting problems in bzr\n")
             tf.write("you can delete or truncate this file, or include sections in\n")
-            tf.write("bug reports to bazaar-ng@lists.canonical.com\n\n")
+            tf.write("bug reports to bazaar@lists.canonical.com\n\n")
         _file_handler = logging.StreamHandler(tf)
         fmt = r'[%(process)5d] %(asctime)s.%(msecs)03d %(levelname)s: %(message)s'
         datefmt = r'%a %H:%M:%S'
@@ -309,4 +319,4 @@
                         sys.platform)
     print >>err_file, 'arguments: %r' % sys.argv
     print >>err_file
-    print >>err_file, "** please send this report to bazaar-ng@lists.ubuntu.com"
+    print >>err_file, "** please send this report to bazaar@lists.ubuntu.com"

=== modified file 'bzrlib/transform.py'
--- bzrlib/transform.py	2006-12-07 04:06:34 +0000
+++ bzrlib/transform.py	2007-02-01 23:48:08 +0000
@@ -273,8 +273,7 @@
                 os.unlink(name)
                 raise
 
-            for segment in contents:
-                f.write(segment)
+            f.writelines(contents)
         finally:
             f.close()
         self._set_mode(trans_id, mode_id, S_ISREG)
@@ -1199,7 +1198,7 @@
 
 
 def revert(working_tree, target_tree, filenames, backups=False, 
-           pb=DummyProgress()):
+           pb=DummyProgress(), change_reporter=None):
     """Revert a working tree's contents to those of a target tree."""
     interesting_ids = find_interesting(working_tree, target_tree, filenames)
     tt = TreeTransform(working_tree, pb)
@@ -1209,7 +1208,7 @@
         child_pb = bzrlib.ui.ui_factory.nested_progress_bar()
         try:
             _alter_files(working_tree, target_tree, tt, child_pb, 
-                         interesting_ids, backups)
+                         interesting_ids, backups, change_reporter)
         finally:
             child_pb.finished()
         pp.next_phase()
@@ -1230,18 +1229,22 @@
     return conflicts
 
 
-def _alter_files(working_tree, target_tree, tt, pb, interesting_ids, backups):
+def _alter_files(working_tree, target_tree, tt, pb, interesting_ids, backups,
+                 report_changes):
+    from bzrlib import delta
     merge_modified = working_tree.merge_modified()
-    iterator = target_tree._iter_changes(working_tree, 
-                                         specific_file_ids=interesting_ids,
-                                         pb=pb)
+    change_list = list(target_tree._iter_changes(working_tree,
+        specific_file_ids=interesting_ids, pb=pb))
     if target_tree.inventory.root is None:
         skip_root = True
     else:
         skip_root = False
     basis_tree = None
+    if report_changes:
+        change_reporter = delta.ChangeReporter(working_tree.inventory)
+        delta.report_changes(change_list, change_reporter)
     for id_num, (file_id, path, changed_content, versioned, parent, name, kind,
-                 executable) in enumerate(iterator):
+                 executable) in enumerate(change_list):
         if skip_root and file_id[0] is not None and parent[0] is None:
             continue
         trans_id = tt.trans_id_file_id(file_id)

=== modified file 'bzrlib/transport/__init__.py'
--- bzrlib/transport/__init__.py	2006-12-15 23:34:42 +0000
+++ bzrlib/transport/__init__.py	2007-01-26 01:23:38 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2005, 2006 Canonical Ltd
+# Copyright (C) 2005, 2006, 2007 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -93,6 +93,8 @@
     intended to be used when the implementation depends on an external
     implementation that may not be present.  If any other error is raised, it
     propagates up and the attempt to open the url fails.
+
+    :param scheme: The url scheme part, eg "ftp://"
     """
     # TODO: If no implementation of a protocol is available because of missing
     # dependencies, we should perhaps show the message about what dependency
@@ -1004,12 +1006,9 @@
 
     base is either a URL or a directory name.  
     """
-    # TODO: give a better error if base looks like a url but there's no
-    # handler for the scheme?
     global _protocol_handlers
     if base is None:
         base = '.'
-
     last_err = None
 
     def convert_path_to_url(base, error_str):

=== modified file 'bzrlib/transport/http/_urllib2_wrappers.py'
--- bzrlib/transport/http/_urllib2_wrappers.py	2006-12-13 15:08:39 +0000
+++ bzrlib/transport/http/_urllib2_wrappers.py	2007-02-08 17:01:20 +0000
@@ -708,14 +708,17 @@
             user_pass, host = host.split('@', 1)
             if ':' in user_pass:
                 user, password = user_pass.split(':', 1)
-                user_pass = '%s:%s' % (urllib.unquote(user),
-                               urllib.unquote(password))
-                user_pass.encode('base64').strip()
-                req.add_header('Proxy-authorization', 'Basic ' + user_pass)
+            else:
+                user = user_pass
+                password = ''
+            user_pass = '%s:%s' % (urllib.unquote(user),
+                                   urllib.unquote(password))
+            user_pass = user_pass.encode('base64').strip()
+            request.add_header('Proxy-authorization', 'Basic ' + user_pass)
         host = urllib.unquote(host)
         request.set_proxy(host, type)
         if self._debuglevel > 0:
-            print 'set_proxy: proxy set to %r://%r' % (type, host)
+            print 'set_proxy: proxy set to %s://%s' % (type, host)
         return request
 
 

=== modified file 'bzrlib/transport/local.py'
--- bzrlib/transport/local.py	2006-12-17 19:11:54 +0000
+++ bzrlib/transport/local.py	2007-02-05 06:17:38 +0000
@@ -75,7 +75,13 @@
         if offset is None:
             return LocalTransport(self.base)
         else:
-            return LocalTransport(self.abspath(offset))
+            abspath = self.abspath(offset)
+            if abspath == 'file://':
+                # fix upwalk for UNC path
+                # when clone from //HOST/path updir recursively
+                # we should stop at least at //HOST part
+                abspath = self.base
+            return LocalTransport(abspath)
 
     def _abspath(self, relative_reference):
         """Return a path for use in os calls.
@@ -474,6 +480,38 @@
             return True
 
 
+class EmulatedWin32LocalTransport(LocalTransport):
+    """Special transport for testing Win32 [UNC] paths on non-windows"""
+
+    def __init__(self, base):
+        if base[-1] != '/':
+            base = base + '/'
+        super(LocalTransport, self).__init__(base)
+        self._local_base = urlutils._win32_local_path_from_url(base)
+
+    def abspath(self, relpath):
+        assert isinstance(relpath, basestring), (type(relpath), relpath)
+        path = osutils.normpath(osutils.pathjoin(
+                    self._local_base, urlutils.unescape(relpath)))
+        return urlutils._win32_local_path_to_url(path)
+
+    def clone(self, offset=None):
+        """Return a new LocalTransport with root at self.base + offset
+        Because the local filesystem does not require a connection, 
+        we can just return a new object.
+        """
+        if offset is None:
+            return EmulatedWin32LocalTransport(self.base)
+        else:
+            abspath = self.abspath(offset)
+            if abspath == 'file://':
+                # fix upwalk for UNC path
+                # when clone from //HOST/path updir recursively
+                # we should stop at least at //HOST part
+                abspath = self.base
+            return EmulatedWin32LocalTransport(abspath)
+
+
 class LocalURLServer(Server):
     """A pretend server for local transports, using file:// urls.
     

=== modified file 'bzrlib/tree.py'
--- bzrlib/tree.py	2007-01-11 15:57:49 +0000
+++ bzrlib/tree.py	2007-02-05 15:27:54 +0000
@@ -347,7 +347,8 @@
     All matches in all trees will be used, and all children of matched
     directories will be used.
 
-    :param filenames: The filenames to find file_ids for
+    :param filenames: The filenames to find file_ids for (if None, returns
+        None)
     :param trees: The trees to find file_ids within
     :param require_versioned: if true, all specified filenames must occur in
     at least one tree.

=== modified file 'bzrlib/uncommit.py'
--- bzrlib/uncommit.py	2006-09-05 09:49:40 +0000
+++ bzrlib/uncommit.py	2007-02-06 02:33:42 +0000
@@ -14,11 +14,13 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
-"""Remove the last revision from the history of the current branch.
-"""
+"""Remove the last revision from the history of the current branch."""
+
+# TODO: make the guts of this methods on tree, branch.
 
 import os
 
+from bzrlib.branch import Branch
 from bzrlib.errors import BoundBranchOutOfDate
 
 
@@ -51,10 +53,14 @@
             raise BoundBranchOutOfDate(branch, master)
         if revno is None:
             revno = len(rh)
+        old_revno, old_tip = branch.last_revision_info()
+        new_revno = revno -1
 
         files_to_remove = []
         for r in range(revno-1, len(rh)):
             rev_id = rh.pop()
+            # NB: performance would be better using the revision graph rather
+            # than the whole revision.
             rev = branch.repository.get_revision(rev_id)
             # When we finish popping off the pending merges, we want
             # them to stay in the order that they used to be.
@@ -70,10 +76,19 @@
             if master is not None:
                 master.set_revision_history(rh)
             branch.set_revision_history(rh)
+            new_tip = branch.last_revision()
+            if master is None:
+                hook_local = None
+                hook_master = branch
+            else:
+                hook_local = branch
+                hook_master = master
+            for hook in Branch.hooks['post_uncommit']:
+                hook(hook_local, hook_master, old_revno, old_tip, new_revno,
+                    new_tip)
             if tree is not None:
-                branch_tip = branch.last_revision()
-                if branch_tip is not None:
-                    parents = [branch.last_revision()]
+                if new_tip is not None:
+                    parents = [new_tip]
                 else:
                     parents = []
                 parents.extend(reversed(pending_merges))

=== modified file 'bzrlib/urlutils.py'
--- bzrlib/urlutils.py	2006-12-08 10:01:38 +0000
+++ bzrlib/urlutils.py	2007-01-28 21:43:32 +0000
@@ -405,7 +405,7 @@
     if not url.endswith('/'):
         # Nothing to do
         return url
-    if sys.platform == 'win32' and url.startswith('file:///'):
+    if sys.platform == 'win32' and url.startswith('file://'):
         return _win32_strip_local_trailing_slash(url)
 
     scheme_loc, first_path_slash = _find_scheme_and_separator(url)

=== modified file 'bzrlib/version.py'
--- bzrlib/version.py	2006-10-11 23:08:27 +0000
+++ bzrlib/version.py	2007-01-18 23:20:16 +0000
@@ -63,5 +63,6 @@
     try:
         from bzrlib.workingtree import WorkingTree
         return WorkingTree.open_containing(__file__)[0]
-    except (errors.NotBranchError, errors.UnknownFormatError):
+    except (errors.NotBranchError, errors.UnknownFormatError,
+            errors.NoWorkingTree):
         return None

=== renamed file 'bzrlib/win32console.py' => 'bzrlib/win32utils.py'
--- bzrlib/win32console.py	2006-10-05 05:37:25 +0000
+++ bzrlib/win32utils.py	2007-02-03 15:02:06 +0000
@@ -1,4 +1,4 @@
-# Copyright (C) 2006 Canonical Ltd
+# Copyright (C) 2006, 2007 Canonical Ltd
 #
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -14,52 +14,227 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
-
-"""
-Set of functions to work with console on Windows.
-Author: Alexander Belchenko (e-mail: bialix AT ukr.net)
-License: Public domain
-"""
-
+"""Win32-specific helper functions
+
+Only one dependency: ctypes should be installed.
+"""
+
+import os
 import struct
+import sys
+
+
+# Windows version
+if sys.platform == 'win32':
+    _major,_minor,_build,_platform,_text = sys.getwindowsversion()
+    # from MSDN:
+    # dwPlatformId
+    #   The operating system platform.
+    #   This member can be one of the following values.
+    #   ==========================  ======================================
+    #   Value                       Meaning
+    #   --------------------------  --------------------------------------
+    #   VER_PLATFORM_WIN32_NT       The operating system is Windows Vista,
+    #   2                           Windows Server "Longhorn",
+    #                               Windows Server 2003, Windows XP,
+    #                               Windows 2000, or Windows NT.
+    #
+    #   VER_PLATFORM_WIN32_WINDOWS  The operating system is Windows Me,
+    #   1                           Windows 98, or Windows 95.
+    #   ==========================  ======================================
+    if _platform == 2:
+        winver = 'Windows NT'
+    else:
+        # don't care about real Windows name, just to force safe operations
+        winver = 'Windows 98'
+else:
+    winver = None
+
 
 # We can cope without it; use a separate variable to help pyflakes
 try:
-   import ctypes
-   has_ctypes = True
+    import ctypes
+    has_ctypes = True
 except ImportError:
     has_ctypes = False
-
-
+else:
+    if winver == 'Windows 98':
+        create_buffer = ctypes.create_string_buffer
+        suffix = 'A'
+    else:
+        create_buffer = ctypes.create_unicode_buffer
+        suffix = 'W'
+
+
+# Special Win32 API constants
+# Handles of std streams
 WIN32_STDIN_HANDLE = -10
 WIN32_STDOUT_HANDLE = -11
 WIN32_STDERR_HANDLE = -12
 
+# CSIDL constants (from MSDN 2003)
+CSIDL_APPDATA = 0x001A      # Application Data folder
+CSIDL_PERSONAL = 0x0005     # My Documents folder
+
+# from winapi C headers
+MAX_PATH = 260
+UNLEN = 256
+MAX_COMPUTERNAME_LENGTH = 31
+
 
 def get_console_size(defaultx=80, defaulty=25):
-   """ Return size of current console.
-
-   This function try to determine actual size of current working
-   console window and return tuple (sizex, sizey) if success,
-   or default size (defaultx, defaulty) otherwise.
-
-   Dependencies: ctypes should be installed.
-   """
-   if not has_ctypes:
-       # no ctypes is found
-       return (defaultx, defaulty)
-
-   # To avoid problem with redirecting output via pipe
-   # need to use stderr instead of stdout
-   h = ctypes.windll.kernel32.GetStdHandle(WIN32_STDERR_HANDLE)
-   csbi = ctypes.create_string_buffer(22)
-   res = ctypes.windll.kernel32.GetConsoleScreenBufferInfo(h, csbi)
-
-   if res:
-       (bufx, bufy, curx, cury, wattr,
+    """Return size of current console.
+
+    This function try to determine actual size of current working
+    console window and return tuple (sizex, sizey) if success,
+    or default size (defaultx, defaulty) otherwise.
+    """
+    if not has_ctypes:
+        # no ctypes is found
+        return (defaultx, defaulty)
+
+    # To avoid problem with redirecting output via pipe
+    # need to use stderr instead of stdout
+    h = ctypes.windll.kernel32.GetStdHandle(WIN32_STDERR_HANDLE)
+    csbi = ctypes.create_string_buffer(22)
+    res = ctypes.windll.kernel32.GetConsoleScreenBufferInfo(h, csbi)
+
+    if res:
+        (bufx, bufy, curx, cury, wattr,
         left, top, right, bottom, maxx, maxy) = struct.unpack("hhhhHhhhhhh", csbi.raw)
-       sizex = right - left + 1
-       sizey = bottom - top + 1
-       return (sizex, sizey)
-   else:
-       return (defaultx, defaulty)
+        sizex = right - left + 1
+        sizey = bottom - top + 1
+        return (sizex, sizey)
+    else:
+        return (defaultx, defaulty)
+
+
+def get_appdata_location():
+    """Return Application Data location.
+    Return None if we cannot obtain location.
+
+    Returned value can be unicode or plain sring.
+    To convert plain string to unicode use
+    s.decode(bzrlib.user_encoding)
+    """
+    if has_ctypes:
+        try:
+            SHGetSpecialFolderPath = \
+                ctypes.windll.shell32.SHGetSpecialFolderPathW
+        except AttributeError:
+            pass
+        else:
+            buf = ctypes.create_unicode_buffer(MAX_PATH)
+            if SHGetSpecialFolderPath(None,buf,CSIDL_APPDATA,0):
+                return buf.value
+    # from env variable
+    appdata = os.environ.get('APPDATA')
+    if appdata:
+        return appdata
+    # if we fall to this point we on win98
+    # at least try C:/WINDOWS/Application Data
+    windir = os.environ.get('windir')
+    if windir:
+        appdata = os.path.join(windir, 'Application Data')
+        if os.path.isdir(appdata):
+            return appdata
+    # did not find anything
+    return None
+
+
+def get_home_location():
+    """Return user's home location.
+    Assume on win32 it's the <My Documents> folder.
+    If location cannot be obtained return system drive root,
+    i.e. C:\
+
+    Returned value can be unicode or plain sring.
+    To convert plain string to unicode use
+    s.decode(bzrlib.user_encoding)
+    """
+    if has_ctypes:
+        try:
+            SHGetSpecialFolderPath = \
+                ctypes.windll.shell32.SHGetSpecialFolderPathW
+        except AttributeError:
+            pass
+        else:
+            buf = ctypes.create_unicode_buffer(MAX_PATH)
+            if SHGetSpecialFolderPath(None,buf,CSIDL_PERSONAL,0):
+                return buf.value
+    # try for HOME env variable
+    home = os.path.expanduser('~')
+    if home != '~':
+        return home
+    # at least return windows root directory
+    windir = os.environ.get('windir')
+    if windir:
+        return os.path.splitdrive(windir) + '/'
+    # otherwise C:\ is good enough for 98% users
+    return 'C:/'
+
+
+def get_user_name():
+    """Return user name as login name.
+    If name cannot be obtained return None.
+
+    Returned value can be unicode or plain sring.
+    To convert plain string to unicode use
+    s.decode(bzrlib.user_encoding)
+    """
+    if has_ctypes:
+        try:
+            advapi32 = ctypes.windll.advapi32
+            GetUserName = getattr(advapi32, 'GetUserName'+suffix)
+        except AttributeError:
+            pass
+        else:
+            buf = create_buffer(UNLEN+1)
+            n = ctypes.c_int(UNLEN+1)
+            if GetUserName(buf, ctypes.byref(n)):
+                return buf.value
+    # otherwise try env variables
+    return os.environ.get('USERNAME', None)
+
+
+def get_host_name():
+    """Return host machine name.
+    If name cannot be obtained return None.
+
+    Returned value can be unicode or plain sring.
+    To convert plain string to unicode use
+    s.decode(bzrlib.user_encoding)
+    """
+    if has_ctypes:
+        try:
+            kernel32 = ctypes.windll.kernel32
+            GetComputerName = getattr(kernel32, 'GetComputerName'+suffix)
+        except AttributeError:
+            pass
+        else:
+            buf = create_buffer(MAX_COMPUTERNAME_LENGTH+1)
+            n = ctypes.c_int(MAX_COMPUTERNAME_LENGTH+1)
+            if GetComputerName(buf, ctypes.byref(n)):
+                return buf.value
+    # otherwise try env variables
+    return os.environ.get('COMPUTERNAME', None)
+
+
+def _ensure_unicode(s):
+    if s and type(s) != unicode:
+        import bzrlib
+        s = s.decode(bzrlib.user_encoding)
+    return s
+    
+
+def get_appdata_location_unicode():
+    return _ensure_unicode(get_appdata_location())
+
+def get_home_location_unicode():
+    return _ensure_unicode(get_home_location())
+
+def get_user_name_unicode():
+    return _ensure_unicode(get_user_name())
+
+def get_host_name_unicode():
+    return _ensure_unicode(get_host_name())

=== modified file 'bzrlib/workingtree.py'
--- bzrlib/workingtree.py	2007-01-20 01:44:46 +0000
+++ bzrlib/workingtree.py	2007-02-04 12:49:55 +0000
@@ -1321,16 +1321,12 @@
         try:
             pp = ProgressPhase("Pull phase", 2, top_pb)
             pp.next_phase()
-            old_revision_history = self.branch.revision_history()
+            old_revision_info = self.branch.last_revision_info()
             basis_tree = self.basis_tree()
             count = self.branch.pull(source, overwrite, stop_revision)
-            new_revision_history = self.branch.revision_history()
-            if new_revision_history != old_revision_history:
+            new_revision_info = self.branch.last_revision_info()
+            if new_revision_info != old_revision_info:
                 pp.next_phase()
-                if len(old_revision_history):
-                    other_revision = old_revision_history[-1]
-                else:
-                    other_revision = None
                 repository = self.branch.repository
                 pb = bzrlib.ui.ui_factory.nested_progress_bar()
                 try:
@@ -1641,28 +1637,28 @@
         for f in files:
             fid = inv.path2id(f)
             if not fid:
-                # TODO: Perhaps make this just a warning, and continue?
-                # This tends to happen when 
-                raise errors.NotVersionedError(path=f)
-            if verbose:
-                # having remove it, it must be either ignored or unknown
-                if self.is_ignored(f):
-                    new_status = 'I'
-                else:
-                    new_status = '?'
-                textui.show_status(new_status, inv[fid].kind, f,
-                                   to_file=to_file)
-            del inv[fid]
+                note("%s is not versioned."%f)
+            else:
+                if verbose:
+                    # having remove it, it must be either ignored or unknown
+                    if self.is_ignored(f):
+                        new_status = 'I'
+                    else:
+                        new_status = '?'
+                    textui.show_status(new_status, inv[fid].kind, f,
+                                       to_file=to_file)
+                del inv[fid]
 
         self._write_inventory(inv)
 
     @needs_tree_write_lock
     def revert(self, filenames, old_tree=None, backups=True, 
-               pb=DummyProgress()):
+               pb=DummyProgress(), report_changes=False):
         from bzrlib.conflicts import resolve
         if old_tree is None:
             old_tree = self.basis_tree()
-        conflicts = transform.revert(self, old_tree, filenames, backups, pb)
+        conflicts = transform.revert(self, old_tree, filenames, backups, pb,
+                                     report_changes)
         if not len(filenames):
             self.set_parent_ids(self.get_parent_ids()[:1])
             resolve(self)

=== modified file 'setup.py'
--- setup.py	2007-01-15 03:31:34 +0000
+++ setup.py	2007-01-30 12:13:18 +0000
@@ -17,7 +17,7 @@
 META_INFO = {'name':         'bzr',
              'version':      bzrlib.__version__,
              'author':       'Canonical Ltd',
-             'author_email': 'bazaar-ng@lists.ubuntu.com',
+             'author_email': 'bazaar@lists.canonical.com',
              'url':          'http://www.bazaar-vcs.org/',
              'description':  'Friendly distributed version control system',
              'license':      'GNU GPL v2',
@@ -99,9 +99,6 @@
     Create bzr.bat for win32.
     """
     def run(self):
-        import os
-        import sys
-
         install_scripts.run(self)   # standard action
 
         if sys.platform == "win32":
@@ -127,7 +124,8 @@
             return path
 
     def _win_batch_args(self):
-        if os.name == 'nt':
+        from bzrlib.win32utils import winver
+        if winver == 'Windows NT':
             return '%*'
         else:
             return '%1 %2 %3 %4 %5 %6 %7 %8 %9'
@@ -197,6 +195,12 @@
     if sys.version.startswith('2.4'):
         # adding elementtree package
         additional_packages.append('elementtree')
+    elif sys.version.startswith('2.5'):
+        additional_packages.append('xml.etree')
+    else:
+        import warnings
+        warnings.warn('Unknown Python version.\n'
+                      'Please check setup.py script for compatibility.')
 
     options_list = {"py2exe": {"packages": BZRLIB['packages'] +
                                            additional_packages,

=== modified file 'tools/win32/bzr-win32-bdist-postinstall.py'
--- tools/win32/bzr-win32-bdist-postinstall.py	2006-12-14 17:46:44 +0000
+++ tools/win32/bzr-win32-bdist-postinstall.py	2007-01-30 12:45:50 +0000
@@ -16,11 +16,14 @@
 # [bialix]: bzr de-facto does not support win98.
 #           Although it seems to work on. Sometimes.
 # 2006/07/30    added minimal support of win98.
+# 2007/01/30    added *real* support of win98.
 
 import os
 import sys
 import _winreg
 
+from bzrlib import win32utils
+
 
 def _quoted_path(path):
     if ' ' in path:
@@ -29,7 +32,7 @@
         return path
 
 def _win_batch_args():
-    if os.name == 'nt':
+    if win32utils.winver == 'Windows NT':
         return '%*'
     else:
         return '%1 %2 %3 %4 %5 %6 %7 %8 %9'
@@ -62,24 +65,16 @@
         python_path = _quoted_path(os.path.join(prefix, "python.exe"))
         args = _win_batch_args()
         batch_str = "@%s %s %s" % (python_path, script_path, args)
-        # minimal support of win98
-        # if there is no HOME in system then set it for Bazaar manually
-        homes = ('BZR_HOME', 'APPDATA', 'HOME')
-        for home in homes:
-            bzr_home = os.environ.get(home, None)
-            if bzr_home is not None:
-                break
-        else:
-            try:
-                bzr_home = get_special_folder('CSIDL_APPDATA')
-            except OSError:
-                # no Application Data
-                bzr_home = ''
-
-            if not bzr_home:
-                bzr_home = os.path.splitdrive(sys.prefix)[0] + '\\'
-
-            batch_str = ("@SET BZR_HOME=" + _quoted_path(bzr_home) + "\n" +
+        # support of win98
+        # if there is no HOME for bzr then set it for Bazaar manually
+        base = os.environ.get('BZR_HOME', None)
+        if base is None:
+            base = win32utils.get_appdata_location()
+        if base is None:
+            base = os.environ.get('HOME', None)
+        if base is None:
+            base = os.path.splitdrive(sys.prefix)[0] + '\\'
+            batch_str = ("@SET BZR_HOME=" + _quoted_path(base) + "\n" +
                          batch_str)
 
         batch_path = os.path.join(scripts_dir, "bzr.bat")
@@ -95,20 +90,6 @@
     except Exception, e:
         print "ERROR: Unable to create %s: %s" % (batch_path, e)
 
-    # make entry in bzr home directory
-    dst = os.path.join(bzr_home, "bazaar", "2.0")
-    if not os.path.isdir(dst):
-        os.makedirs(dst)
-        import locale
-        print "Configuration files stored in %s" % \
-              dst.encode(locale.getpreferredencoding(), 'replace')
-        # create dummy bazaar.conf
-        f = file(os.path.join(dst,'bazaar.conf'), 'w')
-        f.write("# main configuration file of Bazaar\n"
-                "[DEFAULT]\n"
-                "#email=Your Name <you@domain.com>\n")
-        f.close()
-
     ## this hunk borrowed from pywin32_postinstall.py
     # use bdist_wininst builtins to create a shortcut.
     # CSIDL_COMMON_PROGRAMS only available works on NT/2000/XP, and

=== modified file 'tools/win32/bzr.iss.cog'
--- tools/win32/bzr.iss.cog	2007-01-13 20:00:38 +0000
+++ tools/win32/bzr.iss.cog	2007-02-01 13:32:16 +0000
@@ -44,7 +44,7 @@
 InfoBeforeFile="..\tools\win32\info.txt"
 
 VersionInfoCompany="Canonical Ltd."
-VersionInfoCopyright="Canonical Ltd., 2005-2006"
+VersionInfoCopyright="Canonical Ltd., 2005-2007"
 VersionInfoDescription="Installer for stand-alone bzr.exe"
 ; [[[cog
 ; import bzrlib
@@ -90,7 +90,7 @@
 [Icons]
 Name: "{group}\Documentation index"; Filename: "{app}\doc\index.htm"; WorkingDir: "{app}\doc";
 Name: "{group}\Bazaar Home Page"; Filename: "{app}\bazaar.url"; Comment: "http://www.bazaar-vcs.org";
-Name: "{group}\Start Bzr in cmd shell"; Filename: "{sys}\cmd.exe"; Parameters: "/K start_bzr.bat"; WorkingDir: "{app}"; IconFilename: "{app}\bzr.exe"; Comment: "Open new Bzr session";
+Name: "{group}\Start Bzr in cmd shell"; Filename: "{cmd}"; Parameters: "/K start_bzr.bat"; WorkingDir: "{app}"; IconFilename: "{app}\bzr.exe"; Comment: "Open new Bzr session";
 Name: "{group}\Uninstall Bzr"; Filename: "{uninstallexe}"; IconFileName: "{sys}\shell32.dll"; IconIndex: 101; Comment: "Remove Bzr completely";
 
 [Tasks]

=== modified file 'tools/win32/bzr_postinstall.py'
--- tools/win32/bzr_postinstall.py	2006-06-29 08:41:31 +0000
+++ tools/win32/bzr_postinstall.py	2007-02-03 15:02:06 +0000
@@ -16,16 +16,19 @@
 
 """bzr postinstall helper for win32 installation
 Written by Alexander Belchenko
+
+Dependency: ctypes
 """
 
 import os
+import shutil
 import sys
 
 
 ##
 # CONSTANTS
 
-VERSION = "1.3.20060513"
+VERSION = "1.5.20070131"
 
 USAGE = """Bzr postinstall helper for win32 installation
 Usage: %s [options]
@@ -45,6 +48,30 @@
     --check-mfc71               - check if MFC71.DLL present in system
 """ % os.path.basename(sys.argv[0])
 
+# Windows version
+_major,_minor,_build,_platform,_text = sys.getwindowsversion()
+# from MSDN:
+# dwPlatformId
+#   The operating system platform.
+#   This member can be one of the following values.
+#   ==========================  ======================================
+#   Value                       Meaning
+#   --------------------------  --------------------------------------
+#   VER_PLATFORM_WIN32_NT       The operating system is Windows Vista,
+#   2                           Windows Server "Longhorn",
+#                               Windows Server 2003, Windows XP,
+#                               Windows 2000, or Windows NT.
+#
+#   VER_PLATFORM_WIN32_WINDOWS  The operating system is Windows Me,
+#   1                           Windows 98, or Windows 95.
+#   ==========================  ======================================
+if _platform == 2:
+    winver = 'Windows NT'
+else:
+    # don't care about real Windows name, just to force safe operations
+    winver = 'Windows 98'
+
+
 ##
 # INTERNAL VARIABLES
 
@@ -53,6 +80,7 @@
 
 
 def main():
+    import ctypes
     import getopt
     import re
     import _winreg
@@ -126,7 +154,7 @@
     MB_ICONERROR = 16
     MB_ICONEXCLAMATION = 48
 
-    bzr_dir = os.path.dirname(sys.argv[0])
+    bzr_dir = os.path.dirname(os.path.abspath(sys.argv[0]))
 
     if start_bzr:
         fname = os.path.join(bzr_dir, "start_bzr.bat")
@@ -155,7 +183,7 @@
             f.write(''.join(content))
             f.close()
 
-    if add_path or delete_path:
+    if (add_path or delete_path) and winver == 'Windows NT':
         # find appropriate registry key:
         # 1. HKLM\System\CurrentControlSet\Control\SessionManager\Environment
         # 2. HKCU\Environment
@@ -213,6 +241,60 @@
         if not hkey is None:
             _winreg.CloseKey(hkey)
 
+    if (add_path or delete_path) and winver == 'Windows 98':
+        # mutating autoexec.bat
+        # adding or delete string:
+        # SET PATH=%PATH%;C:\PROGRA~1\Bazaar
+        abat = 'C:\\autoexec.bat'
+        abak = 'C:\\autoexec.bak'
+
+        def backup_autoexec_bat(name, backupname, dry_run):
+            # backup autoexec.bat
+            if os.path.isfile(name):
+                if not dry_run:
+                    shutil.copyfile(name, backupname)
+                else:
+                    print '*** backup copy of autoexec.bat created'
+
+        GetShortPathName = ctypes.windll.kernel32.GetShortPathNameA
+        buf = ctypes.create_string_buffer(260)
+        if GetShortPathName(bzr_dir, buf, 260):
+            bzr_dir_8_3 = buf.value
+        else:
+            bzr_dir_8_3 = bzr_dir
+        pattern = 'SET PATH=%PATH%;' + bzr_dir_8_3
+
+        # search pattern
+        f = file(abat, 'r')
+        lines = f.readlines()
+        f.close()
+        found = False
+        for i in lines:
+            if i.rstrip('\r\n') == pattern:
+                found = True
+                break
+
+        if delete_path and found:
+            backup_autoexec_bat(abat, abak, dry_run)
+            if not dry_run:
+                f = file(abat, 'w')
+                for i in lines:
+                    if i.rstrip('\r\n') != pattern:
+                        f.write(i)
+                f.close()
+            else:
+                print '*** Remove line <%s> from autoexec.bat' % pattern
+                    
+        elif add_path and not found:
+            backup_autoexec_bat(abat, abak, dry_run)
+            if not dry_run:
+                f = file(abat, 'a')
+                f.write(pattern)
+                f.write('\n')
+                f.close()
+            else:
+                print '*** Add line <%s> to autoexec.bat' % pattern
+
     if add_shell_menu and not delete_shell_menu:
         hkey = None
         try:
@@ -229,8 +311,9 @@
             _winreg.SetValue(hkey, '', _winreg.REG_SZ, 'Bzr Here')
             hkey2 = _winreg.CreateKey(hkey, 'command')
             _winreg.SetValue(hkey2, '', _winreg.REG_SZ,
-                             'cmd /K "%s"' % os.path.join(bzr_dir,
-                                                          'start_bzr.bat'))
+                             '%s /K "%s"' % (
+                                    os.environ.get('COMSPEC', '%COMSPEC%'),
+                                    os.path.join(bzr_dir, 'start_bzr.bat')))
             _winreg.CloseKey(hkey2)
             _winreg.CloseKey(hkey)
 

=== modified file 'tools/win32/start_bzr.bat'
--- tools/win32/start_bzr.bat	2006-07-30 06:52:39 +0000
+++ tools/win32/start_bzr.bat	2007-01-30 23:05:35 +0000
@@ -27,5 +27,5 @@
 
 REM --------------------------------------------------------------------------
 
-bzr.exe help
 @ECHO ON
+@bzr.exe help
\ No newline at end of file

